#!/usr/bin/env python
#!/bin/bash
#-*-coding:utf8-*-
#############################################################################
# License                                                                       
#    This file is part of RESOS(RESistance Open Source CFD package).                                            
#
#    RESOS is free software; you can redistribute it and/or modify it
#    under the terms of the GNU General Public License as published by the
#    Free Software Foundation; either version 3 of the License, or (at your
#    option) any later version.
#
#    RESOS is distributed in the hope that it will be useful, but WITHOUT
#    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#    for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with RESOS.  If not, see <http://www.gnu.org/licenses/>.
#
# Description
#    - Class for start the launcher
#
# Author
#    NEXTFOAM Inc. All rights reserved.
##############################################################################

import pygtk;pygtk.require('2.0');import gtk
import sys,os

FOAM_USER_APPBIN = os.environ['FOAM_USER_APPBIN']
installpath=FOAM_USER_APPBIN + '/RESOS-GUI-v1.0.2'
       
sys.path.append(installpath+'/common')
sys.path.append(installpath+'/detailSetup')
sys.path.append(installpath+'/resistance')

from resistanceMain import *

class startWindow:

    def delete_event(self,widget,event,data=None):
        self.window.destroy()
        gtk.main_quit()

    def destroy(self,widget):
        self.window.destroy();gtk.main_quit()

    def __init__(self):

        FOAM_USER_APPBIN = os.environ['FOAM_USER_APPBIN']
        installpath=FOAM_USER_APPBIN + '/RESOS-GUI-v1.0.2'

        self.caseDir='none';GEN=generalClass(self.caseDir)
  
        def start(widget):
            aa=modeCombo.child;option=aa.get_text()
            if newradio.get_active()==1:start='New Project'
            else:start='Open Project'
            
            if option=='Resistance':
                if start=='New Project':
                    self.caseDir=GEN.newcase()
                    if self.caseDir!='None':
                        self.window.destroy()
                        MAIN=resistanceMainWindow(self.caseDir,installpath);MAIN.resistanceMainGUI()
                elif start=='Open Project':
                    self.caseDir=GEN.readcase()
                    if self.caseDir!='None':
                        bb=glob.glob(self.caseDir+'/system/settings/openSubWindow')
                        for ii in bb:os.system('rm '+ii)
                        self.window.destroy() 
                        MAIN=resistanceMainWindow(self.caseDir,installpath);MAIN.resistanceMainGUI()
            
        self.window=gtk.Window(gtk.WINDOW_TOPLEVEL);self.window.set_title('Ship hydrodynamics - OpenFOAM-2.3.x GUI')
        self.window.set_border_width(5);self.window.set_position(gtk.WIN_POS_CENTER)
        self.window.connect("delete_event", self.delete_event)
        mainbox=gtk.VBox(False,0);self.window.add(mainbox)

        logo = gtk.Image();logo.set_from_file(installpath+"/pic/launcher_logo.png")	       
        logoframe=gtk.Frame();logoframe.set_shadow_type(gtk.SHADOW_IN)
        mainbox.add(logoframe);logoframe.add(logo)

        frame=gtk.Frame();frame.set_shadow_type(gtk.SHADOW_IN);mainbox.pack_start(frame,False,False,5)
        selbox=gtk.VBox(False,5);frame.add(selbox)

        selectbox=gtk.HBox(False,5);selbox.pack_start(selectbox,False,False,10)
        label=gtk.Label('Simulation')
        modeCombo=gtk.combo_box_entry_new_text();modeCombo.set_size_request(210,28)
        solverList=['Resistance']
        for vv in solverList:modeCombo.append_text(vv)
        modeCombo.set_active(0)
        selectbox.pack_start(label,False,False,25);selectbox.pack_end(modeCombo,False,False,5)

        startbox=gtk.HBox(False,5);selbox.pack_start(startbox,False,False,10)
        newradio=gtk.RadioButton(None,'New Project')
        openradio=gtk.RadioButton(newradio,'Open Project')
        startbox.pack_start(newradio,False,False,15);startbox.pack_start(openradio,False,False,45)        

        buttonbox=gtk.HBox(False,5);mainbox.pack_start(buttonbox,False,False,10)
        startB=gtk.Button(label='Start');startB.connect('clicked',start)
        cancelB=gtk.Button(label='Cancel');cancelB.connect('clicked',self.destroy)
        startB.set_size_request(150,30);cancelB.set_size_request(150,30)
        buttonbox.pack_end(cancelB,False,False,5);buttonbox.pack_end(startB,False,False,5)
        #-----------------------------------------------------------------------------------------

        self.window.show_all()

    def main(self):
        gtk.main()

if __name__=='__main__':
    win=startWindow()
    win.main()

