#-*-coding:utf8-*-
#############################################################################
# License                                                                       
#    This file is part of RESOS(RESistance Open Source CFD package).                                            
#
#    RESOS is free software; you can redistribute it and/or modify it
#    under the terms of the GNU General Public License as published by the
#    Free Software Foundation; either version 3 of the License, or (at your
#    option) any later version.
#
#    RESOS is distributed in the hope that it will be useful, but WITHOUT
#    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#    for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with RESOS.  If not, see <http://www.gnu.org/licenses/>.
#
# Description
#    - Class for boundary condition setup
#
# Author
#    NEXTFOAM Inc. All rights reserved.
##############################################################################

import os,math,glob,sys;import pygtk;pygtk.require('2.0');import gtk

from generalSub import *
from VTKStuffClass import *

class boundaryConditionClass:

    def delete_event(self,widget,event,data=None):
        aa=glob.glob(self.caseDir+'/system/settings/openSubWindow')
        for ii in aa:os.system('rm '+ii)
        window.destroy()
        

    def destroy(self,widget,data=None):
        self.covWin.destroy()

    def __init__(self,caseDir,installpath):
        self.caseDir=caseDir
        self.installpath=installpath
    #-----------------------------------------------------------------------------------------------------------------
    def openBCWindow(self,patchname,patchtype,gvtk,mainwindow,notebook,textbuffer,liststore_patchname):
    
        GEN=generalClass(self.caseDir)        

        aa=glob.glob(self.caseDir+'/system/settings/generalConditions')
        if len(aa)==0:
            GEN.makeDialog('Error!!! Sim. conditions is not set.')
            return
        else:
            genDict=GEN.makeDictFromFile(aa[0])
            self.speed=genDict['speed']
            self.inletk=genDict['inletk']
            self.inlete=genDict['inlete']
            
        def closethis(widget,data=None):
            window.destroy()
            os.system('rm '+self.caseDir+'/system/settings/openSubWindow')

        def applythis(widget,data=None):
        
            oldname=patchname
            newname=bcnameEntry.get_text()
            
            bdict={}
            bdict['name']=patchname;bdict['type']=patchtype
            aa=utypeCombo.child;bdict['Utype']=aa.get_text()
            bdict['Ux']=uxEntry.get_text()
            bdict['Uy']=uyEntry.get_text()
            bdict['Uz']=uzEntry.get_text()
            bdict['Umag']=umagEntry.get_text()

            aa=ptypeCombo.child;bdict['ptype']=aa.get_text()            
            bdict['pstatic']=pstaticEntry.get_text()

            aa=alphatypeCombo.child;bdict['alphatype']=aa.get_text()           
            bdict['alphavalue']=alphavalueEntry.get_text()

            aa=ktypeCombo.child;bdict['ktype']=aa.get_text()                
            bdict['kvalue']=kvalueEntry.get_text()                
            bdict['kinout']=kinoutEntry.get_text()                
            bdict['kintensity']=kintensityEntry.get_text()                               
            if turmodel=='kOmegaSST' or turmodel=='kOmega':
                aa=otypeCombo.child;bdict['otype']=aa.get_text()
                bdict['ovalue']=ovalueEntry.get_text()                    
                bdict['oinout']=oinoutEntry.get_text()                     
            else:
                aa=etypeCombo.child;bdict['etype']=aa.get_text()
                bdict['evalue']=evalueEntry.get_text()                    
                bdict['einout']=einoutEntry.get_text()                    
                bdict['elength']=elengthEntry.get_text()                                

            if GEN.isNumber(bdict['Ux'])==False:GEN.makeDialog('Error!!! Ux is not number')             
            if GEN.isNumber(bdict['Uy'])==False:GEN.makeDialog('Error!!! Uy is not number')                         
            if GEN.isNumber(bdict['Uz'])==False:GEN.makeDialog('Error!!! Uz is not number')             
            if GEN.isNumber(bdict['Umag'])==False:GEN.makeDialog('Error!!! Umag is not number')                         
            if GEN.isNumber(bdict['pstatic'])==False:GEN.makeDialog('Error!!! pstatic is not number')             
            if GEN.isNumber(bdict['alphavalue'])==False:GEN.makeDialog('Error!!! Tvalue is not number')
            if GEN.isNumber(bdict['kvalue'])==False:GEN.makeDialog('Error!!! k is not number') 
            if GEN.isNumber(bdict['kinout'])==False:GEN.makeDialog('Error!!! inlet k is not number')
            if GEN.isNumber(bdict['kintensity'])==False:GEN.makeDialog('Error!!! tur. intensity is not number')
            if turmodel=='kOmegaSST' or turmodel=='kOmega':
                if GEN.isNumber(bdict['ovalue'])==False:GEN.makeDialog('Error!!! omega is not number')
                if GEN.isNumber(bdict['oinout'])==False:GEN.makeDialog('Error!!! inlet omega is not number')
            else:
                if GEN.isNumber(bdict['evalue'])==False:GEN.makeDialog('Error!!! epsilon is not number')
                if GEN.isNumber(bdict['einout'])==False:GEN.makeDialog('Error!!! inlet epsilon is not number')
                if GEN.isNumber(bdict['elength'])==False:GEN.makeDialog('Error!!! dissipation length is not number')         
                                                
            f=open(self.caseDir+'/system/settings/BCDict:'+patchname,'w')
            keys=bdict.keys()
            for ii in keys:f.write(ii+';'+bdict[ii]+'\n')
            f.close()                        
            window.destroy()
            
            os.system('rm '+self.caseDir+'/system/settings/openSubWindow')
            # --- change patch name ------------------    
            if oldname!=newname:
                f=open(self.caseDir+'/constant/polyMesh/boundary','r');ff=f.readlines();f.close()
                for i in range(len(ff)):
                    if ff[i].strip()==oldname:ff[i]='    '+newname+'\n'
                g=open(self.caseDir+'/constant/polyMesh/boundary','w')
                for ii in ff:g.write(ii)
                g.close()
                
                os.system('mv '+self.caseDir+'/VTK/'+oldname+' '+self.caseDir+'/VTK/'+newname)
                os.system('mv '+self.caseDir+'/VTK/'+newname+'/'+oldname+'_0.vtk '+self.caseDir+'/VTK/'+newname+'/'+newname+'_0.vtk')

                aa=glob.glob(self.caseDir+'/system/settings/BCDict:'+oldname)
                if aa!=[]:
                    for ii in aa:os.system('rm '+ii)            
            #--- refresh boundary panel -------------------------
            bcnameList=GEN.getBCName();bctypeList=GEN.getBCType()
            liststore_patchname.clear()
            for i in range(len(bcnameList)): 
                liststore_patchname.append([bcnameList[i],bctypeList[i]])            
            #--- text window message ------------------------------------------------        
            string='\n\n [  Boundary condition for "'+bdict['name']+'" is set  ]\n'
            if bdict['Utype']=='fixed-U':
                string=string+'\n    - U type is '+bdict['Utype']+' : ('+bdict['Ux']+' '+bdict['Uy']+' '+bdict['Uz']+')\n'
            elif bdict['Utype']=='surfaceNormal-U':
                string=string+'\n    - U type is '+bdict['Utype']+' : '+bdict['Umag']+'\n'
            else:
                string=string+'\n    - U type is '+bdict['Utype']+'\n'
                
            if bdict['ptype']=='fixedValue':
                string=string+'\n    - p type is '+bdict['ptype']+' : '+bdict['pstatic']+'\n'
            elif bdict['ptype']=='totalPressure':
                string=string+'\n    - p type is '+bdict['ptype']+' : '+bdict['ptotal']+'\n'
            else:
                string=string+'\n    - p type is '+bdict['ptype']+'\n'
                
            if bdict['ktype']=='fixedValue':
                string=string+'\n    - k type is '+bdict['ktype']+' : '+bdict['kvalue']+'\n'
            elif bdict['ktype']=='inletOutlet':
                string=string+'\n    - k type is '+bdict['ktype']+' : '+bdict['kinout']+'\n'
            elif bdict['ktype']=='intensity':
                string=string+'\n    - k type is '+bdict['ktype']+' : '+bdict['kintensity']+'\n'
            else:
                string=string+'\n    - k type is '+bdict['ktype']+'\n'                   
                
            if turmodel=='kOmegaSST':
                if bdict['etype']=='fixedValue':
                    string=string+'\n    - omega type is '+bdict['etype']+' : '+bdict['evalue']+'\n'
                elif bdict['etype']=='inletOutlet':
                    string=string+'\n    - omega type is '+bdict['etype']+' : '+bdict['einout']+'\n'
                else:
                    string=string+'\n    - omega type is '+bdict['etype']+'\n'
            else:
                if bdict['etype']=='fixedValue':
                    string=string+'\n    - epsilon type is '+bdict['etype']+' : '+bdict['evalue']+'\n'
                elif bdict['etype']=='inletOutlet':
                    string=string+'\n    - epsilon type is '+bdict['etype']+' : '+bdict['einout']+'\n' 
                elif bdict['etype']=='mixingLength':
                    string=string+'\n    - epsilon type is '+bdict['etype']+' : '+bdict['elength']+'\n'
                else:
                    string=string+'\n    - epsilon type is '+bdict['etype']+'\n'
                    
            if bdict['alphatype']=='fixedValue':
                string=string+'\n    - alpha.water type is '+bdict['alphatype']+' : '+bdict['alphavalue']+'\n'
            else:
                string=string+'\n    - alpha.water type is '+bdict['alphatype']+'\n'   

            enditer=textbuffer.get_end_iter()
            textbuffer.insert(enditer,string)
            notebook.set_current_page(0)
                        
        def setSavedValue():
            aa=glob.glob(self.caseDir+'/system/settings/BCDict:'+patchname)
            if len(aa)!=0:
                dic=GEN.makeDictFromFile(aa[0])
                utypeCombo.set_active(utypes.index(dic['Utype']))
                uxEntry.set_text(dic['Ux']);uyEntry.set_text(dic['Uy']);uzEntry.set_text(dic['Uz'])
                umagEntry.set_text(dic['Umag'])
                
                ptypeCombo.set_active(ptypes.index(dic['ptype']))
                pstaticEntry.set_text(dic['pstatic'])

                alphatypeCombo.set_active(alphatypes.index(dic['alphatype']))
                alphavalueEntry.set_text(dic['alphavalue'])

                dickeys=dic.keys()

                if GEN.isThereInList(dickeys,'ktype')=='true':
                    ktypeCombo.set_active(ktypes.index(dic['ktype']));kvalueEntry.set_text(dic['kvalue'])
                    kinoutEntry.set_text(dic['kinout']);kintensityEntry.set_text(dic['kintensity'])                
                if turmodel=='kOmegaSST' or turmodel=='kOmega':
                    if GEN.isThereInList(dickeys,'otype')=='true':
                        otypeCombo.set_active(otypes.index(dic['otype']));ovalueEntry.set_text(dic['ovalue']);oinoutEntry.set_text(dic['oinout']) 
                else:
                    if GEN.isThereInList(dickeys,'etype')=='true':
                        etypeCombo.set_active(etypes.index(dic['etype']));evalueEntry.set_text(dic['evalue']);einoutEntry.set_text(dic['einout'])
                        elengthEntry.set_text(dic['elength'])
        # -- gui window --------------------------------------------------
        openSubWindow=GEN.subWindowOpened()
        
        if openSubWindow==False:

            aa=glob.glob(self.caseDir+'/system/settings/generalConditions')
            if len(aa)==0:turmodel='kEpsilon'
            else:
                gendict=GEN.makeDictFromFile(aa[0])
                turmodel=gendict['RANSModel']

            window=gtk.Window(gtk.WINDOW_TOPLEVEL);window.set_title('Boundary Condition - '+patchname)
            window.set_border_width(10);window.set_position(gtk.WIN_POS_CENTER);window.set_transient_for(mainwindow)
            window.connect("delete_event", self.delete_event)
            
            mainbox=gtk.VBox(False,5);window.add(mainbox)
            
            label=gtk.Label('Name')
            bcnameEntry=gtk.Entry()
            bcnameEntry.set_text(patchname)
            hbox=gtk.HBox(False,5);mainbox.pack_start(hbox,False,False,5)
            hbox.pack_start(label,False,False,5);hbox.pack_end(bcnameEntry,True,True,2)

            separator=gtk.HSeparator();separator.set_size_request(10,5)        
            mainbox.pack_start(separator,True,True,5)

            #-- velocity ---------
            def chutype(widget):
                aa=widget.child;ucondition=aa.get_text()
                aa=ubox.get_children()
                for ii in aa:ubox.remove(ii)
                ubox.pack_start(uhbox,False,False,5)
                if ucondition=='fixed-U':ubox.pack_start(fxubox,False,False,2)
                elif ucondition=='surfaceNormal-U':ubox.pack_start(usnbox,False,False,2)
                window.resize(400,500)
                window.show_all()

            label=gtk.Label();label.set_markup('<b> Velocity </b>');label.set_alignment(0,0.5)
            hhbox=gtk.HBox(False,5);mainbox.pack_start(hhbox,False,False,0)
            hhbox.pack_start(label,False,False,5)
            
            ubox=gtk.VBox(False,5);mainbox.pack_start(ubox,False,False,5)
           
            label=gtk.Label('Type');label.set_size_request(65,28);label.set_alignment(0,0.5)
            utypeCombo=gtk.combo_box_entry_new_text();utypeCombo.set_size_request(180,28)
            utypes=['no-slip','fixed-U','surfaceNormal-U','pressureInletOutletVelocity','zeroGradient','movingWallVelocity']                  
            for ii in utypes:utypeCombo.append_text(ii)                     
            uhbox=gtk.HBox(False,5);ubox.pack_start(uhbox,False,False,5)
            uhbox.pack_start(label,False,False,10);uhbox.pack_end(utypeCombo,False,False,5)

            label=gtk.Label('U [m/s]')
            uxEntry=gtk.Entry();uxEntry.set_size_request(60,28);uxEntry.set_text(self.speed)
            uyEntry=gtk.Entry();uyEntry.set_size_request(60,28);uyEntry.set_text('0')
            uzEntry=gtk.Entry();uzEntry.set_size_request(60,28);uzEntry.set_text('0')
            fxubox=gtk.HBox(False,5)
            fxubox.pack_start(label,False,False,10);fxubox.pack_end(uzEntry,False,False,5)
            fxubox.pack_end(uyEntry,False,False,0);fxubox.pack_end(uxEntry,False,False,5)

            label=gtk.Label('Velocity magnitude [m/s]')
            umagEntry=gtk.Entry();umagEntry.set_size_request(80,28);umagEntry.set_text(self.speed);umagEntry.grab_focus()
            usnbox=gtk.HBox(False,5);usnbox.pack_start(label,False,False,10);usnbox.pack_end(umagEntry,False,False,5)

            utypeCombo.connect('changed',chutype)
            if patchtype=='patch':
                if patchname[:3]=='out' or patchname[:3]=='Out' or patchname[:3]=='OUT':utypeCombo.set_active(4)
                else:utypeCombo.set_active(1)
            elif patchtype=='wall' or patchtype=='mappedWall':utypeCombo.set_active(0)
            #-- pressure ---------
            def chptype(widget):
                aa=widget.child;pcondition=aa.get_text()
                aa=pbox.get_children()
                for ii in aa:pbox.remove(ii)
                pbox.pack_start(phbox,False,False,5)
                if pcondition=='fixedValue':pbox.pack_start(pstaticbox,False,False,2)
                window.show_all()

            separator=gtk.HSeparator();separator.set_size_request(10,5)        
            mainbox.pack_start(separator,True,True,0)

            label=gtk.Label();label.set_markup('<b> Pressure </b>');label.set_alignment(0,0.5)
            hhbox=gtk.HBox(False,5);mainbox.pack_start(hhbox,False,False,0)
            hhbox.pack_start(label,False,False,5)
            
            pbox=gtk.VBox(False,5);mainbox.pack_start(pbox,False,False,5)
            
            label=gtk.Label('Type')
            ptypeCombo=gtk.combo_box_entry_new_text();ptypeCombo.set_size_request(180,28)
            ptypes=['alphaWeighted','fixedValue','zeroGradient','fixedFluxPressure']              
            for ii in ptypes:ptypeCombo.append_text(ii)                
            phbox=gtk.HBox(False,5);pbox.pack_start(phbox,False,False,2)
            phbox.pack_start(label,False,False,10);phbox.pack_end(ptypeCombo,False,False,5)

            label=gtk.Label('Static pressure [Pa]')
            pstaticEntry=gtk.Entry();pstaticEntry.set_size_request(80,28)
            pstaticEntry.set_text('0')
            pstaticbox=gtk.HBox(False,5);pstaticbox.pack_start(label,False,False,10);pstaticbox.pack_end(pstaticEntry,False,False,5)
            
            ptypeCombo.connect('changed',chptype)
            if patchtype=='patch':
                if patchname[:3]=='out' or patchname[:3]=='Out' or patchname[:3]=='OUT':ptypeCombo.set_active(0)
                else:ptypeCombo.set_active(3)
            elif patchtype=='wall':ptypeCombo.set_active(3)        

            #-- alpha ---------
            def chttype(widget):
                aa=widget.child;tcondition=aa.get_text()
                aa=alphabox.get_children()
                for ii in aa:alphabox.remove(ii)
                alphabox.pack_start(thbox,False,False,5)
                if tcondition=='fixedValue':alphabox.pack_start(tvaluebox,False,False,2)
                window.show_all()

            separator=gtk.HSeparator();separator.set_size_request(10,5)        
            mainbox.pack_start(separator,True,True,0)

            label=gtk.Label();label.set_markup('<b> alpha </b>');label.set_alignment(0,0.5)
            hhbox=gtk.HBox(False,5);mainbox.pack_start(hhbox,False,False,0)
            hhbox.pack_start(label,False,False,5)

            alphabox=gtk.VBox(False,5);mainbox.pack_start(alphabox,False,False,5)

            label=gtk.Label('Type')
            alphatypeCombo=gtk.combo_box_entry_new_text();alphatypeCombo.set_size_request(180,28)
            alphatypes=['fixedValue','zeroGradient']  
            for ii in alphatypes:alphatypeCombo.append_text(ii)               
            thbox=gtk.HBox(False,5);alphabox.pack_start(thbox,False,False,2)
            thbox.pack_start(label,False,False,10);thbox.pack_end(alphatypeCombo,False,False,5)

            label=gtk.Label('alpha ')
            alphavalueEntry=gtk.Entry();alphavalueEntry.set_size_request(80,28);alphavalueEntry.set_text('0')
            tvaluebox=gtk.HBox(False,5);tvaluebox.pack_start(label,False,False,10);tvaluebox.pack_end(alphavalueEntry,False,False,5)
            
            alphatypeCombo.connect('changed',chttype)
            if patchtype=='patch':
                alphatypeCombo.set_active(1) 
                if patchname[:3]=='out' or patchname[:3]=='Out' or patchname[:3]=='OUT':
                    alphatypeCombo.set_active(1)                               
            elif patchtype=='wall':
                alphatypeCombo.set_active(1) 

            #-- turbulence, k---------
            def chktype(widget):
                aa=widget.child;kcondition=aa.get_text()
                aa=kbox.get_children()
                for ii in aa:kbox.remove(ii)
                kbox.pack_start(khhbox,False,False,0)
                kbox.pack_start(khbox,False,False,5)
                if kcondition=='fixedValue':kbox.pack_start(kvaluebox,False,False,2)
                elif kcondition=='inletOutlet':kbox.pack_start(kinoutbox,False,False,2)
                elif kcondition=='intensity':kbox.pack_start(kintensitybox,False,False,2)
                window.show_all()
            
            kbox=gtk.VBox(False,5)

            label=gtk.Label();label.set_markup('<b> k, Turb. kinetic energy </b>');label.set_alignment(0,0.5)
            khhbox=gtk.HBox(False,5);kbox.pack_start(khhbox,False,False,0)
            khhbox.pack_start(label,False,False,5)

            label=gtk.Label('Type')
            ktypeCombo=gtk.combo_box_entry_new_text();ktypeCombo.set_size_request(180,28)
            ktypes=['wallFunction','fixedValue','zeroGradient','inletOutlet','intensity']  
            for ii in ktypes:ktypeCombo.append_text(ii)               
            khbox=gtk.HBox(False,5);kbox.pack_start(khbox,False,False,2)
            khbox.pack_start(label,False,False,10);khbox.pack_end(ktypeCombo,False,False,5)

            label=gtk.Label('k [m2/s2]')
            kvalueEntry=gtk.Entry();kvalueEntry.set_size_request(80,28);kvalueEntry.set_text(self.inletk)
            kvaluebox=gtk.HBox(False,5);kvaluebox.pack_start(label,False,False,10);kvaluebox.pack_end(kvalueEntry,False,False,5)

            label=gtk.Label('Inlet k [m2/s2]')
            kinoutEntry=gtk.Entry();kinoutEntry.set_size_request(80,28);kinoutEntry.set_text(self.inletk)
            kinoutbox=gtk.HBox(False,5);kinoutbox.pack_start(label,False,False,10);kinoutbox.pack_end(kinoutEntry,False,False,5)

            label=gtk.Label('Intensity')
            kintensityEntry=gtk.Entry();kintensityEntry.set_size_request(80,28);kintensityEntry.set_text('0.1')
            kintensitybox=gtk.HBox(False,5);kintensitybox.pack_start(label,False,False,10);kintensitybox.pack_end(kintensityEntry,False,False,5)
            
            ktypeCombo.connect('changed',chktype)
            if patchtype=='patch':
                ktypeCombo.set_active(1) 
                if patchname[:3]=='out' or patchname[:3]=='Out' or patchname[:3]=='OUT':
                    ktypeCombo.set_active(2) 
            elif patchtype=='wall' or patchtype=='mappedWall':ktypeCombo.set_active(0)
            #-- epsilon ---------
            def chetype(widget):
                aa=widget.child;econdition=aa.get_text()
                aa=ebox.get_children()
                for ii in aa:ebox.remove(ii)
                ebox.pack_start(ehhbox,False,False,5)
                ebox.pack_start(ehbox,False,False,5)
                if econdition=='fixedValue':ebox.pack_start(evaluebox,False,False,2)
                elif econdition=='inletOutlet':ebox.pack_start(einoutbox,False,False,2)
                elif econdition=='mixingLength':ebox.pack_start(elengthbox,False,False,2)
                window.show_all()

            separator=gtk.HSeparator();separator.set_size_request(10,5)        
            mainbox.pack_start(separator,True,True,0)
            
            ebox=gtk.VBox(False,5)

            label=gtk.Label();label.set_markup('<b> epsilon </b>');label.set_alignment(0,0.5)
            ehhbox=gtk.HBox(False,5);ebox.pack_start(ehhbox,False,False,0)
            ehhbox.pack_start(label,False,False,5)
            
            label=gtk.Label('Type')
            etypeCombo=gtk.combo_box_entry_new_text();etypeCombo.set_size_request(180,28)
            etypes=['wallFunction','fixedValue','zeroGradient','inletOutlet','mixingLength']  
            for ii in etypes:etypeCombo.append_text(ii)               
            ehbox=gtk.HBox(False,5);ebox.pack_start(ehbox,False,False,2)
            ehbox.pack_start(label,False,False,10);ehbox.pack_end(etypeCombo,False,False,5)

            label=gtk.Label('epsilon [m2/s3]')
            evalueEntry=gtk.Entry();evalueEntry.set_size_request(80,28);evalueEntry.set_text(self.inlete)
            evaluebox=gtk.HBox(False,5);evaluebox.pack_start(label,False,False,10);evaluebox.pack_end(evalueEntry,False,False,5)

            label=gtk.Label('Inlet epsilon [m2/s3]')
            einoutEntry=gtk.Entry();einoutEntry.set_size_request(80,28);einoutEntry.set_text(self.inlete)
            einoutbox=gtk.HBox(False,5);einoutbox.pack_start(label,False,False,10);einoutbox.pack_end(einoutEntry,False,False,5)
            
            label=gtk.Label('Length scale [m2/s3]')
            elengthEntry=gtk.Entry();elengthEntry.set_size_request(80,28);elengthEntry.set_text('1')
            elengthbox=gtk.HBox(False,5);elengthbox.pack_start(label,False,False,10);elengthbox.pack_end(elengthEntry,False,False,5)
            
            etypeCombo.connect('changed',chetype)
            if patchtype=='patch':
                etypeCombo.set_active(1)
                if patchname[:3]=='out' or patchname[:3]=='Out' or patchname[:3]=='OUT':
                    etypeCombo.set_active(2)  
            elif patchtype=='wall' or patchtype=='mappedWall':etypeCombo.set_active(0)
            #-- omega -----------------------------
            def chotype(widget):
                aa=widget.child;ocondition=aa.get_text()
                aa=obox.get_children()
                for ii in aa:obox.remove(ii)
                obox.pack_start(ohhbox,False,False,5)
                obox.pack_start(ohbox,False,False,5)
                if ocondition=='fixedValue':obox.pack_start(ovaluebox,False,False,2)
                elif ocondition=='inletOutlet':obox.pack_start(oinoutbox,False,False,2)
                window.show_all()

            separator=gtk.HSeparator();separator.set_size_request(10,5)        
            
            obox=gtk.VBox(False,5)

            label=gtk.Label();label.set_markup('<b> omega </b>');label.set_alignment(0,0.5)
            ohhbox=gtk.HBox(False,5);obox.pack_start(ohhbox,False,False,0)
            ohhbox.pack_start(label,False,False,5)
            
            label=gtk.Label('Type')
            otypeCombo=gtk.combo_box_entry_new_text();otypeCombo.set_size_request(180,28)
            otypes=['wallFunction','fixedValue','zeroGradient','inletOutlet']  
            for ii in otypes:otypeCombo.append_text(ii)               
            ohbox=gtk.HBox(False,5);obox.pack_start(ohbox,False,False,2)
            ohbox.pack_start(label,False,False,10);ohbox.pack_end(otypeCombo,False,False,5)

            label=gtk.Label('omega [1/s]')
            ovalueEntry=gtk.Entry();ovalueEntry.set_size_request(80,28);ovalueEntry.set_text('1')
            ovaluebox=gtk.HBox(False,5);ovaluebox.pack_start(label,False,False,10);ovaluebox.pack_end(ovalueEntry,False,False,5)

            label=gtk.Label('Inlet omega [1/s]')
            oinoutEntry=gtk.Entry();oinoutEntry.set_size_request(80,28);oinoutEntry.set_text('1')
            oinoutbox=gtk.HBox(False,5);oinoutbox.pack_start(label,False,False,10);oinoutbox.pack_end(oinoutEntry,False,False,5)
            
            otypeCombo.connect('changed',chotype)
            if patchtype=='patch':
                otypeCombo.set_active(1)
                if patchname[:3]=='out' or patchname[:3]=='Out' or patchname[:3]=='OUT':
                    etypeCombo.set_active(2)  
            elif patchtype=='wall':otypeCombo.set_active(0)
            #-------------------------------
            if turmodel=='kOmega' or turmodel=='kOmegaSST':
                mainbox.pack_start(kbox,True,True,5)
                mainbox.pack_start(separator,True,True,5)
                mainbox.pack_start(obox,True,True,5)                
            else:
                mainbox.pack_start(kbox,True,True,5)
                mainbox.pack_start(separator,True,True,5)
                mainbox.pack_start(ebox,True,True,5)        

            separator=gtk.HSeparator();separator.set_size_request(10,5)        
            mainbox.pack_start(separator,True,True,5)      
            #-------------------------------
            buttonbox=gtk.HBox(False,5)        
            mainbox.pack_start(buttonbox,False,False,5)  
            
            app=gtk.Button(label='Apply');app.set_size_request(100,30);cll=gtk.Button(label='Close');cll.set_size_request(100,30)
            app.connect('clicked',applythis);cll.connect('clicked',closethis)
            buttonbox.pack_end(cll,False,False,5);buttonbox.pack_end(app,False,False,5) 

            setSavedValue()

            window.show_all()   

        else:return    

    def main(self):
        gtk.main()

if __name__=='__main__':
    solverwin=covWin()
    solverwin.main()
