#-*-coding:utf8-*-
#############################################################################
# License                                                                       
#    This file is part of RESOS(RESistance Open Source CFD package).                                            
#
#    RESOS is free software; you can redistribute it and/or modify it
#    under the terms of the GNU General Public License as published by the
#    Free Software Foundation; either version 3 of the License, or (at your
#    option) any later version.
#
#    RESOS is distributed in the hope that it will be useful, but WITHOUT
#    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#    for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with RESOS.  If not, see <http://www.gnu.org/licenses/>.
#
# Description
#    - Class for miscellaneous functions
#
# Author
#    NEXTFOAM Inc. All rights reserved.
##############################################################################

import os,math,sys;import pygtk;pygtk.require('2.0');import gtk;import glob

from generalSub import *

class miscClass:

    def delete_event(self,widget,event,data=None):
        print 'delete event occurred'
        return False

    def destroy(self,widget,data=None):
        self.Win.destroy()

    def __init__(self,caseDir):
	    self.caseDir=caseDir

    #-------------------------------------------------------------------------------------
    def foamComment(self):
        fc=[]
        fc.append('/*--------------------------------*- C++ -*----------------------------------*\ \n')
        fc.append('| =========                 |                                                 |\n')
        fc.append('| \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox           |\n')
        fc.append('|  \\    /   O peration     | Version:  2.3.0                                 |\n')
        fc.append('|   \\  /    A nd           | Web:      www.OpenFOAM.org                      |\n')
        fc.append('|    \\/     M anipulation  |                                                 |\n')
        fc.append('\*---------------------------------------------------------------------------*/\n')	
        return fc
    #------------------------------------------------------------------------------
    def header(self,location,obj):
        he=[]
        he.append('FoamFile\n')
        he.append('{\n')
        he.append('    version     2.0;\n')
        he.append('    format      ascii;\n')
        he.append('    class       dictionary;\n')
        he.append('    location    "'+location+'";\n')
        he.append('    object      '+obj+';\n')
        he.append('}\n')
        he.append('// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //\n')
        return he
    #------------------------------------------------------------------------------
    def BCheader(self,classtype,obj):
        he=[]
        he.append('FoamFile\n')
        he.append('{\n')
        he.append('    version     2.0;\n')
        he.append('    format      ascii;\n')
        he.append('    class       '+classtype+';\n')
        he.append('    object      '+obj+';\n')
        he.append('}\n')
        he.append('// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //\n')
        return he	    
    #--------------------------------------------------------------------------------------  
    def basicfvsolution(self):
        fcom=self.foamComment();head=self.header('system','fvSolution');hhh=fcom+head
        f=open(self.caseDir+'/system/fvSolution','w')
        for aaa in hhh:f.write(aaa)	
        f.write('solvers\n')
        f.write('{\n')
        f.write('    "alpha.water.*"\n')
        f.write('    {\n')
        f.write('        nAlphaCorr      1;\n')
        f.write('        nAlphaSubCycles 3;\n')
        f.write('        cAlpha          0.2;\n')
        f.write('        icAlpha         0.0;\n')
        f.write('        MULESCorr       yes;\n')
        f.write('        nLimiterIter    5;\n')
        f.write('        alphaApplyPrevCorr  yes;\n')
        f.write('        solver          smoothSolver;\n')
        f.write('        smoother        symGaussSeidel;\n')
        f.write('        tolerance       1e-8;\n')
        f.write('        relTol          0;\n')
        f.write('        minIter         2;\n')
        f.write('        maxIter         100;\n')
        f.write('        minAlpha        0;\n')
        f.write('        maxAlpha        1;\n')
        f.write('    }\n')      
        f.write('    "pcorr.*"\n')
        f.write('    {\n')
        f.write('        solver          PCG;\n')
        f.write('        preconditioner\n')
        f.write('        {\n')
        f.write('            preconditioner  GAMG;\n')
        f.write('            smoother        GaussSeidel;\n')
        f.write('            agglomerator    faceAreaPair;\n')
        f.write('            mergeLevels     1;\n')
        f.write('            nCellsInCoarsestLevel 10;\n')
        f.write('            cacheAgglomeration true;\n')
        f.write('            tolerance       1e-5;\n')
        f.write('            relTol          0;\n')
        #f.write('            minIter         1;\n')
        f.write('        };\n')
        f.write('        tolerance       1e-5;\n')
        f.write('        relTol          0;\n')
        f.write('        minIter         2;\n')
        f.write('        maxIter         200;\n')
        f.write('    };\n')

        f.write('    "(p|p_rgh)"\n')
        f.write('    {\n')
        f.write('        solver          GAMG;\n')
        f.write('        smoother        DIC;\n')
        f.write('        agglomerator    faceAreaPair;\n')
        f.write('        mergeLevels     1;\n')
        f.write('        nCellsInCoarsestLevel 10;\n')
        f.write('        cacheAgglomeration true;\n')
        f.write('        tolerance       1e-9;\n')
        f.write('        relTol          0.0;\n')
        f.write('        minIter         2;\n')
        f.write('        maxIter         20;\n')
        f.write('    }\n')
        
        f.write('    p_rghFinal\n')
        f.write('    {\n')
        f.write('        $p_rgh;\n')
        #f.write('        relTol          0;\n')
        #f.write('        minIter         1;\n')
        f.write('    }\n')
        
        f.write('    "(U|k|omega|epsilon|nuTilda)"\n')
        f.write('    {\n')
        f.write('        solver          smoothSolver;\n')
        f.write('        smoother        symGaussSeidel;\n')
        f.write('        tolerance       1e-7;\n')
        f.write('        relTol          0.01;\n')
        f.write('        minIter         2;\n')
        f.write('        maxIter         200;\n')        
        f.write('    };\n')
        
        f.write('    "(U|k|omega|epsilon|nuTilda)Final"\n')
        f.write('    {\n')
      	f.write('        $U;\n')
        #f.write('        relTol          0;\n')
        f.write('    };\n')
        
        f.write('}\n')
        
        f.write('potentialFlow\n')
        f.write('{\n')
        f.write('    nNonOrthogonalCorrectors 20;\n')
        f.write('    pRefCell                  0;\n')
        f.write('    pRefValue                 0;\n')
        f.write('}\n')
        f.write('SIMPLE\n')
        f.write('{\n')
        f.write('    momentumPredictor no;\n')
        f.write('    nNonOrthogonalCorrectors 2;\n')
        f.write('    pRefCell	0;\n')
        f.write('    pRefValue	0;\n')
        f.write('    residualControl\n')
        f.write('    {\n')
        f.write('        p                    1e-3;\n')
        f.write('        U                    1e-3;\n')
        f.write('        "(k|epsilon|omega|nuTilda)"  1e-5;\n')
        f.write('    }\n')
        f.write('}\n')
        f.write('PIMPLE\n')
        f.write('{\n')
        #f.write('    momentumPredictor no;\n')
        f.write('    turbOnFinalIterOnly    false;\n')
        f.write('    nNonOrthogonalCorrectors 1;\n')
        f.write('    nOuterCorrectors 1;\n')
        f.write('    nCorrectors 2;\n')
        
        f.write('    residualControl\n')
        f.write('    {\n')
        f.write('        "(p_rgh|U|k|epsilon)"\n')
        f.write('        {\n')
        f.write('            relTol          0;\n')
        f.write('            tolerance       0.00001;\n')
        f.write('        }\n')
        f.write('    }\n')
        
        #f.write('\n')
        #f.write('    maxCo               100;\n')
        #f.write('    maxAlphaCo          0.8;\n')
        #f.write('\n')
        #f.write('    rDeltaTSmoothingCoeff 0.05;\n')
        #f.write('    rDeltaTDampingCoeff 0.5;\n')
        #f.write('    nAlphaSpreadIter    0;\n')
        #f.write('    nAlphaSweepIter     0;\n')
        #f.write('    maxDeltaT           1;\n')
        #f.write('\n')    
        #f.write('    correctPhi  yes;\n')
        #f.write('    pRefCell	0;\n')
        #f.write('    pRefValue	0;\n')
        f.write('}\n')
        f.write('relaxationFactors\n')
        f.write('{\n')
        f.write('    fields\n')
        f.write('    {\n')
        f.write('        p_rgh    1.0;\n')
        f.write('        pUrf     0.5;\n')
        f.write('    }\n')
        f.write('    equations\n')
        f.write('    {\n')
        f.write('        "U.*"    0.5;\n')        
        f.write('        "(k|epsilon|omega|nuTilda).*"    0.5;\n')
        f.write('    }\n')
        f.write('}\n')
        f.write('cache\n')
        f.write('{\n')
        f.write('    grad(U);\n')
        f.write('}\n')
        f.close()
    #--------------------------------------------------------------------------------------  
    def basicfvsolutionAlpha(self):
        f=open(self.caseDir+'/system/fvSolutionAlpha','w')
        f.write('       nAlphaCorr 1;\n')
        f.write('       nAlphaSubCycles 3;\n')
        f.write('       cAlpha 0.2;\n')
        f.write('       icAlpha 0;\n')
        f.write('       MULESCorr yes;\n')
        f.write('       nLimiterIter 5;\n')
        f.write('       alphaApplyPrevCorr yes;\n')
        f.close()            
    #--------------------------------------------------------------------------------------  
    def basicfvschemes(self):
        
        fcom=self.foamComment();head=self.header('system','fvSchemes');hhh=fcom+head
        f=open(self.caseDir+'/system/fvSchemes','w')
        for aaa in hhh:f.write(aaa)	
        f.write('ddtSchemes\n')
        f.write('{\n')
        #f.write('    default         localEuler rDeltaT;\n')
        f.write('    default         Euler;\n')        
        f.write('}\n')
        f.write('gradSchemes\n')
        f.write('{\n')
        f.write('    default         Gauss linear;\n')
        f.write('    limitedGrad     cellLimited Gauss linear 1;\n')
        f.write('}\n')
        f.write('divSchemes\n')
        f.write('{\n')
        f.write('    default          Gauss linear;\n')
        f.write('    div(rhoPhi,U)    Gauss linearUpwindV grad(U);\n')
        f.write('    div(phi,alpha)   Gauss vanLeer;\n')
        f.write('    div(phirb,alpha) Gauss linear;\n')        
        f.write('    div(phi,k)       Gauss upwind;\n')
        f.write('    div(phi,epsilon) Gauss upwind;\n')
        f.write('    div(phi,omega)   Gauss upwind;\n')
        f.write('    div(phi,nuTilda) Gauss upwind;\n')
        f.write('}\n')
        f.write('laplacianSchemes\n')
        f.write('{\n')
        f.write('    default         Gauss linear corrected;\n')
        #f.write('    default         Gauss linear limited corrected 0.5;\n')        
        f.write('}\n')
        f.write('interpolationSchemes\n')
        f.write('{\n')
        f.write('    default         linear;\n')
        f.write('}\n')
        f.write('snGradSchemes\n')
        f.write('{\n')
        f.write('    default         corrected;\n')
        #f.write('    default         limited corrected 0.5;\n')        
        f.write('}\n')
        f.write('fluxRequired\n')
        f.write('{\n')
        f.write('    default         no;\n')
        f.write('    alpha.water;\n')
        f.write('    p_rgh;\n')
        f.write('    pcorr;\n')
        f.write('    p;\n')        
        f.write('}\n')
        f.close()
    #--------------------------------------------------------------------------------------  
    def basiccontroldict(self):
        fcom=self.foamComment();head=self.header('system','controlDict');hhh=fcom+head
        f=open(self.caseDir+'/system/controlDict','w')
        for aaa in hhh:f.write(aaa)	
        f.write('application     interNFoam;\n')
        f.write('startFrom       startTime;\n')
        f.write('startTime       0;\n')
        f.write('stopAt          endTime;\n')
        f.write('endTime         10000;\n')
        f.write('deltaT          0.01;\n')
        f.write('writeControl    runTime;\n')
        f.write('writeInterval   100;\n')
        f.write('purgeWrite      10;\n')
        f.write('writeFormat     ascii;//binary;\n')
        f.write('writePrecision  6;\n')
        f.write('writeCompression uncompressed;\n')
        f.write('timeFormat      general;\n')
        f.write('timePrecision   6;\n')
        f.write('runTimeModifiable yes;\n')
        f.write('adjustTimeStep no;\n')
        f.write('maxCo          50;\n')
        f.write('maxAlphaCo     20;\n')
        #f.write('maxDeltaT      1.0;\n')
        f.close()
    #------------------------------------------------------------------------------
    def UFileBasic(self):
        GEN=generalClass(self.caseDir)
        fcom=self.foamComment();head=self.BCheader('volVectorField','U');hhh=fcom+head
        bcname=GEN.getBCName();bctype=GEN.getBCType()
        
        f=open(self.caseDir+'/0/U','w')
        for aaa in hhh:f.write(aaa)	
        f.write('dimensions      [0 1 -1 0 0 0 0];\n')
        f.write('internalField   uniform (0 0 0);\n')
        f.write('boundaryField\n')
        f.write('{\n')
        for j in range(len(bcname)):
            f.write('    '+bcname[j]+'\n')
            f.write('    {\n')
            if bctype[j]=='wall' or bctype[j]=='mappedWall':
                f.write('        type    fixedValue;\n')
                f.write('        value   uniform (0 0 0);\n')
            elif bctype[j]=='patch':
                f.write('        type    fixedValue;\n')
                f.write('        value   uniform (0 0 0);\n')
            elif bctype[j]=='symmetry':f.write('        type    symmetry;\n')
            elif bctype[j]=='symmetryPlane':f.write('        type    symmetryPlane;\n')
            elif bctype[j]=='empty':f.write('        type    empty;\n')
            elif bctype[j]=='cyclic':f.write('        type    cyclic;\n')
            elif bctype[j]=='cyclicAMI':f.write('        type    cyclicAMI;\n')
            f.write('    }\n')
        f.write('}\n')
        f.close()
    #------------------------------------------------------------------------------
    def kFileBasic(self):
        GEN=generalClass(self.caseDir)
        fcom=self.foamComment();head=self.BCheader('volScalarField','k');hhh=fcom+head        
        bcname=GEN.getBCName();bctype=GEN.getBCType()
        f=open(self.caseDir+'/0/k','w')
        for aaa in hhh:f.write(aaa)	
        f.write('dimensions      [0 2 -2 0 0 0 0];\n')
        f.write('internalField   uniform 1;\n')
        f.write('boundaryField\n')
        f.write('{\n')
        for j in range(len(bcname)):
            f.write('    '+bcname[j]+'\n')
            f.write('    {\n')
            if bctype[j]=='wall' or bctype[j]=='mappedWall':
                f.write('        type    kqRWallFunction;\n')
                f.write('        value   $internalField;\n')
            elif bctype[j]=='patch':f.write('        type    zeroGradient;\n')
            elif bctype[j]=='symmetry':f.write('        type    symmetry;\n')
            elif bctype[j]=='symmetryPlane':f.write('        type    symmetryPlane;\n')
            elif bctype[j]=='empty':f.write('        type    empty;\n')
            elif bctype[j]=='cyclic':f.write('        type    cyclic;\n')
            elif bctype[j]=='cyclicAMI':f.write('        type    cyclicAMI;\n')
            f.write('    }\n')
        f.write('}\n')
        f.close()        
    #------------------------------------------------------------------------------
    def epsilonFileBasic(self):
        GEN=generalClass(self.caseDir)
        fcom=self.foamComment();head=self.BCheader('volScalarField','epsilon');hhh=fcom+head
        
        bcname=GEN.getBCName();bctype=GEN.getBCType()
        f=open(self.caseDir+'/0/epsilon','w')
        for aaa in hhh:f.write(aaa)	
        f.write('dimensions      [0 2 -3 0 0 0 0];\n')
        f.write('internalField   uniform 1;\n')
        f.write('boundaryField\n')
        f.write('{\n')
        for j in range(len(bcname)):
            f.write('    '+bcname[j]+'\n')
            f.write('    {\n')
            if bctype[j]=='wall' or bctype[j]=='mappedWall':
                f.write('        type    epsilonWallFunction;\n')
                f.write('        value   $internalField;\n')
            elif bctype[j]=='patch':f.write('        type    zeroGradient;\n')
            elif bctype[j]=='symmetry':f.write('        type    symmetry;\n')
            elif bctype[j]=='symmetryPlane':f.write('        type    symmetryPlane;\n')
            elif bctype[j]=='empty':f.write('        type    empty;\n')
            elif bctype[j]=='cyclic':f.write('        type    cyclic;\n')
            elif bctype[j]=='cyclicAMI':f.write('        type    cyclicAMI;\n')
            f.write('    }\n')
        f.write('}\n')
        f.close()
    #------------------------------------------------------------------------------
    def omegaFileBasic(self):
        GEN=generalClass(self.caseDir)
        fcom=self.foamComment();head=self.BCheader('volScalarField','omega');hhh=fcom+head
        bcname=GEN.getBCName();bctype=GEN.getBCType()
        f=open(self.caseDir+'/0/omega','w')
        for aaa in hhh:f.write(aaa)	
        f.write('dimensions      [0 0 -1 0 0 0 0];\n')
        f.write('internalField   uniform 1;\n')
        f.write('boundaryField\n')
        f.write('{\n')
        for j in range(len(bcname)):
            f.write('    '+bcname[j]+'\n')
            f.write('    {\n')
            if bctype[j]=='wall' or bctype[j]=='mappedWall':
                f.write('        type    omegaWallFunction;\n')
                f.write('        value   $internalField;\n')
            elif bctype[j]=='patch':f.write('        type    zeroGradient;\n')
            elif bctype[j]=='symmetry':f.write('        type    symmetry;\n')
            elif bctype[j]=='symmetryPlane':f.write('        type    symmetryPlane;\n')
            elif bctype[j]=='empty':f.write('        type    empty;\n')
            elif bctype[j]=='cyclic':f.write('        type    cyclic;\n')
            elif bctype[j]=='cyclicAMI':f.write('        type    cyclicAMI;\n')
            f.write('    }\n')
        f.write('}\n')
        f.close()
    #------------------------------------------------------------------------------
    def p_rghFileBasic(self,bcDictList):
        GEN=generalClass(self.caseDir)
        fcom=self.foamComment();head=self.BCheader('volScalarField','p_rgh');hhh=fcom+head

        bcname=GEN.getBCName();bctype=GEN.getBCType()
        nameType={}
        for i in range(len(bcname)):
            nameType[bcname[i]]=bctype[i]
                    
        f=open(self.caseDir+'/0/p_rgh','w')
        for aaa in hhh:f.write(aaa)	
        f.write('dimensions      [1 -1 -2 0 0 0 0];\n')
        f.write('internalField   uniform 0;\n')
        f.write('boundaryField\n')
        f.write('{\n')
       
        for i in range(len(bcDictList)):
            dic=bcDictList[i]
            name=dic['name'];patchtype=dic['type'];ptype=dic['ptype']
            if patchtype=='patch':
                if ptype=='alphaWeighted':
                    f.write('    '+name+'\n')
                    f.write('    {\n')
                    f.write('        type         alphaWeighted;\n')
                    f.write('        pRefValue    0;\n')
                    f.write('        phaseName    alpha.water;\n')
                    f.write('        value        $internalField;\n')
                    f.write('    }\n')
                else:
                    f.write('    '+name+'\n')
                    f.write('    {\n')
                    f.write('        type         zeroGradient;\n')
                    f.write('    }\n')
            elif patchtype=='wall':
                f.write('    '+name+'\n')
                f.write('    {\n')
                f.write('        type         fixedFluxPressure;\n')
                f.write('    }\n')
            bcname.remove(name)

        for j in range(len(bcname)):
            f.write('    '+bcname[j]+'\n')
            f.write('    {\n')
            if nameType[bcname[j]]=='wall':
                f.write('        type    fixedFluxPressure;\n')
            elif nameType[bcname[j]]=='patch':                
                if bcname[j]=='outlet':
                    f.write('        type       alphaWeighted;\n')
                    f.write('        pRefValue  0;\n')
                    f.write('        phaseName  alpha.water;\n')
                    f.write('        value      uniform 0;\n')
                else:
                    f.write('        type    fixedFluxPressure;\n')
            elif nameType[bcname[j]]=='symmetry':f.write('        type    symmetry;\n')
            elif nameType[bcname[j]]=='symmetryPlane':f.write('        type    symmetryPlane;\n')
            elif nameType[bcname[j]]=='empty':f.write('        type    empty;\n')            
            f.write('    }\n')
                    
        f.write('}\n')
        f.close()                        
    #------------------------------------------------------------------------------
    def pFileBasicPotential(self):
        GEN=generalClass(self.caseDir)
        fcom=self.foamComment();head=self.BCheader('volScalarField','p');hhh=fcom+head
        bcname=GEN.getBCName();bctype=GEN.getBCType()
        f=open(self.caseDir+'/0/p','w')
        for aaa in hhh:f.write(aaa)	
        f.write('dimensions      [1 -1 -2 0 0 0 0];\n')
        f.write('internalField   uniform 0;\n')
        f.write('boundaryField\n')
        f.write('{\n')
        for j in range(len(bcname)):
            f.write('    '+bcname[j]+'\n')
            f.write('    {\n')
            if bctype[j]=='wall' or bctype[j]=='mappedWall':f.write('        type    zeroGradient;\n')
            elif bctype[j]=='patch':f.write('        type    zeroGradient;\n')
            elif bctype[j]=='symmetry':f.write('        type    symmetry;\n')
            elif bctype[j]=='symmetryPlane':f.write('        type    symmetryPlane;\n')
            elif bctype[j]=='empty':f.write('        type    empty;\n')
            elif bctype[j]=='cyclic':f.write('        type    cyclic;\n')
            elif bctype[j]=='cyclicAMI':f.write('        type    cyclicAMI;\n')
            f.write('    }\n')
        f.write('}\n')
        f.close()  
    #------------------------------------------------------------------------------
    def alphaFileBasic(self):
        GEN=generalClass(self.caseDir)
        fcom=self.foamComment();head=self.BCheader('volScalarField','alpha.water');hhh=fcom+head
        bcname=GEN.getBCName();bctype=GEN.getBCType()
        f=open(self.caseDir+'/0/alpha.water','w')
        for aaa in hhh:f.write(aaa)	
        f.write('dimensions      [0 0 0 0 0 0 0];\n')
        f.write('internalField   uniform 0;\n')
        f.write('boundaryField\n')
        f.write('{\n')
        for j in range(len(bcname)):
            f.write('    '+bcname[j]+'\n')
            f.write('    {\n')
            if bctype[j]=='wall' or bctype[j]=='mappedWall':f.write('        type    zeroGradient;\n')
            elif bctype[j]=='patch':
                f.write('        type    fixedValue;\n')
                f.write('        value   uniform 0;\n')
            elif bctype[j]=='symmetry':f.write('        type    symmetry;\n')
            elif bctype[j]=='symmetryPlane':f.write('        type    symmetryPlane;\n')
            elif bctype[j]=='empty':f.write('        type    empty;\n')
            elif bctype[j]=='cyclic':f.write('        type    cyclic;\n')
            elif bctype[j]=='cyclicAMI':f.write('        type    cyclicAMI;\n')
            f.write('    }\n')
        f.write('}\n')
        f.close()



