#-*-coding:utf8-*-
#############################################################################
# License                                                                       
#    This file is part of RESOS(RESistance Open Source CFD package).                                            
#
#    RESOS is free software; you can redistribute it and/or modify it
#    under the terms of the GNU General Public License as published by the
#    Free Software Foundation; either version 3 of the License, or (at your
#    option) any later version.
#
#    RESOS is distributed in the hope that it will be useful, but WITHOUT
#    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#    for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with RESOS.  If not, see <http://www.gnu.org/licenses/>.
#
# Description
#    - Class for snappyHexMesh sub-functions
#
# Author
#    NEXTFOAM Inc. All rights reserved.
##############################################################################

import os,math,sys;import pygtk;pygtk.require('2.0');import gtk;import glob

from generalSub import *

class snappySubClass:

    def delete_event(self,widget,event,data=None):
        aa=glob.glob(self.caseDir+'/system/settings/openSubWindow')
        for ii in aa:os.system('rm '+ii)

    def destroy(self,widget,data=None):
        self.Win.destroy()

    def __init__(self,caseDir):
	    self.caseDir=caseDir    
    #--------------------------------------------------------------------------------------  
    def selSTL(self):
        dialog = gtk.FileChooserDialog("Open..",None,gtk.FILE_CHOOSER_ACTION_OPEN,
                                       (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN, gtk.RESPONSE_OK))
        dialog.set_default_response(gtk.RESPONSE_OK)
        dialog.set_select_multiple(False)
        filter = gtk.FileFilter();filter.set_name("stl files")
        filter.add_mime_type("stl/STL");filter.add_mime_type("stl/stl")
        filter.add_pattern("*.STL");filter.add_pattern("*.stl")
        dialog.add_filter(filter)
        response = dialog.run()
        if response == gtk.RESPONSE_OK:
            stlList=dialog.get_filenames()
        elif response == gtk.RESPONSE_CANCEL:
            stlList=[]
            print 'Closed, no files selected'
        dialog.destroy()
        return stlList  
    #---------------------------------------------------------------------------------------------------------
    def makeBlockMeshVOFDict(self,p1,p2,p3,p4,p5,p6,domainNode):
        f=open(self.caseDir+'/constant/polyMesh/blockMeshDict','w')
        f.write('/*--------------------------------*- C++ -*----------------------------------*\ \n')
        f.write('| =========                 |                                                 | \n')
        f.write('| \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox           | \n')
        f.write('|  \\    /   O peration     | Version:  2.3.x                                 | \n')
        f.write('|   \\  /    A nd           | Web:      www.OpenFOAM.org                      | \n')
        f.write('|    \\/     M anipulation  |                                                 | \n')
        f.write('\*---------------------------------------------------------------------------*/ \n')
        f.write('FoamFile \n')
        f.write('{ \n')
        f.write('    version     2.0; \n')
        f.write('    format      ascii; \n')
        f.write('    class       dictionary; \n')
        f.write('    object      blockMeshDict; \n')
        f.write('} \n')
        f.write('// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * // \n')
        f.write('convertToMeters 1; \n')
        f.write('vertices \n')
        f.write('( \n')
        f.write('( '+p1[0][0]+' '+p1[0][1]+' '+p1[0][2]+' ) \n') 
        f.write('( '+p1[1][0]+' '+p1[1][1]+' '+p1[1][2]+' ) \n') 
        f.write('( '+p1[2][0]+' '+p1[2][1]+' '+p1[2][2]+' ) \n') 
        f.write('( '+p1[3][0]+' '+p1[3][1]+' '+p1[3][2]+' ) \n') 
        f.write('\n')
        f.write('( '+p2[0][0]+' '+p2[0][1]+' '+p2[0][2]+' ) \n') 
        f.write('( '+p2[1][0]+' '+p2[1][1]+' '+p2[1][2]+' ) \n') 
        f.write('( '+p2[2][0]+' '+p2[2][1]+' '+p2[2][2]+' ) \n') 
        f.write('( '+p2[3][0]+' '+p2[3][1]+' '+p2[3][2]+' ) \n') 
        f.write('\n')
        f.write('( '+p3[0][0]+' '+p3[0][1]+' '+p3[0][2]+' ) \n') 
        f.write('( '+p3[1][0]+' '+p3[1][1]+' '+p3[1][2]+' ) \n') 
        f.write('( '+p3[2][0]+' '+p3[2][1]+' '+p3[2][2]+' ) \n') 
        f.write('( '+p3[3][0]+' '+p3[3][1]+' '+p3[3][2]+' ) \n') 
        f.write('\n')
        f.write('( '+p4[0][0]+' '+p4[0][1]+' '+p4[0][2]+' ) \n') 
        f.write('( '+p4[1][0]+' '+p4[1][1]+' '+p4[1][2]+' ) \n') 
        f.write('( '+p4[2][0]+' '+p4[2][1]+' '+p4[2][2]+' ) \n') 
        f.write('( '+p4[3][0]+' '+p4[3][1]+' '+p4[3][2]+' ) \n') 
        f.write('\n')
        f.write('( '+p5[0][0]+' '+p5[0][1]+' '+p5[0][2]+' ) \n') 
        f.write('( '+p5[1][0]+' '+p5[1][1]+' '+p5[1][2]+' ) \n') 
        f.write('( '+p5[2][0]+' '+p5[2][1]+' '+p5[2][2]+' ) \n') 
        f.write('( '+p5[3][0]+' '+p5[3][1]+' '+p5[3][2]+' ) \n') 
        f.write('\n')
        f.write('( '+p6[0][0]+' '+p6[0][1]+' '+p6[0][2]+' ) \n') 
        f.write('( '+p6[1][0]+' '+p6[1][1]+' '+p6[1][2]+' ) \n') 
        f.write('( '+p6[2][0]+' '+p6[2][1]+' '+p6[2][2]+' ) \n') 
        f.write('( '+p6[3][0]+' '+p6[3][1]+' '+p6[3][2]+' ) \n') 
        f.write('\n')
        f.write(');\n')

        f.write('blocks\n')
        f.write('(\n')
        f.write('    hex ( 0  1  2  3  4  5  6  7) ('+domainNode[0]+' '+domainNode[1]+' 35) simpleGrading (1 1 0.049)\n')
        f.write('    hex ( 4  5  6  7  8  9 10 11) ('+domainNode[0]+' '+domainNode[1]+' 10) simpleGrading (1 1 0.80)\n')
        f.write('    hex ( 8  9 10 11 12 13 14 15) ('+domainNode[0]+' '+domainNode[1]+' 06) simpleGrading (1 1 1)\n')
        f.write('    hex (12 13 14 15 16 17 18 19) ('+domainNode[0]+' '+domainNode[1]+' 08) simpleGrading (1 1 1.5)\n')
        f.write('    hex (16 17 18 19 20 21 22 23) ('+domainNode[0]+' '+domainNode[1]+' 08) simpleGrading (1 1 1.20)\n')
        f.write(');\n')
        f.write('edges\n')
        f.write('(\n')
        f.write(');\n')
        f.write('boundary\n')
        f.write('(\n')
        f.write('    atmosphere\n')
        f.write('    {\n')
        f.write('        type symmetry;\n')
        f.write('        faces\n')
        f.write('        (\n')
        f.write('            (20 21 22 23)\n')
        f.write('        );\n')
        f.write('    }\n')
        f.write('    inlet\n')
        f.write('    {\n')
        f.write('        type patch;\n')
        f.write('        faces\n')
        f.write('        (\n')
        f.write('            ( 0  4  7  3)\n')
        f.write('            ( 4  8 11  7)\n')
        f.write('            ( 8 12 15 11)\n')
        f.write('            (12 16 19 15)\n')
        f.write('            (16 20 23 19)\n')
        f.write('        );\n')
        f.write('    }\n')
        f.write('    outlet\n')
        f.write('    {\n')
        f.write('        type patch;\n')
        f.write('        faces\n')
        f.write('        (\n')
        f.write('            ( 1  2  6  5)\n')
        f.write('            ( 5  6 10  9)\n')
        f.write('            ( 9 10 14 13)\n')
        f.write('            (13 14 18 17)\n')
        f.write('            (17 18 22 21)\n')
        f.write('        );\n')
        f.write('    }\n')
        f.write('    bottom\n')
        f.write('    {\n')
        f.write('        type symmetry;\n')
        f.write('        faces\n')
        f.write('        (\n')
        f.write('            (0 3 2 1)\n')
        f.write('        );\n')
        f.write('    }\n')
        f.write('    side\n')
        f.write('    {\n')
        f.write('        type symmetry;\n')
        f.write('        faces\n')
        f.write('        (\n')
        f.write('            ( 0  1  5  4)\n')
        f.write('            ( 4  5  9  8)\n')
        f.write('            ( 8  9 13 12)\n')
        f.write('            (12 13 17 16)\n')
        f.write('            (16 17 21 20)\n')
        f.write('        );\n')
        f.write('    }\n')
        f.write('    midPlane\n')
        f.write('    {\n')
        f.write('        type symmetry;\n')
        f.write('        faces\n')
        f.write('        (\n')
        f.write('            ( 3  7  6  2)\n')
        f.write('            ( 7 11 10  6)\n')
        f.write('            (11 15 14 10)\n')
        f.write('            (15 19 18 14)\n')
        f.write('            (19 23 22 18)\n')
        f.write('        );\n')
        f.write('    }\n')
        f.write('); \n')
        f.write('mergePatchPairs\n')
        f.write('(\n')
        f.write(');\n')
        f.close()       
    #-------------------------------------------------------------------------------------------------
    def makeTopoSetDict(self,topo,filename):
        f=open(self.caseDir+'/system/'+filename,'w')
        f.write('/*--------------------------------*- C++ -*----------------------------------*\ \n')
        f.write('| =========                 |                                                 | \n')
        f.write('| \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox           | \n')
        f.write('|  \\    /   O peration     | Version:  2.3.x                                 | \n')
        f.write('|   \\  /    A nd           | Web:      www.OpenFOAM.org                      | \n')
        f.write('|    \\/     M anipulation  |                                                 | \n')
        f.write('\*---------------------------------------------------------------------------*/ \n')
        f.write('FoamFile \n')
        f.write('{ \n')
        f.write('    version     2.0; \n')
        f.write('    format      ascii; \n')
        f.write('    class       dictionary; \n')
        f.write('    object      topoSetDict; \n')
        f.write('} \n')
        f.write('// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * // \n')
        f.write('actions\n')
        f.write('(\n')
        f.write('    {\n')
        f.write('        name    c0;\n')
        f.write('        type    cellSet;\n')
        f.write('        action  new;\n')
        f.write('        source  boxToCell;\n')
        f.write('        sourceInfo\n')
        f.write('        {\n')
        f.write('//          box (-1.25L 0.00 -6.0D) (0.6L 0.7L 6.0FB);\n')
        f.write('            box ('+topo[0]+' '+topo[1]+' '+topo[2]+') ('+topo[3]+' '+topo[4]+' '+topo[5]+');\n')
        f.write('        }\n')
        f.write('    }\n')
        f.write(');\n')
        f.close() 
    #---------------------------------------------------------------------------------------------------------
    def sizeLevel(self,mainwindow):
    
        def setLevel(widget):
            f=open(self.caseDir+'/system/settings/surfaceLevel.txt','w')
            f1=open(self.caseDir+'/system/settings/featureLevel.txt','w')
            for i in range(len(surfaceName)):
                f.write(surfaceName[i]+' '+faceLevel[i].get_text()+'\n')
            for j in range(len(featureName)):
                f1.write(featureName[j]+' '+featureLevel[j].get_text()+'\n')
            f.close();f1.close()
            window1.destroy()
            
        def closethis(widget):
            window1.destroy()	
            
        window1=gtk.Window(gtk.WINDOW_TOPLEVEL);window1.set_title('Size Level')
        window1.set_border_width(5);window1.set_position(gtk.WIN_POS_CENTER)
        window1.set_transient_for(mainwindow)
        mainbox=gtk.VBox(False,5);window1.add(mainbox)
        mainbox1=gtk.HBox(False,5);mainbox.pack_start(mainbox1,False,False,5)
        
        lbox=gtk.VBox(False,5);rbox=gtk.VBox(False,5)
        mainbox1.pack_start(lbox,False,False,5);mainbox1.pack_start(rbox,False,False,5)
        ibox1=gtk.HBox(False,5);lbox.pack_start(ibox1,False,False,5)        
        label=gtk.Label('Surface Level');ibox1.pack_start(label,False,False,5)
        ibox2=gtk.HBox(False,5);rbox.pack_start(ibox2,False,False,5)        
        label=gtk.Label('Feature Level');ibox2.pack_start(label,False,False,5)
        
        stl1=glob.glob(self.caseDir+'/constant/triSurface/*.stl');stl2=glob.glob(self.caseDir+'/constant/triSurface/*.STL')
        geometrySTLFile=stl1+stl2
        surfaceName=[];surfaceNameOri=[]
        for i in range(len(geometrySTLFile)):
            aa=geometrySTLFile[i].split('/');surfaceName.append(aa[-1])
            
        swin1=gtk.ScrolledWindow();swin1.set_border_width(5);swin1.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_ALWAYS)
        lbox.pack_start(swin1,True,True,5);itembox1=gtk.VBox(False,0);swin1.add_with_viewport(itembox1)
        scheight=len(surfaceName)*45
        if scheight > 750:scheight=750        
        swin1.set_size_request(260,scheight)
        
        faceName=[];faceLevel=[]
        for i in range(len(surfaceName)):
            hbox1=gtk.HBox(False,5);itembox1.pack_start(hbox1,False,False,2)                
            faceName.append(gtk.Entry());faceName[i].set_size_request(200,28);faceName[i].set_text(surfaceName[i])
            faceLevel.append(gtk.Entry());faceLevel[i].set_size_request(40,28)
            firstOr=glob.glob(self.caseDir+'/system/settings/surfaceLevel.txt')
            if len(firstOr)==0:
                faceLevel[i].set_text('3')
            else:
                f=open(firstOr[0],'r');ff=f.readlines();f.close()
                if len(surfaceName)==len(ff):
                    aa=ff[i][:-1].split(' ')
                    faceLevel[i].set_text(aa[-1])
                else:faceLevel[i].set_text('3')
            hbox1.pack_start(faceName[i],False,False,0);hbox1.pack_start(faceLevel[i],False,False,0)
            
        featureNameOri=geometrySTLFile;featureName=[]
        for ii in range(len(featureNameOri)):
            aa=featureNameOri[ii].split('/');featureName.append(aa[-1])
            
        swin2=gtk.ScrolledWindow();swin2.set_border_width(5);swin2.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_ALWAYS)
        rbox.pack_start(swin2,True,True,5);itembox2=gtk.VBox(False,0);swin2.add_with_viewport(itembox2)
        scheight=len(featureName)*45
        if scheight > 750:scheight=750        
        swin2.set_size_request(260,scheight)
        
        fName=[];featureLevel=[]
        
        for i in range(len(featureName)):
            hbox2=gtk.HBox(False,5);itembox2.pack_start(hbox2,False,False,2)                
            fName.append(gtk.Entry());fName[i].set_size_request(200,28);fName[i].set_text(featureName[i])
            featureLevel.append(gtk.Entry());featureLevel[i].set_size_request(40,28)
            firstOr=glob.glob(self.caseDir+'/system/settings/featureLevel.txt')
            if len(firstOr)==0:
                featureLevel[i].set_text('3')
            else:
                f=open(firstOr[0],'r');fff=f.readlines();f.close()
                if len(featureName)==len(fff):
                    aaa=fff[i].split()
                    featureLevel[i].set_text(aaa[-1])	
                else:featureLevel[i].set_text('3')
            hbox2.pack_start(fName[i],False,False,0)
            hbox2.pack_start(featureLevel[i],False,False,0)
            
        hbox2=gtk.HBox(False,5);mainbox.pack_start(hbox2,False,False,5)
        app=gtk.Button(label='Apply');app.set_size_request(150,28)
        cll=gtk.Button(label='Cancel');cll.set_size_request(150,28)
        app.connect('clicked',setLevel);cll.connect('clicked',closethis)
        hbox2.pack_end(cll,False,False,5);hbox2.pack_end(app,False,False,5)  
        
        window1.show_all()  
    #-------------------------------------------------------------------------------------------------
    def makeFeatureFile(self,stlfiles,featureAngle):
        f=open(self.caseDir+'/system/surfaceFeatureExtractDict','w')
        f.write('/*--------------------------------*- C++ -*----------------------------------*\ \n')
        f.write('| =========                 |                                                 | \n')
        f.write('| \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox           | \n')
        f.write('|  \\    /   O peration     | Version:  2.3.x                                 | \n')
        f.write('|   \\  /    A nd           | Web:      www.OpenFOAM.org                      | \n')
        f.write('|    \\/     M anipulation  |                                                 | \n')
        f.write('\*---------------------------------------------------------------------------*/ \n')
        f.write('FoamFile \n')
        f.write('{ \n')
        f.write('    version     2.0; \n')
        f.write('    format      ascii; \n')
        f.write('    class       dictionary; \n')
        f.write('    object      surfaceFeatureExtractDict; \n')
        f.write('} \n')
        f.write('// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * // \n')

        for i in range(len(stlfiles)):
	    f.write(stlfiles[i]+'\n')
	    f.write('{ \n')
	    f.write('    extractionMethod    extractFromSurface;\n')
	    f.write('    extractFromSurfaceCoeffs \n')
	    f.write('    {\n')
	    f.write('        includedAngle   '+featureAngle+';\n')
	    f.write('    }\n')
	    f.write('    subsetFeatures\n')
	    f.write('    {\n')
	    f.write('        nonManifoldEdges    yes;\n')
	    f.write('        openEdges           yes;\n')
	    f.write('    }\n')
	    f.write('    writeObj                yes; \n')
	    f.write('}\n')

        f.close()                     
    #-------------------------------------------------------------------------------------------------
    def makeSnappyFileVOF(self,generalMesh,casMesh,snapMesh,layerMesh,surfNfeat,refinebox,advdic):
        #generalMesh=[casSnapLayer,startFrom,nCore,hostfilename]
        #casMesh=[locationInMesh,minRefinementCells,nCellsBetweenLevels]
        #snapMesh=[nSmoothPatch,tolerance,nSolveIter,nRelaxIter,nFeatureSnapIter]
        #layerMesh=[relativeSizes,layers,expansionRatio,minThickness,finalLayerThickness,featureAngle]
        #surfNfeat=[stlfiles,featuresizelevel,surfacesizelevel]
        ##surfNfeat=[stlfiles,featuresizelevel,surfacesizelevel]
        #refinebox : dictionary, key is box-**.txt, value is list by readlines
        #advancedValue=[casAdv,snapAdv,layerAdv,qltAdv]

        f=open(self.caseDir+'/system/snappyHexMeshDict','w')
        f.write('/*--------------------------------*- C++ -*----------------------------------*\ \n')
        f.write('| =========                 |                                                 | \n')
        f.write('| \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox           | \n')
        f.write('|  \\    /   O peration     | Version:  2.3.x                                 | \n')
        f.write('|   \\  /    A nd           | Web:      www.OpenFOAM.org                      | \n')
        f.write('|    \\/     M anipulation  |                                                 | \n')
        f.write('\*---------------------------------------------------------------------------*/ \n')
        f.write('FoamFile \n')
        f.write('{ \n')
        f.write('    version     2.0; \n')
        f.write('    format      ascii; \n')
        f.write('    class       dictionary; \n')
        f.write('    object      snappyHexMeshDict; \n')
        f.write('} \n')
        f.write('// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * // \n')

        f.write('castellatedMesh '+generalMesh[0][0]+';\n')
        f.write('snap            '+generalMesh[0][1]+';\n')
        f.write('addLayers       '+generalMesh[0][2]+';\n')

        f.write('geometry \n')
        f.write('{ \n')

        surfaces=surfNfeat[0];featuresizelevel=surfNfeat[1];surfacesizelevel=surfNfeat[2]

        for i in range(len(surfaces)):
            f.write('    '+surfaces[i]+'\n')
            f.write('    { \n')
            f.write('        type    triSurfaceMesh;\n')
            f.write('        name    hull;\n')
            f.write('        patchInfo\n')
            f.write('        {\n')
            f.write('            type    wall;\n')
            f.write('        }\n')
            f.write('    } \n')

        rkey=refinebox.keys();boxlevel={}
        if len(rkey)!=0:
            for i in range(len(rkey)):
                boxname=rkey[i][:-4]
                row1=refinebox[rkey[i]][0];row2=refinebox[rkey[i]][1]
                mini=row1[:-1].split(' ');maxi=row2[:-1].split(' ')
                f.write('    '+boxname+'\n')
                f.write('    {\n')
                f.write('        type    searchableBox;\n')
                f.write('        min     ('+mini[0]+' '+mini[1]+' '+mini[2]+');\n')
                f.write('        max     ('+maxi[0]+' '+maxi[1]+' '+maxi[2]+');\n')	
                f.write('    }\n')
        f.write('}; \n')

        f.write('castellatedMeshControls \n')
        f.write('{ \n')
        f.write('    maxLocalCells '+advdic['maxLocalCells']+';\n')
        f.write('    maxGlobalCells '+advdic['maxGlobalCells']+';\n')
        f.write('    minRefinementCells '+casMesh[1]+';\n')
        f.write('    nCellsBetweenLevels '+casMesh[2]+';\n')

        f.write('    features\n')
        f.write('    (\n')
        for i in range(len(surfaces)):
            sss=surfaces[i][:-4]
            f.write('        {  file "'+sss+'.eMesh";          levels ((0.01 '+surfNfeat[1][i]+'));     } \n')
            #f.write('        {  file "'+sss+'.eMesh";          levels (('+surfNfeat[1][i]+' '+surfNfeat[1][i]+'));     } \n')
        f.write('    );\n')

        f.write('    refinementSurfaces \n')
        f.write('    { \n')
        for i in range(len(surfaces)):
            f.write('        hull\n')
            f.write('        {\n')
            f.write('            level ('+surfacesizelevel[i]+' '+surfacesizelevel[i]+');\n')
            #f.write('            level (2 '+surfacesizelevel[i]+');\n')
            f.write('        } \n')
        f.write('    }\n')
        #---------------------------------------
        f.write('    resolveFeatureAngle '+advdic['resolveFeatureAngle']+';\n')

        f.write('    refinementRegions\n')
        f.write('    {\n')
        if len(rkey)!=0:
            for i in range(len(rkey)):
                boxname=rkey[i][:-4]
                row3=refinebox[rkey[i]][2];boxlevel=row3[:-1]
                f.write('    '+boxname+'\n')
                f.write('        {\n')
                f.write('            mode    inside;\n')
                f.write('            levels  ((1E15 '+boxlevel+'));\n')
                f.write('        }\n')
        f.write('    }\n')

        f.write('    locationInMesh ('+casMesh[0][0]+' '+casMesh[0][1]+' '+casMesh[0][2]+');\n')
        f.write('    allowFreeStandingZoneFaces '+advdic['allowFreeStandingZoneFaces']+';\n')
        f.write('}\n')
        f.write('\n')

        f.write('snapControls\n')
        f.write('{\n')
        f.write('    nSmoothPatch '+snapMesh[0]+';\n')
        f.write('    tolerance '+snapMesh[1]+';\n')
        f.write('    nSolveIter '+snapMesh[2]+';\n')
        f.write('    nRelaxIter '+snapMesh[3]+';\n')
        f.write('    nFeatureSnapIter '+snapMesh[4]+';\n')
        f.write('    implicitFeatureSnap '+advdic['implicitFeatureSnap']+';\n')
        f.write('    explicitFeatureSnap '+advdic['explicitFeatureSnap']+';\n')
        f.write('    multiRegionFeatureSnap '+advdic['multiRegionFeatureSnap']+';\n')
        f.write('}\n')
        f.write('\n')

        f.write('addLayersControls\n')
        f.write('{\n')
        f.write('    relativeSizes '+layerMesh[0]+';\n')
        f.write('    layers\n')
        f.write('    {\n')
        for i in range(len(surfaces)):
            f.write('        hull\n')
            f.write('        { \n')
            f.write('            nSurfaceLayers '+layerMesh[1]+';\n')
            f.write('        } \n')
        f.write('    }\n')

        f.write('    expansionRatio            '+layerMesh[2]+';\n')
        f.write('    firstLayerThickness       '+layerMesh[4]+';\n')
        f.write('    minThickness              '+layerMesh[3]+';\n')
        f.write('    nGrow                     '+advdic['nGrow']+';\n')
        f.write('    featureAngle              '+layerMesh[5]+';\n')
        f.write('    nRelaxIter                '+advdic['nRelaxIter']+';\n')
        f.write('    nSmoothSurfaceNormals     '+advdic['nSmoothSurfaceNormals']+';\n')
        f.write('    nSmoothNormals            '+advdic['nSmoothNormals']+';\n')
        f.write('    nSmoothThickness          '+advdic['nSmoothThickness']+';\n')
        f.write('    maxFaceThicknessRatio     '+advdic['maxFaceThicknessRatio']+';\n')
        f.write('    maxThicknessToMedialRatio '+advdic['maxThicknessToMedialRatio']+';\n')
        f.write('    minMedianAxisAngle        '+advdic['minMedianAxisAngle']+';\n')
        f.write('    nBufferCellsNoExtrude     '+advdic['nBufferCellsNoExtrude']+';\n')
        f.write('    nLayerIter                '+advdic['nLayerIter']+';\n')
        #f.write('    nRelaxedIter            '+advdic['nRelaxedIter']+';\n')
        f.write('}\n')
        f.write('\n')

        f.write('meshQualityControls\n')
        f.write('{\n')
        f.write('    maxNonOrtho           '+advdic['maxNonOrtho']+';\n')
        f.write('    maxBoundarySkewness   '+advdic['maxBoundarySkewness']+';\n')
        f.write('    maxInternalSkewness   '+advdic['maxInternalSkewness']+';\n')
        f.write('    maxConcave            '+advdic['maxConcave']+';\n')
        f.write('    minVol                '+advdic['minVol']+';\n')
        f.write('    minTetQuality         '+advdic['minTetQuality']+';\n')
        f.write('    minArea               '+advdic['minArea']+';\n')
        f.write('    minTwist              '+advdic['minTwist']+';\n')
        f.write('    minDeterminant        '+advdic['minDeterminant']+';\n')
        f.write('    minFaceWeight         '+advdic['minFaceWeight']+';\n')
        f.write('    minVolRatio           '+advdic['minVolRatio']+';\n')
        f.write('    minTriangleTwist      '+advdic['minTriangleTwist']+';\n')
        f.write('\n')

        f.write('    nSmoothScale   '+advdic['nSmoothScale']+';\n')
        f.write('    errorReduction '+advdic['errorReduction']+';\n')
        f.write('    relaxed\n')
        f.write('    {\n')
        f.write('        maxNonOrtho  '+advdic['maxNonOrtho']+';\n')
        f.write('    }\n')
        f.write('}\n')
        f.write('\n')

        f.write('debug '+advdic['debug']+';\n')
        f.write('mergeTolerance '+advdic['mergeTolerance']+';\n')

        f.close()
    #-------------------------------------------------------------------------------------------------
    def refineMeshDict(self):
        f=open(self.caseDir+'/system/refineMeshDict','w')
        f.write('FoamFile \n')
        f.write('{\n')
        f.write('    version     2.0;\n')
        f.write('    format      ascii;\n')
        f.write('    class       dictionary;\n')
        f.write('    location    "system";\n')
        f.write('    object      refineMeshDict;\n')
        f.write('}\n')
        f.write('// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //\n')
        f.write('set             c0;\n')
        f.write('\n')
        f.write('coordinateSystem global;\n')
        f.write('globalCoeffs\n')
        f.write('{\n')
        f.write('    tan1            ( 1 0 0 );\n')
        f.write('    tan2            ( 0 1 0 );\n')
        f.write('}\n')
        f.write('patchLocalCoeffs\n')
        f.write('{\n')
        f.write('    patch           outside;\n')
        f.write('    tan1            ( 1 0 0 );\n')
        f.write('}\n')
        f.write('directions      ( tan1 tan2 );\n')
        f.write('useHexTopology  no;\n')
        f.write('geometricCut    yes;\n')
        f.write('writeMesh       no;\n')
        f.close()              
    #---------------------------------------------------------------------------------------------------------
    def advancedSetup(self,mainwindow):
    
        def advSetup(widget):
            advdict={}            
            advdict['maxLocalCells']=mLCEntry.get_text();advdict['maxGlobalCells']=mGCEntry.get_text()
            advdict['resolveFeatureAngle']=refeaEntry.get_text();advdict['allowFreeStandingZoneFaces']=allowEntry.get_text()            
            advdict['implicitFeatureSnap']=implicitEntry.get_text();advdict['explicitFeatureSnap']=explicitEntry.get_text()
            advdict['multiRegionFeatureSnap']=multiEntry.get_text();advdict['nGrow']=growEntry.get_text()
            advdict['nRelaxIter']=relaxEntry.get_text();advdict['nSmoothSurfaceNormals']=nSSNEntry.get_text()
            advdict['nSmoothNormals']=nSNEntry.get_text();advdict['nSmoothThickness']=nSTEntry.get_text()
            advdict['maxFaceThicknessRatio']=mFTREntry.get_text();advdict['maxThicknessToMedialRatio']=mTMREntry.get_text()
            advdict['minMedianAxisAngle']=mMAAEntry.get_text();advdict['nBufferCellsNoExtrude']=nBCNEEntry.get_text()
            advdict['nLayerIter']=nLIEntry.get_text();advdict['nRelaxedIter']=nRIEntry.get_text()
            advdict['maxNonOrtho']=qlt1Entry.get_text();advdict['maxBoundarySkewness']=qlt2Entry.get_text()
            advdict['maxInternalSkewness']=qlt3Entry.get_text();advdict['maxConcave']=qlt4Entry.get_text()
            advdict['minVol']=qlt5Entry.get_text();advdict['minTetQuality']=qlt6Entry.get_text()
            advdict['minArea']=qlt7Entry.get_text();advdict['minTwist']=qlt8Entry.get_text()
            advdict['minDeterminant']=qlt9Entry.get_text();advdict['minFaceWeight']=qlt10Entry.get_text()
            advdict['minVolRatio']=qlt11Entry.get_text();advdict['minTriangleTwist']=qlt12Entry.get_text()
            advdict['nSmoothScale']=qlt13Entry.get_text();advdict['errorReduction']=qlt14Entry.get_text()
            advdict['relaxedmaxNonOrtho']=qlt15Entry.get_text();advdict['debug']=qlt16Entry.get_text()
            advdict['mergeTolerance']=qlt17Entry.get_text()

            keys=advdict.keys()            
            f=open(self.caseDir+'/system/settings/snappyAdvancedSetup','w')
            for ii in keys:f.write(ii+';'+advdict[ii]+'\n')
            f.close()

            window3.destroy()

        def closethis(widget):
            window3.destroy()
        
        def setSavedValue():
            aa=glob.glob(self.caseDir+'/system/settings/snappyAdvancedSetup')
            if len(aa)!=0:
                GEN=generalClass(self.caseDir)
                dic=GEN.makeDictFromFile(aa[0])                               
                mLCEntry.set_text(dic['maxLocalCells']);mGCEntry.set_text(dic['maxGlobalCells']);refeaEntry.set_text(dic['resolveFeatureAngle'])
                allowEntry.set_text(dic['allowFreeStandingZoneFaces'])
                implicitEntry.set_text(dic['implicitFeatureSnap']);explicitEntry.set_text(dic['explicitFeatureSnap'])
                multiEntry.set_text(dic['multiRegionFeatureSnap'])
                growEntry.set_text(dic['nGrow']);relaxEntry.set_text(dic['nRelaxIter']);nSSNEntry.set_text(dic['nSmoothSurfaceNormals'])
                nSNEntry.set_text(dic['nSmoothNormals']);nSTEntry.set_text(dic['nSmoothThickness']);mFTREntry.set_text(dic['maxFaceThicknessRatio'])
                mTMREntry.set_text(dic['maxThicknessToMedialRatio'])
                mMAAEntry.set_text(dic['minMedianAxisAngle']);nBCNEEntry.set_text(dic['nBufferCellsNoExtrude']);nLIEntry.set_text(dic['nLayerIter'])
                nRIEntry.set_text(dic['nRelaxedIter'])
                qlt1Entry.set_text(dic['maxNonOrtho']);qlt2Entry.set_text(dic['maxBoundarySkewness']);qlt3Entry.set_text(dic['maxInternalSkewness'])
                qlt4Entry.set_text(dic['maxConcave'])
                qlt5Entry.set_text(dic['minVol']);qlt6Entry.set_text(dic['minTetQuality']);qlt7Entry.set_text(dic['minArea'])
                qlt8Entry.set_text(dic['minTwist'])
                qlt9Entry.set_text(dic['minDeterminant']);qlt10Entry.set_text(dic['minFaceWeight']);qlt11Entry.set_text(dic['minVolRatio'])
                qlt12Entry.set_text(dic['minTriangleTwist'])
                qlt13Entry.set_text(dic['nSmoothScale']);qlt14Entry.set_text(dic['errorReduction']);qlt15Entry.set_text(dic['relaxedmaxNonOrtho'])
                qlt16Entry.set_text(dic['debug'])
                qlt17Entry.set_text(dic['mergeTolerance'])
            
            
        
        window3=gtk.Window(gtk.WINDOW_TOPLEVEL);window3.set_title('Advanced Setup')
        window3.set_border_width(5);window3.set_position(gtk.WIN_POS_CENTER)
        window3.set_transient_for(mainwindow)
        mainbox=gtk.VBox(False,5);window3.add(mainbox)     
        adTable=gtk.Table(4,2,False);mainbox.add(adTable)
        #----------------------
        Frame1=gtk.Frame();Frame1.set_label(' Castellate ');Frame1.set_label_align(0.1,0.5)
        Frame1.set_shadow_type(gtk.SHADOW_ETCHED_OUT)	    

        cBox=gtk.VBox(False,5);adTable.attach(cBox,0,1,0,1);cBox.pack_start(Frame1,False,False,5)	
        castelBox=gtk.VBox(False,5);Frame1.add(castelBox)

        chbox1=gtk.HBox(False,5);castelBox.pack_start(chbox1,False,False,0)
        label=gtk.Label(' maxLocalCells ')
        mLCEntry=gtk.Entry();mLCEntry.set_size_request(80,28);mLCEntry.set_text('20000000')
        chbox1.pack_start(label,False,False,5);chbox1.pack_end(mLCEntry,False,False,5)
        chbox2=gtk.HBox(False,5);castelBox.pack_start(chbox2,False,False,0)
        label=gtk.Label(' maxGlobalCells ')
        mGCEntry=gtk.Entry();mGCEntry.set_size_request(80,28);mGCEntry.set_text('20000000')
        chbox2.pack_start(label,False,False,5);chbox2.pack_end(mGCEntry,False,False,5)
        chbox3=gtk.HBox(False,5);castelBox.pack_start(chbox3,False,False,0)
        label=gtk.Label(' resolveFeatureAngle ')
        refeaEntry=gtk.Entry();refeaEntry.set_size_request(80,28);refeaEntry.set_text('30')
        chbox3.pack_start(label,False,False,5);chbox3.pack_end(refeaEntry,False,False,5)
        chbox4=gtk.HBox(False,5);castelBox.pack_start(chbox4,False,False,0)
        label=gtk.Label(' allowFreeStandingZoneFaces ')
        allowEntry=gtk.Entry();allowEntry.set_size_request(80,28);allowEntry.set_text('true')
        chbox4.pack_start(label,False,False,5);chbox4.pack_end(allowEntry,False,False,5)
        #------------------------
        Frame2=gtk.Frame();Frame2.set_label(' Snap ');Frame2.set_label_align(0.1,0.5)
        Frame2.set_shadow_type(gtk.SHADOW_ETCHED_OUT)	    

        sBox=gtk.VBox(False,5);adTable.attach(sBox,0,1,1,2);sBox.pack_start(Frame2,False,False,5)	
        snapBox=gtk.VBox(False,5);Frame2.add(snapBox)

        snbox1=gtk.HBox(False,5);snapBox.pack_start(snbox1,False,False,0)
        label=gtk.Label(' implicitFeatureSnap ')
        implicitEntry=gtk.Entry();implicitEntry.set_size_request(80,28);implicitEntry.set_text('false')
        snbox1.pack_start(label,False,False,5);snbox1.pack_end(implicitEntry,False,False,5)
        snbox2=gtk.HBox(False,5);snapBox.pack_start(snbox2,False,False,0)
        label=gtk.Label(' explicitFeatureSnap ')
        explicitEntry=gtk.Entry();explicitEntry.set_size_request(80,28);explicitEntry.set_text('true')
        snbox2.pack_start(label,False,False,5);snbox2.pack_end(explicitEntry,False,False,5)
        snbox3=gtk.HBox(False,5);snapBox.pack_start(snbox3,False,False,0)
        label=gtk.Label(' multiRegionFeatureSnap ')
        multiEntry=gtk.Entry();multiEntry.set_size_request(80,28);multiEntry.set_text('true')
        snbox3.pack_start(label,False,False,5);snbox3.pack_end(multiEntry,False,False,5)
        #------------------------
        Frame3=gtk.Frame();Frame3.set_label(' AddLayer ');Frame3.set_label_align(0.1,0.5)
        Frame3.set_shadow_type(gtk.SHADOW_ETCHED_OUT)	    

        aBox=gtk.VBox(False,5);adTable.attach(aBox,0,1,2,3);aBox.pack_start(Frame3,False,False,5)	
        layBox=gtk.VBox(False,5);Frame3.add(layBox)

        labox2=gtk.HBox(False,5);layBox.pack_start(labox2,False,False,0)
        label=gtk.Label(' nGrow ')
        growEntry=gtk.Entry();growEntry.set_size_request(80,28);growEntry.set_text('0')
        labox2.pack_start(label,False,False,5);labox2.pack_end(growEntry,False,False,5)
        labox3=gtk.HBox(False,5);layBox.pack_start(labox3,False,False,0)
        label=gtk.Label(' nRelaxIter ')
        relaxEntry=gtk.Entry();relaxEntry.set_size_request(80,28);relaxEntry.set_text('7')
        labox3.pack_start(label,False,False,5);labox3.pack_end(relaxEntry,False,False,5)
        labox4=gtk.HBox(False,5);layBox.pack_start(labox4,False,False,0)
        label=gtk.Label(' nSmoothSurfaceNormals ')
        nSSNEntry=gtk.Entry();nSSNEntry.set_size_request(80,28);nSSNEntry.set_text('30')
        labox4.pack_start(label,False,False,5);labox4.pack_end(nSSNEntry,False,False,5)
        labox5=gtk.HBox(False,5);layBox.pack_start(labox5,False,False,0)
        label=gtk.Label(' nSmoothNormals ')
        nSNEntry=gtk.Entry();nSNEntry.set_size_request(80,28);nSNEntry.set_text('10')
        labox5.pack_start(label,False,False,5);labox5.pack_end(nSNEntry,False,False,5)
        labox6=gtk.HBox(False,5);layBox.pack_start(labox6,False,False,0)
        label=gtk.Label(' nSmoothThickness ')
        nSTEntry=gtk.Entry();nSTEntry.set_size_request(80,28);nSTEntry.set_text('10')
        labox6.pack_start(label,False,False,5);labox6.pack_end(nSTEntry,False,False,5)
        labox7=gtk.HBox(False,5);layBox.pack_start(labox7,False,False,0)
        label=gtk.Label(' maxFaceThicknessRatio ')
        mFTREntry=gtk.Entry();mFTREntry.set_size_request(80,28);mFTREntry.set_text('0.5')
        labox7.pack_start(label,False,False,5);labox7.pack_end(mFTREntry,False,False,5)
        labox8=gtk.HBox(False,5);layBox.pack_start(labox8,False,False,0)
        label=gtk.Label(' maxThicknessToMedialRatio ')
        mTMREntry=gtk.Entry();mTMREntry.set_size_request(80,28);mTMREntry.set_text('0.3')
        labox8.pack_start(label,False,False,5);labox8.pack_end(mTMREntry,False,False,5)
        labox9=gtk.HBox(False,5);layBox.pack_start(labox9,False,False,0)
        label=gtk.Label(' minMedianAxisAngle ')
        mMAAEntry=gtk.Entry();mMAAEntry.set_size_request(80,28);mMAAEntry.set_text('90')
        labox9.pack_start(label,False,False,5);labox9.pack_end(mMAAEntry,False,False,5)
        labox10=gtk.HBox(False,5);layBox.pack_start(labox10,False,False,0)
        label=gtk.Label(' nBufferCellsNoExtrude ')
        nBCNEEntry=gtk.Entry();nBCNEEntry.set_size_request(80,28);nBCNEEntry.set_text('0')
        labox10.pack_start(label,False,False,5);labox10.pack_end(nBCNEEntry,False,False,5)
        labox11=gtk.HBox(False,5);layBox.pack_start(labox11,False,False,0)
        label=gtk.Label(' nLayerIter ')
        nLIEntry=gtk.Entry();nLIEntry.set_size_request(80,28);nLIEntry.set_text('10')
        labox11.pack_start(label,False,False,5);labox11.pack_end(nLIEntry,False,False,5)
        labox12=gtk.HBox(False,5);layBox.pack_start(labox12,False,False,0)
        label=gtk.Label(' nRelaxedIter ')
        nRIEntry=gtk.Entry();nRIEntry.set_size_request(80,28);nRIEntry.set_text('40')
        labox12.pack_start(label,False,False,5);labox12.pack_end(nRIEntry,False,False,5)
        #------------------------
        Frame4=gtk.Frame();Frame4.set_label(' meshQualityControls ');Frame4.set_label_align(0.1,0.5)
        Frame4.set_shadow_type(gtk.SHADOW_ETCHED_OUT)	    

        qBox=gtk.VBox(False,5);adTable.attach(qBox,1,2,0,3);qBox.pack_start(Frame4,False,False,5)	
        qltBox=gtk.VBox(False,5);Frame4.add(qltBox)

        qltBox1=gtk.HBox(False,5);qltBox.pack_start(qltBox1,False,False,0)
        label=gtk.Label(' maxNonOrtho ')
        qlt1Entry=gtk.Entry();qlt1Entry.set_size_request(80,28);qlt1Entry.set_text('75')
        qltBox1.pack_start(label,False,False,5);qltBox1.pack_end(qlt1Entry,False,False,5)
        qltBox2=gtk.HBox(False,5);qltBox.pack_start(qltBox2,False,False,0)
        label=gtk.Label(' maxBoundarySkewness ')
        qlt2Entry=gtk.Entry();qlt2Entry.set_size_request(80,28);qlt2Entry.set_text('20')
        qltBox2.pack_start(label,False,False,5);qltBox2.pack_end(qlt2Entry,False,False,5)
        qltBox3=gtk.HBox(False,5);qltBox.pack_start(qltBox3,False,False,0)
        label=gtk.Label(' maxInternalSkewness ')
        qlt3Entry=gtk.Entry();qlt3Entry.set_size_request(80,28);qlt3Entry.set_text('4')
        qltBox3.pack_start(label,False,False,5);qltBox3.pack_end(qlt3Entry,False,False,5)
        qltBox4=gtk.HBox(False,5);qltBox.pack_start(qltBox4,False,False,0)
        label=gtk.Label(' maxConcave ')
        qlt4Entry=gtk.Entry();qlt4Entry.set_size_request(80,28);qlt4Entry.set_text('80')
        qltBox4.pack_start(label,False,False,5);qltBox4.pack_end(qlt4Entry,False,False,5)
        qltBox5=gtk.HBox(False,5);qltBox.pack_start(qltBox5,False,False,0)
        label=gtk.Label(' minVol ')
        qlt5Entry=gtk.Entry();qlt5Entry.set_size_request(80,28);qlt5Entry.set_text('1e-13')
        qltBox5.pack_start(label,False,False,5);qltBox5.pack_end(qlt5Entry,False,False,5)
        qltBox6=gtk.HBox(False,5);qltBox.pack_start(qltBox6,False,False,0)
        label=gtk.Label(' minTetQuality ')
        qlt6Entry=gtk.Entry();qlt6Entry.set_size_request(80,28);qlt6Entry.set_text('1e-15')
        qltBox6.pack_start(label,False,False,5);qltBox6.pack_end(qlt6Entry,False,False,5)
        qltBox7=gtk.HBox(False,5);qltBox.pack_start(qltBox7,False,False,0)
        label=gtk.Label(' minArea ')
        qlt7Entry=gtk.Entry();qlt7Entry.set_size_request(80,28);qlt7Entry.set_text('-1')
        qltBox7.pack_start(label,False,False,5);qltBox7.pack_end(qlt7Entry,False,False,5)
        qltBox8=gtk.HBox(False,5);qltBox.pack_start(qltBox8,False,False,0)
        label=gtk.Label(' minTwist ')
        qlt8Entry=gtk.Entry();qlt8Entry.set_size_request(80,28);qlt8Entry.set_text('0.02')
        qltBox8.pack_start(label,False,False,5);qltBox8.pack_end(qlt8Entry,False,False,5)
        qltBox9=gtk.HBox(False,5);qltBox.pack_start(qltBox9,False,False,0)
        label=gtk.Label(' minDeterminant ')
        qlt9Entry=gtk.Entry();qlt9Entry.set_size_request(80,28);qlt9Entry.set_text('0.001')
        qltBox9.pack_start(label,False,False,5);qltBox9.pack_end(qlt9Entry,False,False,5)
        qltBox10=gtk.HBox(False,5);qltBox.pack_start(qltBox10,False,False,0)
        label=gtk.Label(' minFaceWeight ')
        qlt10Entry=gtk.Entry();qlt10Entry.set_size_request(80,28);qlt10Entry.set_text('0.05')
        qltBox10.pack_start(label,False,False,5);qltBox10.pack_end(qlt10Entry,False,False,5)
        qltBox11=gtk.HBox(False,5);qltBox.pack_start(qltBox11,False,False,0)
        label=gtk.Label(' minVolRatio ')
        qlt11Entry=gtk.Entry();qlt11Entry.set_size_request(80,28);qlt11Entry.set_text('0.01')
        qltBox11.pack_start(label,False,False,5);qltBox11.pack_end(qlt11Entry,False,False,5)
        qltBox12=gtk.HBox(False,5);qltBox.pack_start(qltBox12,False,False,0)
        label=gtk.Label(' minTriangleTwist ')
        qlt12Entry=gtk.Entry();qlt12Entry.set_size_request(80,28);qlt12Entry.set_text('-1')
        qltBox12.pack_start(label,False,False,5);qltBox12.pack_end(qlt12Entry,False,False,5)
        qltBox13=gtk.HBox(False,5);qltBox.pack_start(qltBox13,False,False,0)
        label=gtk.Label(' nSmoothScale ')
        qlt13Entry=gtk.Entry();qlt13Entry.set_size_request(80,28);qlt13Entry.set_text('4')
        qltBox13.pack_start(label,False,False,5);qltBox13.pack_end(qlt13Entry,False,False,5)
        qltBox14=gtk.HBox(False,5);qltBox.pack_start(qltBox14,False,False,0)
        label=gtk.Label(' errorReduction ')
        qlt14Entry=gtk.Entry();qlt14Entry.set_size_request(80,28);qlt14Entry.set_text('0.75')
        qltBox14.pack_start(label,False,False,5);qltBox14.pack_end(qlt14Entry,False,False,5)
        qltBox15=gtk.HBox(False,5);qltBox.pack_start(qltBox15,False,False,0)
        label=gtk.Label(' relaxedmaxNonOrtho ')
        qlt15Entry=gtk.Entry();qlt15Entry.set_size_request(80,28);qlt15Entry.set_text('75')
        qltBox15.pack_start(label,False,False,5);qltBox15.pack_end(qlt15Entry,False,False,5)
        qltBox16=gtk.HBox(False,5);qltBox.pack_start(qltBox16,False,False,0)
        label=gtk.Label(' debug ')
        qlt16Entry=gtk.Entry();qlt16Entry.set_size_request(80,28);qlt16Entry.set_text('0')
        qltBox16.pack_start(label,False,False,5);qltBox16.pack_end(qlt16Entry,False,False,5)
        qltBox17=gtk.HBox(False,5);qltBox.pack_start(qltBox17,False,False,0)
        label=gtk.Label(' mergeTolerance ')
        qlt17Entry=gtk.Entry();qlt17Entry.set_size_request(80,28);qlt17Entry.set_text('1e-6')
        qltBox17.pack_start(label,False,False,5);qltBox17.pack_end(qlt17Entry,False,False,5)

        setSavedValue()
        #-------------------
        bBox=gtk.VBox(False,5);adTable.attach(bBox,0,2,3,4)
        bhBox=gtk.HBox(False,5);bBox.pack_start(bhBox,False,False,5)
        appButton=gtk.Button(label='Apply');appButton.set_size_request(150,28)
        appButton.connect('clicked',advSetup)
        clButton=gtk.Button(label='Cancel');clButton.set_size_request(150,28)
        clButton.connect('clicked',closethis)

        bhBox.pack_end(clButton,False,False,5);bhBox.pack_end(appButton,False,False,5)

        window3.show_all()    
    #-------------------------------------------------------------------------------------------------
    def defaultSnappyAdvDict(self):  
    
        advdict={}            
        advdict['maxLocalCells']='20000000';advdict['maxGlobalCells']='20000000';advdict['resolveFeatureAngle']='30'
        advdict['allowFreeStandingZoneFaces']='true';advdict['implicitFeatureSnap']='false';advdict['explicitFeatureSnap']='true'
        advdict['multiRegionFeatureSnap']='true';advdict['nGrow']='0';advdict['nRelaxIter']='7'
        advdict['nSmoothSurfaceNormals']='30';advdict['nSmoothNormals']='10';advdict['nSmoothThickness']='10'
        advdict['maxFaceThicknessRatio']='0.5';advdict['maxThicknessToMedialRatio']='0.3';advdict['minMedianAxisAngle']='90'
        advdict['nBufferCellsNoExtrude']='0';advdict['nLayerIter']='10';advdict['nRelaxedIter']='40'
        advdict['maxNonOrtho']='75';advdict['maxBoundarySkewness']='20';advdict['maxInternalSkewness']='4'
        advdict['maxConcave']='80';advdict['minVol']='1e-13';advdict['minTetQuality']='1e-15'
        advdict['minArea']='-1';advdict['minTwist']='0.02';advdict['minDeterminant']='0.001'
        advdict['minFaceWeight']='0.05';advdict['minVolRatio']='0.01';advdict['minTriangleTwist']='-1'
        advdict['nSmoothScale']='4';advdict['errorReduction']='0.75';advdict['relaxedmaxNonOrtho']='75'
        advdict['debug']='0';advdict['mergeTolerance']='1e-6'   

        return advdict    	
            
            
            
            
