#-*-coding:utf8-*-
#############################################################################
# License                                                                       
#    This file is part of RESOS(RESistance Open Source CFD package).                                            
#
#    RESOS is free software; you can redistribute it and/or modify it
#    under the terms of the GNU General Public License as published by the
#    Free Software Foundation; either version 3 of the License, or (at your
#    option) any later version.
#
#    RESOS is distributed in the hope that it will be useful, but WITHOUT
#    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#    for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with RESOS.  If not, see <http://www.gnu.org/licenses/>.
#
# Description
#    - Class for VOF free-panel
#
# Author
#    NEXTFOAM Inc. All rights reserved.
##############################################################################

import os,math,sys;import pygtk;pygtk.require('2.0');import gtk;import glob

from generalSub import *
from boundaryConditionSub import *
from etcSub import *

class freepanelVOFClass:

    def delete_event(self,widget,event,data=None):
        print 'delete event occurred'
        return False

    def destroy(self,widget,data=None):
        self.Win.destroy()

    def __init__(self,caseDir,mainwindow,installpath):
        self.caseDir=caseDir
        self.mainwindow=mainwindow
        self.installpath=installpath
        self.openSubWindow=False

    def vofSetup(self,notebook,textbuffer):
        GEN=generalClass(self.caseDir);ETC=etcClass(self.caseDir,'interNFoam',self.installpath,1,1,1)

        def applythis(widget):            
            vofDict={}
            
            vofDict['nAlphaCorr']=self.nAlphaCorrEntry.get_text()            
            vofDict['nAlphaSubCycles']=self.nAlphaSubCyclesEntry.get_text()
            vofDict['cAlpha']=self.cAlphaEntry.get_text()            
            vofDict['icAlpha']=self.icAlphaEntry.get_text()
            
            aa=self.MULESCorrCombo.child;vofDict['MULESCorr']=aa.get_text()
            vofDict['nLimiterIter']=self.nLimiterIterEntry.get_text()
            aa=self.alphaApplyPrevCorrCombo.child;vofDict['alphaApplyPrevCorr']=aa.get_text()
            
            vofDict['minxEntry']=self.minxEntry.get_text()
            vofDict['minyEntry']=self.minyEntry.get_text()
            vofDict['minzEntry']=self.minzEntry.get_text()
            vofDict['maxxEntry']=self.maxxEntry.get_text()
            vofDict['maxyEntry']=self.maxyEntry.get_text()
            vofDict['maxzEntry']=self.maxzEntry.get_text()            

            if GEN.isNumber(vofDict['nAlphaCorr'])==False:GEN.makeDialog('Error!!! nAlphaCorr is not number')             
            if GEN.isNumber(vofDict['nAlphaSubCycles'])==False:GEN.makeDialog('Error!!! nAlphaSubCycles is not number')            
            if GEN.isNumber(vofDict['cAlpha'])==False:GEN.makeDialog('Error!!! cAlpha is not number')            
            if GEN.isNumber(vofDict['icAlpha'])==False:GEN.makeDialog('Error!!! icAlpha is not number')
            if GEN.isNumber(vofDict['nLimiterIter'])==False:GEN.makeDialog('Error!!! nLimiterIter is not number') 
            if GEN.isNumber(vofDict['minxEntry'])==False:GEN.makeDialog('Error!!! min. x is not number') 
            if GEN.isNumber(vofDict['minyEntry'])==False:GEN.makeDialog('Error!!! min. y is not number') 
            if GEN.isNumber(vofDict['minzEntry'])==False:GEN.makeDialog('Error!!! min. z is not number') 
            if GEN.isNumber(vofDict['maxxEntry'])==False:GEN.makeDialog('Error!!! max. x is not number') 
            if GEN.isNumber(vofDict['maxyEntry'])==False:GEN.makeDialog('Error!!! max. y is not number') 
            if GEN.isNumber(vofDict['maxzEntry'])==False:GEN.makeDialog('Error!!! max. z is not number')           
                        
            keys=vofDict.keys()
            f=open(self.caseDir+'/system/settings/vofSetup','w')
            for ii in keys:f.write(ii+';'+vofDict[ii]+'\n')         
            f.close()
            
            f=open(self.caseDir+'/system/fvSolutionAlpha','w')
            f.write('nAlphaCorr '+vofDict['nAlphaCorr']+';\n')
            f.write('nAlphaSubCycles '+vofDict['nAlphaSubCycles']+';\n')
            f.write('cAlpha '+vofDict['cAlpha']+';\n')
            f.write('icAlpha '+vofDict['icAlpha']+';\n')
            f.write('MULESCorr '+vofDict['MULESCorr']+';\n')
            f.write('nLimiterIter '+vofDict['nLimiterIter']+';\n')
            f.write('alphaApplyPrevCorr '+vofDict['alphaApplyPrevCorr']+';\n')
            f.close()
            
            setFieldsRangeMin='('+vofDict['minxEntry']+' '+vofDict['minyEntry']+' '+vofDict['minzEntry']+')'
            setFieldsRangeMax='('+vofDict['maxxEntry']+' '+vofDict['maxyEntry']+' '+vofDict['maxzEntry']+')'
            scalar='alpha.water'
            default='0'
            value='1'
            ETC.setFieldsDict(setFieldsRangeMin,setFieldsRangeMax,scalar,default,value)
            #------------            
            message='\n [  VOF Conditions are saved  ]\n' 
            message=message+'\n    - nAlphaCorr is '+vofDict['nAlphaCorr']+'\n'
            message=message+'\n    - nAlphaSubCycles is '+vofDict['nAlphaSubCycles']+'\n'
            message=message+'\n    - cAlpha is '+vofDict['cAlpha']+'\n'
            message=message+'\n    - icAlpha is '+vofDict['icAlpha']+'\n'
            message=message+'\n    - MULESCorr is '+vofDict['MULESCorr']+'\n'
            message=message+'\n    - nLimiterIter is '+vofDict['nLimiterIter']+'\n'
            message=message+'\n    - alphaApplyPrevCorr is '+vofDict['alphaApplyPrevCorr']+'\n'
            message=message+'\n    - Initial Water Level is ('+vofDict['minxEntry']+' '+vofDict['minyEntry']+' '+vofDict['minzEntry']+') ('+vofDict['maxxEntry']+' '+vofDict['maxyEntry']+' '+vofDict['maxzEntry']+')\n'

            enditer=textbuffer.get_end_iter()
            textbuffer.insert(enditer,message)
            notebook.set_current_page(0)  
                        
        def setSavedValue():
            fileName=self.caseDir+'/system/settings/vofSetup';aa=glob.glob(fileName)            
            if len(aa)!=0:
                GEN=generalClass(self.caseDir);dic=GEN.makeDictFromFile(fileName)
                self.nAlphaCorrEntry.set_text(dic['nAlphaCorr']);self.nAlphaSubCyclesEntry.set_text(dic['nAlphaSubCycles'])
                self.cAlphaEntry.set_text(dic['cAlpha']);self.icAlphaEntry.set_text(dic['icAlpha'])
                if dic['MULESCorr']=='yes':self.MULESCorrCombo.set_active(0) 
                else:self.MULESCorrCombo.set_active(1) 
                self.nLimiterIterEntry.set_text(dic['nLimiterIter']) 
                if dic['alphaApplyPrevCorr']=='yes':self.alphaApplyPrevCorrCombo.set_active(0) 
                else:self.alphaApplyPrevCorrCombo.set_active(1) 
                self.minxEntry.set_text(dic['minxEntry']) 
                self.minyEntry.set_text(dic['minyEntry']) 
                self.minzEntry.set_text(dic['minzEntry']) 
                self.maxxEntry.set_text(dic['maxxEntry']) 
                self.maxyEntry.set_text(dic['maxyEntry']) 
                self.maxzEntry.set_text(dic['maxzEntry']) 
                                            
                
        self.vofbox=gtk.VBox(False,5)
        label=gtk.Label();label.set_markup('<b>  VOF Setup  </b>')
        ebox=gtk.EventBox();self.vofbox.pack_start(ebox,True,True,0)
        label.set_alignment(0,0.5);label.set_size_request(50,45)
        ebox.modify_bg(gtk.STATE_NORMAL,gtk.gdk.color_parse('white'));ebox.add(label) 
        
        label=gtk.Label('nAlphaCorr');label.set_alignment(0,0.5)
        self.nAlphaCorrEntry=gtk.Entry();self.nAlphaCorrEntry.set_size_request(80,28);self.nAlphaCorrEntry.set_text('1')      
        hbox=gtk.HBox(False,5);self.vofbox.pack_start(hbox,False,False,5)
        hbox.pack_start(label,False,False,5);hbox.pack_end(self.nAlphaCorrEntry,False,False,5)

        label=gtk.Label('nAlphaSubCycles');label.set_alignment(0,0.5)
        self.nAlphaSubCyclesEntry=gtk.Entry();self.nAlphaSubCyclesEntry.set_size_request(80,28);self.nAlphaSubCyclesEntry.set_text('3')      
        hbox=gtk.HBox(False,5);self.vofbox.pack_start(hbox,False,False,5)
        hbox.pack_start(label,False,False,5);hbox.pack_end(self.nAlphaSubCyclesEntry,False,False,5)

        label=gtk.Label('cAlpha');label.set_alignment(0,0.5)
        self.cAlphaEntry=gtk.Entry();self.cAlphaEntry.set_size_request(80,28);self.cAlphaEntry.set_text('0.2')      
        hbox=gtk.HBox(False,5);self.vofbox.pack_start(hbox,False,False,5)
        hbox.pack_start(label,False,False,5);hbox.pack_end(self.cAlphaEntry,False,False,5)
        
        label=gtk.Label('icAlpha');label.set_alignment(0,0.5)
        self.icAlphaEntry=gtk.Entry();self.icAlphaEntry.set_size_request(80,28);self.icAlphaEntry.set_text('0')      
        hbox=gtk.HBox(False,5);self.vofbox.pack_start(hbox,False,False,5)
        hbox.pack_start(label,False,False,5);hbox.pack_end(self.icAlphaEntry,False,False,5)
        
        label=gtk.Label('MULESCorr');label.set_alignment(0,0.5)               
        self.MULESCorrCombo=gtk.combo_box_entry_new_text();self.MULESCorrCombo.set_size_request(80,28)
        self.MULESCorrCombo.append_text('yes');self.MULESCorrCombo.append_text('no')  
        self.MULESCorrCombo.set_active(0)
        hbox=gtk.HBox(False,5);self.vofbox.pack_start(hbox,False,False,5)
        hbox.pack_start(label,False,False,5);hbox.pack_end(self.MULESCorrCombo,False,False,5)   
        
        label=gtk.Label('nLimiterIter');label.set_alignment(0,0.5)
        self.nLimiterIterEntry=gtk.Entry();self.nLimiterIterEntry.set_size_request(80,28);self.nLimiterIterEntry.set_text('5')      
        hbox=gtk.HBox(False,5);self.vofbox.pack_start(hbox,False,False,5)
        hbox.pack_start(label,False,False,5);hbox.pack_end(self.nLimiterIterEntry,False,False,5)
        
        label=gtk.Label('alphaApplyPrevCorr');label.set_alignment(0,0.5)               
        self.alphaApplyPrevCorrCombo=gtk.combo_box_entry_new_text();self.alphaApplyPrevCorrCombo.set_size_request(80,28)
        self.alphaApplyPrevCorrCombo.append_text('yes');self.alphaApplyPrevCorrCombo.append_text('no')  
        self.alphaApplyPrevCorrCombo.set_active(0)
        hbox=gtk.HBox(False,5);self.vofbox.pack_start(hbox,False,False,5)
        hbox.pack_start(label,False,False,5);hbox.pack_end(self.alphaApplyPrevCorrCombo,False,False,5)
        
        separator=gtk.HSeparator();separator.set_size_request(285,5);self.vofbox.pack_start(separator,False,True,10)

        label=gtk.Label('Initial Water Level');label.set_alignment(0,0.5)
        hbox=gtk.HBox(False,5);self.vofbox.pack_start(hbox,False,False,5)
        hbox.pack_start(label,False,False,5)

        label=gtk.Label('min.');label.set_alignment(0,0.5)
        self.minxEntry=gtk.Entry();self.minxEntry.set_size_request(60,28);self.minxEntry.set_text('-100')
        self.minyEntry=gtk.Entry();self.minyEntry.set_size_request(60,28);self.minyEntry.set_text('-100')
        self.minzEntry=gtk.Entry();self.minzEntry.set_size_request(60,28);self.minzEntry.set_text('-100')

        hbox=gtk.HBox(False,5);self.vofbox.pack_start(hbox,False,False,5)
        hbox.pack_end(self.minzEntry,False,False,5);hbox.pack_end(self.minyEntry,False,False,5);hbox.pack_end(self.minxEntry,False,False,5)
        hbox.pack_end(label,False,False,5)
        
        label=gtk.Label('max.');label.set_alignment(0,0.5)
        self.maxxEntry=gtk.Entry();self.maxxEntry.set_size_request(60,28);self.maxxEntry.set_text('100')
        self.maxyEntry=gtk.Entry();self.maxyEntry.set_size_request(60,28);self.maxyEntry.set_text('100')
        self.maxzEntry=gtk.Entry();self.maxzEntry.set_size_request(60,28);self.maxzEntry.set_text('0')
              
        hbox=gtk.HBox(False,5);self.vofbox.pack_start(hbox,False,False,5)
        hbox.pack_end(self.maxzEntry,False,False,5);hbox.pack_end(self.maxyEntry,False,False,5);hbox.pack_end(self.maxxEntry,False,False,5)
        hbox.pack_end(label,False,False,5)
        
        #self.setFieldsB=gtk.Button('setFields');self.setFieldsB.set_size_request(100,28)
        #self.setFieldsB.connect('clicked',setFields)
        #hbox=gtk.HBox(False,5);self.vofbox.pack_start(hbox,False,False,5)
        #hbox.pack_end(self.setFieldsB,False,False,5)


        hbox=gtk.HBox(False,5);self.vofbox.pack_start(hbox,False,False,5)
        self.rhoAppB=gtk.Button('Apply');hbox.pack_end(self.rhoAppB,True,True,5)
        self.rhoAppB.connect('clicked',applythis)
        
        setSavedValue()

        return self.vofbox



