#-*-coding:utf8-*-
#############################################################################
# License                                                                       
#    This file is part of RESOS(RESistance Open Source CFD package).                                            
#
#    RESOS is free software; you can redistribute it and/or modify it
#    under the terms of the GNU General Public License as published by the
#    Free Software Foundation; either version 3 of the License, or (at your
#    option) any later version.
#
#    RESOS is distributed in the hope that it will be useful, but WITHOUT
#    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#    for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with RESOS.  If not, see <http://www.gnu.org/licenses/>.
#
# Description
#    - Class for fvSolution free-panel
#
# Author
#    NEXTFOAM Inc. All rights reserved.
##############################################################################

import os,math,sys;import pygtk;pygtk.require('2.0');import gtk;import glob

from generalSub import *
from boundaryConditionSub import *
from writeFileSub import *
from VTKStuffClass import *

class freepanelFvSolutionClass:

    def delete_event(self,widget,event,data=None):
        print 'delete event occurred'
        return False

    def destroy(self,widget,data=None):
        self.Win.destroy()

    def __init__(self,caseDir,mainwindow):
        self.caseDir=caseDir
        self.mainwindow=mainwindow
        self.openSubWindow=False

    def fvSolution(self,notebook,textbuffer):
    
        GEN=generalClass(self.caseDir);WFILE=writeFileClass(self.caseDir)
        
        aa=glob.glob(self.caseDir+'/system/settings/operatingConditions')
        if len(aa)!=0:
            opdic=GEN.makeDictFromFile(aa[0])
            if opdic['useRefLocation']=='true':
                refpoint=1
                refx=opdic['refXLocation'];refy=opdic['refYLocation'];refz=opdic['refZLocation']
            else:
                refpoint=0;refx='0';refy='0';refz='0'
            refValue=opdic['opCondition']
        else:
            refpoint=0;refx='0';refy='0';refz='0';refValue='0'
            refValue='0'
    
        def psolverAdv(widget):
            if self.openSubWindow==False:
                aa=psolverCombo.child;psolver=aa.get_text()
                self.psolverAdv(psolver)
            
        def usolverAdv(widget):
            if self.openSubWindow==False:
                aa=usolverCombo.child;usolver=aa.get_text()
                self.usolverAdv(usolver)
            
        def tursolverAdv(widget):
            if self.openSubWindow==False:
                aa=tursolverCombo.child;tursolver=aa.get_text()
                self.tursolverAdv(tursolver)
            
        def ysolverAdv(widget):
            if self.openSubWindow==False:
                aa=ysolverCombo.child;ysolver=aa.get_text()
                self.ysolverAdv(ysolver)
            
        def applythis(widget):
            GEN=generalClass(self.caseDir)
            fvSolutionDict={}
            aa=psolverCombo.child;fvSolutionDict['psolver']=aa.get_text()
            fvSolutionDict['ptolerance']=ptolEntry.get_text()
            fvSolutionDict['prelTol']=preltolEntry.get_text()
            aa=usolverCombo.child;fvSolutionDict['usolver']=aa.get_text()
            fvSolutionDict['utolerance']=utolEntry.get_text()
            fvSolutionDict['urelTol']=ureltolEntry.get_text()
            aa=tursolverCombo.child;fvSolutionDict['tursolver']=aa.get_text()
            fvSolutionDict['turtolerance']=turtolEntry.get_text()
            fvSolutionDict['turrelTol']=turreltolEntry.get_text()
            aa=ysolverCombo.child;fvSolutionDict['ysolver']=aa.get_text()
            fvSolutionDict['ytolerance']=ytolEntry.get_text()
            fvSolutionDict['yrelTol']=yreltolEntry.get_text()
            fvSolutionDict['nNonOrtho']=nonorthoEntry.get_text()
            fvSolutionDict['nOuterCorrectors']=noutEntry.get_text()
            fvSolutionDict['nCorrectors']=ncorrEntry.get_text()
            fvSolutionDict['maxCo']=maxCoEntry.get_text()
            fvSolutionDict['maxAlphaCo']=maxAlphaCoEntry.get_text()
            fvSolutionDict['relaxp']=prelaxEntry.get_text()
            fvSolutionDict['relaxu']=urelaxEntry.get_text()
            fvSolutionDict['relaxtur']=turrelaxEntry.get_text()

            if GEN.isNumber(fvSolutionDict['ptolerance'])==False:GEN.makeDialog('Error!!! ptolerance is not number')            
            if GEN.isNumber(fvSolutionDict['prelTol'])==False:GEN.makeDialog('Error!!! prelTol is not number')            
            if GEN.isNumber(fvSolutionDict['utolerance'])==False:GEN.makeDialog('Error!!! utolerance is not number')            
            if GEN.isNumber(fvSolutionDict['urelTol'])==False:GEN.makeDialog('Error!!! urelTol is not number')            
            if GEN.isNumber(fvSolutionDict['turtolerance'])==False:GEN.makeDialog('Error!!! turtolerance is not number')                        
            if GEN.isNumber(fvSolutionDict['turrelTol'])==False:GEN.makeDialog('Error!!! turrelTol is not number')                        
            if GEN.isNumber(fvSolutionDict['ytolerance'])==False:GEN.makeDialog('Error!!! ytolerance is not number')                        
            if GEN.isNumber(fvSolutionDict['yrelTol'])==False:GEN.makeDialog('Error!!! yrelTol is not number')                        
            if GEN.isNumber(fvSolutionDict['nNonOrtho'])==False:GEN.makeDialog('Error!!! nNonOrtho is not number')                        
            if GEN.isNumber(fvSolutionDict['nOuterCorrectors'])==False:GEN.makeDialog('Error!!! nOuterCorrectors is not number')                        
            if GEN.isNumber(fvSolutionDict['nCorrectors'])==False:GEN.makeDialog('Error!!! nCorrectors is not number')                        
            if GEN.isNumber(fvSolutionDict['maxCo'])==False:GEN.makeDialog('Error!!! maxCo is not number')                        
            if GEN.isNumber(fvSolutionDict['maxAlphaCo'])==False:GEN.makeDialog('Error!!! maxAlphaCo is not number')                        
            if GEN.isNumber(fvSolutionDict['relaxp'])==False:GEN.makeDialog('Error!!! relaxp is not number')                        
            if GEN.isNumber(fvSolutionDict['relaxu'])==False:GEN.makeDialog('Error!!! relaxu is not number')                        
            if GEN.isNumber(fvSolutionDict['relaxtur'])==False:GEN.makeDialog('Error!!! relaxtur is not number')                        
                        
            keys=fvSolutionDict.keys()
            f=open(self.caseDir+'/system/settings/fvSolutionSetup','w')
            for ii in keys:f.write(ii+';'+fvSolutionDict[ii]+'\n')
            f.close()

            pAdvDict={}
            sfile=glob.glob(self.caseDir+'/system/settings/fvSolution_pAdv')
            if len(sfile)!=0:
                pAdvDict=GEN.makeDictFromFile(sfile[0])
            else:
                pAdvDict['minIter']='2';pAdvDict['maxIter']='20';pAdvDict['PCGPreconditioner']='DIC'
                pAdvDict['GAMGSmoother']='DIC';pAdvDict['GAMGnPreSweeps']='0';pAdvDict['GAMGnPostSweeps']='2'
                pAdvDict['GAMGcache']='true';pAdvDict['GAMGagglomerator']='faceAreaPair';pAdvDict['GAMGnCellsInCoarsestLevel']='10'
                pAdvDict['GAMGmergeLevels']='1';pAdvDict['pFinalTol']='1e-9';pAdvDict['pFinalRelTol']='0';pAdvDict['pcorrTol']='1e-7';pAdvDict['pcorrRelTol']='0'

            UAdvDict={}
            sfile=glob.glob(self.caseDir+'/system/settings/fvSolution_UAdv')
            if len(sfile)!=0:
                UAdvDict=GEN.makeDictFromFile(sfile[0])
            else:
                UAdvDict['minIter']='2';UAdvDict['maxIter']='100';UAdvDict['PCGPreconditioner']='DILU';UAdvDict['smoothSmoother']='symGaussSeidel'
                UAdvDict['GAMGSmoother']='symGaussSeidel';UAdvDict['GAMGnPreSweeps']='0';UAdvDict['GAMGnPostSweeps']='2'
                UAdvDict['GAMGcache']='true';UAdvDict['GAMGagglomerator']='faceAreaPair';UAdvDict['GAMGnCellsInCoarsestLevel']='10'
                UAdvDict['GAMGmergeLevels']='1';UAdvDict['finalTol']='1e-7';UAdvDict['finalRelTol']='0.01'

            turAdvDict={}
            sfile=glob.glob(self.caseDir+'/system/settings/fvSolution_turAdv')
            if len(sfile)!=0:
                turAdvDict=GEN.makeDictFromFile(sfile[0])
            else:
                turAdvDict['minIter']='2';turAdvDict['maxIter']='100';turAdvDict['PCGPreconditioner']='DILU';turAdvDict['smoothSmoother']='symGaussSeidel'
                turAdvDict['GAMGSmoother']='symGaussSeidel';turAdvDict['GAMGnPreSweeps']='0';turAdvDict['GAMGnPostSweeps']='2'
                turAdvDict['GAMGcache']='true';turAdvDict['GAMGagglomerator']='faceAreaPair';turAdvDict['GAMGnCellsInCoarsestLevel']='10'
                turAdvDict['GAMGmergeLevels']='1';turAdvDict['finalTol']='1e-7';turAdvDict['finalRelTol']='0.01'
                
            yAdvDict={}
            sfile=glob.glob(self.caseDir+'/system/settings/fvSolution_yAdv')
            if len(sfile)!=0:
                yAdvDict=GEN.makeDictFromFile(sfile[0])
            else:
                yAdvDict['minIter']='2';yAdvDict['maxIter']='100';yAdvDict['PCGPreconditioner']='DILU';yAdvDict['smoothSmoother']='symGaussSeidel'
                yAdvDict['GAMGSmoother']='symGaussSeidel';yAdvDict['GAMGnPreSweeps']='0';yAdvDict['GAMGnPostSweeps']='2'
                yAdvDict['GAMGcache']='true';yAdvDict['GAMGagglomerator']='faceAreaPair';yAdvDict['GAMGnCellsInCoarsestLevel']='10'
                yAdvDict['GAMGmergeLevels']='1';yAdvDict['finalTol']='1e-8';yAdvDict['finalRelTol']='0'

            self.createFvSolutionFile(fvSolutionDict,pAdvDict,UAdvDict,turAdvDict,yAdvDict,refpoint,refx,refy,refz,refValue)
            #----------------
            message='\n [  fvSolution is saved  ]\n'
            message=message+'\n    - nNonOrthogonalCorrectors is '+fvSolutionDict['nNonOrtho']+'\n'            
            message=message+'\n    - nOuterCorrectors is '+fvSolutionDict['nOuterCorrectors']+'\n' 
            message=message+'\n    - nCorrectors is '+fvSolutionDict['nCorrectors']+'\n' 
            message=message+'\n    - relaxation factor of p is '+fvSolutionDict['relaxp']+'\n' 
            message=message+'\n    - relaxation factor of U is '+fvSolutionDict['relaxu']+'\n' 
            message=message+'\n    - relaxation factor of turbulence is '+fvSolutionDict['relaxtur']+'\n' 
                
            enditer=textbuffer.get_end_iter()
            textbuffer.insert(enditer,message)
            notebook.set_current_page(0)

        def setDefault(widget):
            psolverCombo.set_active(0);ptolEntry.set_text('1e-9');preltolEntry.set_text('0')
            usolverCombo.set_active(0);utolEntry.set_text('1e-7');ureltolEntry.set_text('0.01')
            tursolverCombo.set_active(0);turtolEntry.set_text('1e-7');turreltolEntry.set_text('0.01')
            ysolverCombo.set_active(0);ytolEntry.set_text('1e-8');yreltolEntry.set_text('0')
            nonorthoEntry.set_text('1');noutEntry.set_text('1');ncorrEntry.set_text('2')
            maxCoEntry.set_text('100');maxAlphaCoEntry.set_text('0.8')
            prelaxEntry.set_text('1.0');urelaxEntry.set_text('0.5');turrelaxEntry.set_text('0.5')        

        def setSavedValue():
            sfile=glob.glob(self.caseDir+'/system/settings/fvSolutionSetup')
            if len(sfile)!=0:
                dic=GEN.makeDictFromFile(sfile[0])
                aaa=psolverList.index(dic['psolver']);psolverCombo.set_active(aaa)
                ptolEntry.set_text(dic['ptolerance']);preltolEntry.set_text(dic['prelTol'])
                aaa=usolverList.index(dic['usolver']);usolverCombo.set_active(aaa)
                utolEntry.set_text(dic['utolerance']);ureltolEntry.set_text(dic['urelTol'])
                aaa=tursolverList.index(dic['tursolver']);tursolverCombo.set_active(aaa)
                turtolEntry.set_text(dic['turtolerance']);turreltolEntry.set_text(dic['turrelTol'])
                aaa=ysolverList.index(dic['ysolver']);ysolverCombo.set_active(aaa)
                ytolEntry.set_text(dic['ytolerance']);yreltolEntry.set_text(dic['yrelTol'])                               
                nonorthoEntry.set_text(dic['nNonOrtho'])
                noutEntry.set_text(dic['nOuterCorrectors']);ncorrEntry.set_text(dic['nCorrectors'])
                maxCoEntry.set_text(dic['maxCo']);maxAlphaCoEntry.set_text(dic['maxAlphaCo'])
                prelaxEntry.set_text(dic['relaxp']);urelaxEntry.set_text(dic['relaxu']);turrelaxEntry.set_text(dic['relaxtur'])
        #---------------------------------------------------------------------------------------------
        solbox=gtk.VBox(False,5)
        label=gtk.Label();label.set_markup('<b>  fvSolution  </b>')
        ebox=gtk.EventBox();solbox.pack_start(ebox,True,True,0)
        label.set_alignment(0,0.5);label.set_size_request(50,45)
        ebox.modify_bg(gtk.STATE_NORMAL,gtk.gdk.color_parse('white'));ebox.add(label) 

        # Solvers                 
        label=gtk.Label();label.set_markup('<i>  Solvers / Convergence criteria  </i>');solbox.pack_start(label,False,False,5);label.set_alignment(0,0.5)

        table=gtk.Table(5,3,False);table.set_row_spacings(3);table.set_col_spacings(2)
        solbox.pack_start(table,False,False,5)
        
        hbox=gtk.HBox(False,5);table.attach(hbox,0,1,0,1);label=gtk.Label('Fields');hbox.pack_start(label,False,False,5)
        hbox=gtk.HBox(False,5);table.attach(hbox,1,2,0,1);label=gtk.Label('Solver');hbox.pack_start(label,False,False,5)
        hbox=gtk.HBox(False,5);table.attach(hbox,2,3,0,1);label=gtk.Label('Advanced');hbox.pack_start(label,False,False,5)
        # p
        hbox=gtk.HBox(False,5);table.attach(hbox,0,1,1,2);label=gtk.Label('  p');hbox.pack_start(label,False,False,0)
        
        hbox=gtk.HBox(False,5);table.attach(hbox,1,2,1,2)
        psolverCombo=gtk.combo_box_entry_new_text();psolverCombo.set_size_request(130,28)
        psolverList=['GAMG','PCG','smoothSolver']
        for ii in psolverList:psolverCombo.append_text(ii) 
        psolverCombo.set_active(0)
        hbox.pack_start(psolverCombo,False,False,0)
        
        hbox=gtk.HBox(False,5);table.attach(hbox,2,3,1,2)
        psolverB=gtk.Button('Open');psolverB.set_size_request(80,28);psolverB.connect('clicked',psolverAdv)                
        hbox.pack_start(psolverB,False,False,0)
        # U
        hbox=gtk.HBox(False,5);table.attach(hbox,0,1,2,3);label=gtk.Label('  U');hbox.pack_start(label,False,False,0)
        
        hbox=gtk.HBox(False,5);table.attach(hbox,1,2,2,3)
        usolverCombo=gtk.combo_box_entry_new_text();usolverCombo.set_size_request(130,28)
        usolverList=['smoothSolver','PBiCG','GAMG']
        for ii in usolverList:usolverCombo.append_text(ii) 
        usolverCombo.set_active(0)
        hbox.pack_start(usolverCombo,False,False,0)
        
        hbox=gtk.HBox(False,5);table.attach(hbox,2,3,2,3)
        usolverB=gtk.Button('Open');usolverB.set_size_request(80,28);usolverB.connect('clicked',usolverAdv)                
        hbox.pack_start(usolverB,False,False,0)
        # turbulence
        hbox=gtk.HBox(False,5);table.attach(hbox,0,1,3,4);label=gtk.Label('  turb.');hbox.pack_start(label,False,False,0)
        
        hbox=gtk.HBox(False,5);table.attach(hbox,1,2,3,4)
        tursolverCombo=gtk.combo_box_entry_new_text();tursolverCombo.set_size_request(130,28)
        tursolverList=['smoothSolver','PBiCG','GAMG']
        for ii in tursolverList:tursolverCombo.append_text(ii) 
        tursolverCombo.set_active(0)
        hbox.pack_start(tursolverCombo,False,False,0)
        
        hbox=gtk.HBox(False,5);table.attach(hbox,2,3,3,4)
        tursolverB=gtk.Button('Open');tursolverB.set_size_request(80,28);tursolverB.connect('clicked',tursolverAdv)                
        hbox.pack_start(tursolverB,False,False,0)
        # Yi
        hbox=gtk.HBox(False,5);table.attach(hbox,0,1,4,5);label=gtk.Label('  α');hbox.pack_start(label,False,False,0)
        
        hbox=gtk.HBox(False,5);table.attach(hbox,1,2,4,5)
        ysolverCombo=gtk.combo_box_entry_new_text();ysolverCombo.set_size_request(130,28)
        ysolverList=['smoothSolver','PBiCG','GAMG']
        for ii in ysolverList:ysolverCombo.append_text(ii) 
        ysolverCombo.set_active(0)
        hbox.pack_start(ysolverCombo,False,False,0)
        
        hbox=gtk.HBox(False,5);table.attach(hbox,2,3,4,5)
        ysolverB=gtk.Button('Open');ysolverB.set_size_request(80,28);ysolverB.connect('clicked',ysolverAdv)                
        hbox.pack_start(ysolverB,False,False,0)

        separator=gtk.HSeparator();separator.set_size_request(285,5);solbox.pack_start(separator,True,True,5)

        # Tolerance                 
        table=gtk.Table(5,3,True);table.set_row_spacings(3);table.set_col_spacings(2)
        solbox.pack_start(table,False,False,10)
        
        hbox=gtk.HBox(False,5);table.attach(hbox,0,1,0,1);label=gtk.Label('Fields');label.set_alignment(0,0.5);hbox.pack_start(label,True,True,5)
        hbox=gtk.HBox(False,5);table.attach(hbox,1,2,0,1);label=gtk.Label('Tolerance');label.set_alignment(0,0.5);hbox.pack_start(label,True,True,5)
        hbox=gtk.HBox(False,5);table.attach(hbox,2,3,0,1);label=gtk.Label('relTol');label.set_alignment(0,0.5);hbox.pack_start(label,True,True,5)
        # p
        hbox=gtk.HBox(False,5);table.attach(hbox,0,1,1,2);label=gtk.Label('  p');hbox.pack_start(label,False,False,0)
        
        hbox=gtk.HBox(False,5);table.attach(hbox,1,2,1,2)
        ptolEntry=gtk.Entry();ptolEntry.set_size_request(80,28);ptolEntry.set_text('1e-9')
        hbox.pack_start(ptolEntry,True,True,0)
        
        hbox=gtk.HBox(False,5);table.attach(hbox,2,3,1,2)
        preltolEntry=gtk.Entry();preltolEntry.set_size_request(80,28);preltolEntry.set_text('0.0')             
        hbox.pack_start(preltolEntry,True,True,0)
        
        hbox=gtk.HBox(False,5)
        pconvEntry=gtk.Entry();pconvEntry.set_size_request(70,28);pconvEntry.set_text('1e-3')             
        # U
        hbox=gtk.HBox(False,5);table.attach(hbox,0,1,2,3);label=gtk.Label('  U');hbox.pack_start(label,False,False,0)
        
        hbox=gtk.HBox(False,5);table.attach(hbox,1,2,2,3)
        utolEntry=gtk.Entry();utolEntry.set_size_request(80,28);utolEntry.set_text('1e-7')
        hbox.pack_start(utolEntry,True,True,0)
        
        hbox=gtk.HBox(False,5);table.attach(hbox,2,3,2,3)
        ureltolEntry=gtk.Entry();ureltolEntry.set_size_request(80,28);ureltolEntry.set_text('0.01')             
        hbox.pack_start(ureltolEntry,True,True,0)
        
        hbox=gtk.HBox(False,5)
        uconvEntry=gtk.Entry();uconvEntry.set_size_request(70,28);uconvEntry.set_text('1e-3')             
        # turbulence
        hbox=gtk.HBox(False,5);table.attach(hbox,0,1,3,4);label=gtk.Label('  turb.');hbox.pack_start(label,False,False,0)
        
        hbox=gtk.HBox(False,5);table.attach(hbox,1,2,3,4)
        turtolEntry=gtk.Entry();turtolEntry.set_size_request(80,28);turtolEntry.set_text('1e-7')
        hbox.pack_start(turtolEntry,True,True,0)
        
        hbox=gtk.HBox(False,5);table.attach(hbox,2,3,3,4)
        turreltolEntry=gtk.Entry();turreltolEntry.set_size_request(80,28);turreltolEntry.set_text('0.1')             
        hbox.pack_start(turreltolEntry,True,True,0)
        
        hbox=gtk.HBox(False,5)
        turconvEntry=gtk.Entry();turconvEntry.set_size_request(70,28);turconvEntry.set_text('1e-3')             
        # alpha
        hbox=gtk.HBox(False,5);table.attach(hbox,0,1,4,5);label=gtk.Label('  α');hbox.pack_start(label,False,False,0)
        
        hbox=gtk.HBox(False,5);table.attach(hbox,1,2,4,5)
        ytolEntry=gtk.Entry();ytolEntry.set_size_request(80,28);ytolEntry.set_text('1e-8')
        hbox.pack_start(ytolEntry,True,True,0)
        
        hbox=gtk.HBox(False,5);table.attach(hbox,2,3,4,5)
        yreltolEntry=gtk.Entry();yreltolEntry.set_size_request(80,28);yreltolEntry.set_text('0')             
        hbox.pack_start(yreltolEntry,True,True,0)
        
        hbox=gtk.HBox(False,5)
        yconvEntry=gtk.Entry();yconvEntry.set_size_request(70,28);yconvEntry.set_text('1e-3')             
        
        separator=gtk.HSeparator();separator.set_size_request(285,5);solbox.pack_start(separator,True,True,5)
        # --- SIMPLE / PIMPLE  ----------------------------
        label=gtk.Label();label.set_markup('<i>  PIMPLE  </i>');solbox.pack_start(label,False,False,0);label.set_alignment(0,0.5)
                
        hbox=gtk.HBox(False,5);solbox.pack_start(hbox,False,False,1)
        label=gtk.Label('nNonOrthogonalCorrectors')
        nonorthoEntry=gtk.Entry();nonorthoEntry.set_size_request(60,28);nonorthoEntry.set_text('1')
        hbox.pack_start(label,False,False,5);hbox.pack_end(nonorthoEntry,False,False,5)

        hbox=gtk.HBox(False,5);solbox.pack_start(hbox,False,False,1)
        label=gtk.Label('nOuterCorrectors')
        noutEntry=gtk.Entry();noutEntry.set_size_request(60,28);noutEntry.set_text('1')
        hbox.pack_start(label,False,False,5);hbox.pack_end(noutEntry,False,False,5)
        
        hbox=gtk.HBox(False,5);solbox.pack_start(hbox,False,False,1)
        label=gtk.Label('nCorrectors')
        ncorrEntry=gtk.Entry();ncorrEntry.set_size_request(60,28);ncorrEntry.set_text('2')
        hbox.pack_start(label,False,False,5);hbox.pack_end(ncorrEntry,False,False,5)
        
        hbox=gtk.HBox(False,5);solbox.pack_start(hbox,False,False,1)
        label=gtk.Label('maxCo')
        maxCoEntry=gtk.Entry();maxCoEntry.set_size_request(60,28);maxCoEntry.set_text('100')
        #hbox.pack_start(label,False,False,5);hbox.pack_end(maxCoEntry,False,False,5)
        
        hbox=gtk.HBox(False,5);solbox.pack_start(hbox,False,False,1)
        label=gtk.Label('maxAlphaCo')
        maxAlphaCoEntry=gtk.Entry();maxAlphaCoEntry.set_size_request(60,28);maxAlphaCoEntry.set_text('0.8')
        #hbox.pack_start(label,False,False,5);hbox.pack_end(maxAlphaCoEntry,False,False,5)
        
        separator=gtk.HSeparator();separator.set_size_request(285,5);solbox.pack_start(separator,True,True,5)        
        # --- relaxation factor  ----------------------------
        label=gtk.Label();label.set_markup('<i>  Relaxation factor  </i>');solbox.pack_start(label,False,False,0);label.set_alignment(0,0.5)        

        table=gtk.Table(5,6,False);table.set_row_spacings(3);table.set_col_spacings(2)
        hhbox=gtk.HBox(False,5);solbox.pack_start(hhbox,False,False,5)
        hhbox.pack_end(table,False,False,0)
        
        hbox=gtk.HBox(False,5);table.attach(hbox,0,1,0,1);label=gtk.Label('p');hbox.pack_start(label,False,False,5)
        hbox=gtk.HBox(False,5);table.attach(hbox,1,2,0,1)
        prelaxEntry=gtk.Entry();prelaxEntry.set_size_request(60,28);prelaxEntry.set_text('1.0');hbox.pack_start(prelaxEntry,False,False,2)
        
        hbox=gtk.HBox(False,5);table.attach(hbox,2,3,0,1);label=gtk.Label('U');hbox.pack_start(label,False,False,5)
        hbox=gtk.HBox(False,5);table.attach(hbox,3,4,0,1)
        urelaxEntry=gtk.Entry();urelaxEntry.set_size_request(60,28);urelaxEntry.set_text('0.5');hbox.pack_start(urelaxEntry,False,False,2)
        
        hbox=gtk.HBox(False,5);table.attach(hbox,4,5,0,1);label=gtk.Label('turb.');hbox.pack_start(label,False,False,5)
        hbox=gtk.HBox(False,5);table.attach(hbox,5,6,0,1)
        turrelaxEntry=gtk.Entry();turrelaxEntry.set_size_request(60,28);turrelaxEntry.set_text('0.5');hbox.pack_start(turrelaxEntry,False,False,2)

        defaultB=gtk.Button('Set Default');defaultB.connect('clicked',setDefault)
        appB=gtk.Button('Apply');appB.connect('clicked',applythis)
        hbox=gtk.HBox(True,5);solbox.pack_start(hbox,False,False,5)
        hbox.pack_start(appB,True,True,5);hbox.pack_start(defaultB,True,True,5)
        
        setSavedValue()
               
        return solbox
    #-------------------------------------------------------------------------------------------------      
    def psolverAdv(self,psolver):
    
        GEN=generalClass(self.caseDir)
       
        def applythis(widget):
            pAdvDict={}
            pAdvDict['minIter']=paminIterEntry.get_text()
            if GEN.isNumber(pAdvDict['minIter'])==False:GEN.makeDialog('Error!!! minIter is not number')            
            pAdvDict['maxIter']=pamaxIterEntry.get_text()
            if GEN.isNumber(pAdvDict['maxIter'])==False:GEN.makeDialog('Error!!! maxIter is not number')            
            aa=papreconCombo.child;pAdvDict['PCGPreconditioner']=aa.get_text()
            aa=pagamgsmootherCombo.child;pAdvDict['GAMGSmoother']=aa.get_text()
            pAdvDict['GAMGnPreSweeps']=papresweepEntry.get_text()
            if GEN.isNumber(pAdvDict['GAMGnPreSweeps'])==False:GEN.makeDialog('Error!!! GAMGnPreSweeps is not number')            
            pAdvDict['GAMGnPostSweeps']=papostsweepEntry.get_text()
            if GEN.isNumber(pAdvDict['GAMGnPostSweeps'])==False:GEN.makeDialog('Error!!! GAMGnPostSweeps is not number')            
            if pacacheCB.get_active()==True:pAdvDict['GAMGcache']='true'
            else:pAdvDict['GAMGcache']='false'
            aa=paaggloCombo.child;pAdvDict['GAMGagglomerator']=aa.get_text()
            pAdvDict['GAMGnCellsInCoarsestLevel']=pancellsEntry.get_text()
            if GEN.isNumber(pAdvDict['GAMGnCellsInCoarsestLevel'])==False:GEN.makeDialog('Error!!! GAMGnCellsInCoarsestLevel is not number')            
            pAdvDict['GAMGmergeLevels']=pamergeEntry.get_text()
            if GEN.isNumber(pAdvDict['GAMGmergeLevels'])==False:GEN.makeDialog('Error!!! GAMGmergeLevels is not number')            
            aa=pasmootherCombo.child;pAdvDict['smoothSolverSmoother']=aa.get_text()
            pAdvDict['pFinalTol']=pafinaltolEntry.get_text()
            if GEN.isNumber(pAdvDict['pFinalTol'])==False:GEN.makeDialog('Error!!! pFinalTol is not number')            
            pAdvDict['pFinalRelTol']=pafinalreltolEntry.get_text()
            if GEN.isNumber(pAdvDict['pFinalRelTol'])==False:GEN.makeDialog('Error!!! pFinalRelTol is not number')
            
            keys=pAdvDict.keys()
            f=open(self.caseDir+'/system/settings/fvSolution_pAdv','w')
            for ii in keys:f.write(ii+';'+pAdvDict[ii]+'\n')
            f.close()
            win.destroy();self.openSubWindow=False

        def closethis(widget):
            win.destroy();self.openSubWindow=False

        def setSavedValueAdv():
            sfile=glob.glob(self.caseDir+'/system/settings/fvSolution_pAdv')
            if len(sfile)!=0:
                dic=GEN.makeDictFromFile(sfile[0])
                paminIterEntry.set_text(dic['minIter']);pamaxIterEntry.set_text(dic['maxIter'])
                aaa=papreconList.index(dic['PCGPreconditioner']);papreconCombo.set_active(aaa)
                aaa=pasmootherList.index(dic['GAMGSmoother']);pagamgsmootherCombo.set_active(aaa)
                papresweepEntry.set_text(dic['GAMGnPreSweeps']);papostsweepEntry.set_text(dic['GAMGnPostSweeps'])
                if dic['GAMGcache']=='true':pacacheCB.set_active(1)
                else:pacacheCB.set_active(0)
                aaa=paaggloList.index(dic['GAMGagglomerator']);paaggloCombo.set_active(aaa)
                pancellsEntry.set_text(dic['GAMGnCellsInCoarsestLevel']);pamergeEntry.set_text(dic['GAMGmergeLevels'])
                aaa=pasmootherList.index(dic['smoothSolverSmoother']);pasmootherCombo.set_active(aaa)
                pafinaltolEntry.set_text(dic['pFinalTol']);pafinalreltolEntry.set_text(dic['pFinalRelTol'])

        def setDefaultp(widget):
            paminIterEntry.set_text('2');pamaxIterEntry.set_text('20')
            papreconCombo.set_active(0);pagamgsmootherCombo.set_active(2)
            papresweepEntry.set_text('0');papostsweepEntry.set_text('2');pacacheCB.set_active(1)
            paaggloCombo.set_active(0);pancellsEntry.set_text('10');pamergeEntry.set_text('1')
            pasmootherCombo.set_active(1);pafinaltolEntry.set_text('1e-7');pafinalreltolEntry.set_text('0')

        def changePre(widget):
            aa=widget.child;precon=aa.get_text()
            if precon=='GAMG':
                pagamgsmootherCombo.set_sensitive(1);papresweepEntry.set_sensitive(1)
                papostsweepEntry.set_sensitive(1);paaggloCombo.set_sensitive(1)
                pancellsEntry.set_sensitive(1);pamergeEntry.set_sensitive(1);pacacheCB.set_sensitive(1)
            else:		    
                pasmootherCombo.set_sensitive(1);papresweepEntry.set_sensitive(0)
                papostsweepEntry.set_sensitive(0);paaggloCombo.set_sensitive(0)
                pancellsEntry.set_sensitive(0);pamergeEntry.set_sensitive(0);pacacheCB.set_sensitive(0)

        self.openSubWindow=True
        
        win=gtk.Window(gtk.WINDOW_TOPLEVEL);win.set_title('p solver advanced')
        win.set_border_width(5);win.set_position(gtk.WIN_POS_CENTER);win.set_transient_for(self.mainwindow)
        vbox=gtk.VBox(False,5);win.add(vbox)
        paframe=gtk.Frame();paframe.set_shadow_type(gtk.SHADOW_ETCHED_OUT);vbox.pack_start(paframe,False,False,5)
        pahbox=gtk.HBox(True,5);paframe.add(pahbox)
        pavbox=gtk.VBox(False,5);pahbox.pack_start(pavbox,True,True,5)

        label=gtk.Label('minIter')
        paminIterEntry=gtk.Entry();paminIterEntry.set_size_request(100,28);paminIterEntry.set_text('2')	    
        paminIterbox=gtk.HBox(False,5);pavbox.pack_start(paminIterbox,False,False,5)
        paminIterbox.pack_start(label,False,False,5);paminIterbox.pack_end(paminIterEntry,False,False,5)	    

        label=gtk.Label('maxIter')
        pamaxIterEntry=gtk.Entry();pamaxIterEntry.set_size_request(100,28);pamaxIterEntry.set_text('20')	    
        pamaxIterbox=gtk.HBox(False,5);pavbox.pack_start(pamaxIterbox,False,False,5)
        pamaxIterbox.pack_start(label,False,False,5);pamaxIterbox.pack_end(pamaxIterEntry,False,False,5)	
        # PCG
        pcgframe=gtk.Frame();pcgframe.set_label('  PCG  ');pcgframe.set_label_align(0.1, 0.5)
        pcgframe.set_shadow_type(gtk.SHADOW_ETCHED_OUT);pavbox.pack_start(pcgframe,False,False,5)

        pcghbox=gtk.HBox(True,5);pcgframe.add(pcghbox)
        pcgvbox=gtk.VBox(False,5);pcghbox.pack_start(pcgvbox,True,True,5)

        label=gtk.Label('preconditioner')
        papreconCombo=gtk.combo_box_entry_new_text();papreconCombo.set_size_request(120,28)
        papreconList=['DIC','FDIC','GAMG','diagonal','none']
        for ii in papreconList:papreconCombo.append_text(ii) 
        papreconCombo.set_active(0);papreconCombo.connect('changed',changePre)
        papreconbox=gtk.HBox(False,5);pcgvbox.pack_start(papreconbox,False,False,5)
        papreconbox.pack_start(label,False,False,5);papreconbox.pack_end(papreconCombo,False,False,5)
        # GAMG
        gamgframe=gtk.Frame();gamgframe.set_label('  GAMG  ');gamgframe.set_label_align(0.1, 0.5)
        gamgframe.set_shadow_type(gtk.SHADOW_ETCHED_OUT);pavbox.pack_start(gamgframe,False,False,5)

        gamghbox=gtk.HBox(True,5);gamgframe.add(gamghbox)
        gamgvbox=gtk.VBox(False,5);gamghbox.pack_start(gamgvbox,False,False,5)

        label=gtk.Label('smoother')
        pagamgsmootherCombo=gtk.combo_box_entry_new_text();pagamgsmootherCombo.set_size_request(120,28)
        pasmootherList=['GaussSeidel','symGaussSeidel','DIC','DICGaussSeidel','FDIC','nonBlockingGaussSeidel']
        for ii in pasmootherList:pagamgsmootherCombo.append_text(ii) 
        pagamgsmootherCombo.set_active(2)
        pasmootherbox=gtk.HBox(False,5);gamgvbox.pack_start(pasmootherbox,False,False,5)
        pasmootherbox.pack_start(label,False,False,5);pasmootherbox.pack_end(pagamgsmootherCombo,False,False,5)	

        label=gtk.Label('nPreSweeps')
        papresweepEntry=gtk.Entry();papresweepEntry.set_size_request(100,28);papresweepEntry.set_text('0')	    
        papresweepbox=gtk.HBox(False,5);gamgvbox.pack_start(papresweepbox,False,False,5)
        papresweepbox.pack_start(label,False,False,5);papresweepbox.pack_end(papresweepEntry,False,False,5)	

        label=gtk.Label('nPostSweeps')
        papostsweepEntry=gtk.Entry();papostsweepEntry.set_size_request(100,28);papostsweepEntry.set_text('2')	    
        papostsweepbox=gtk.HBox(False,5);gamgvbox.pack_start(papostsweepbox,False,False,5)
        papostsweepbox.pack_start(label,False,False,5);papostsweepbox.pack_end(papostsweepEntry,False,False,5)

        pacacheCB=gtk.CheckButton('cacheAgglomeration');pacacheCB.set_active(1)	    
        pacachebox=gtk.HBox(False,5);gamgvbox.pack_start(pacachebox,False,False,5)
        pacachebox.pack_start(pacacheCB,False,False,5)

        label=gtk.Label('agglomerator')
        paaggloCombo=gtk.combo_box_entry_new_text();paaggloCombo.set_size_request(120,28)
        paaggloList=['faceAreaPair']
        for ii in paaggloList:paaggloCombo.append_text(ii) 
        paaggloCombo.set_active(0)
        paagglobox=gtk.HBox(False,5);gamgvbox.pack_start(paagglobox,False,False,5)
        paagglobox.pack_start(label,False,False,5);paagglobox.pack_end(paaggloCombo,False,False,5)

        label=gtk.Label('nCellsInCoarsestLevel')
        pancellsEntry=gtk.Entry();pancellsEntry.set_size_request(100,28);pancellsEntry.set_text('10')	    
        pancellsbox=gtk.HBox(False,5);gamgvbox.pack_start(pancellsbox,False,False,5)
        pancellsbox.pack_start(label,False,False,5);pancellsbox.pack_end(pancellsEntry,False,False,5)

        label=gtk.Label('mergeLevels')
        pamergeEntry=gtk.Entry();pamergeEntry.set_size_request(100,28);pamergeEntry.set_text('1')	    
        pamergebox=gtk.HBox(False,5);gamgvbox.pack_start(pamergebox,False,False,5)
        pamergebox.pack_start(label,False,False,5);pamergebox.pack_end(pamergeEntry,False,False,5)
        # smoothSolver
        smoothframe=gtk.Frame();smoothframe.set_label('  smoothSolver  ');smoothframe.set_label_align(0.1, 0.5)
        smoothframe.set_shadow_type(gtk.SHADOW_ETCHED_OUT);pavbox.pack_start(smoothframe,False,False,5)

        smoothhbox=gtk.HBox(True,5);smoothframe.add(smoothhbox)
        smoothvbox=gtk.VBox(False,5);smoothhbox.pack_end(smoothvbox,True,True,5)

        label=gtk.Label('smoother')
        pasmootherCombo=gtk.combo_box_entry_new_text();pasmootherCombo.set_size_request(120,28)
        pasmootherList=['GaussSeidel','symGaussSeidel','DILU','DILUGaussSeidel','nonBlockingGaussSeidel']
        for ii in pasmootherList:pasmootherCombo.append_text(ii) 
        pasmootherCombo.set_active(1)
        pasmootherbox=gtk.HBox(False,5);smoothvbox.pack_start(pasmootherbox,False,False,5)
        pasmootherbox.pack_start(label,False,False,5);pasmootherbox.pack_end(pasmootherCombo,False,False,5)	

        finalframe=gtk.Frame();finalframe.set_label('  pFinal  ');finalframe.set_label_align(0.1, 0.5)
        finalframe.set_shadow_type(gtk.SHADOW_ETCHED_OUT);pavbox.pack_start(finalframe,False,False,5)

        finalbox=gtk.HBox(True,5);finalframe.add(finalbox)
        finalvbox=gtk.VBox(False,5);finalbox.pack_start(finalvbox,True,True,5)

        label=gtk.Label('tolerance')
        pafinaltolEntry=gtk.Entry();pafinaltolEntry.set_size_request(100,28);pafinaltolEntry.set_text('1e-9')
        pafinaltolbox=gtk.HBox(False,5);finalvbox.pack_start(pafinaltolbox,False,False,2)
        pafinaltolbox.pack_start(label,False,False,5);pafinaltolbox.pack_end(pafinaltolEntry,False,False,5)

        label=gtk.Label('relTol')
        pafinalreltolEntry=gtk.Entry();pafinalreltolEntry.set_size_request(100,28);pafinalreltolEntry.set_text('0')
        pafinalreltolbox=gtk.HBox(False,5);finalvbox.pack_start(pafinalreltolbox,False,False,2)
        pafinalreltolbox.pack_start(label,False,False,5);pafinalreltolbox.pack_end(pafinalreltolEntry,False,False,5)
        # button box
        buttonbox=gtk.HBox(False,5)
        pavbox.pack_start(buttonbox,False,False,5)
        app=gtk.Button(label='Apply');app.set_size_request(80,30)
        cll=gtk.Button(label='Close');cll.set_size_request(80,30)
        default=gtk.Button('Default');default.set_size_request(80,30)
        app.connect('clicked',applythis);cll.connect('clicked',closethis);default.connect('clicked',setDefaultp)
        buttonbox.pack_end(cll,True,True,5);buttonbox.pack_end(default,True,True,5);buttonbox.pack_end(app,True,True,5)

        if psolver=='PCG':  
            pasmootherCombo.set_sensitive(0);papresweepEntry.set_sensitive(0)
            papostsweepEntry.set_sensitive(0);paaggloCombo.set_sensitive(0)
            pancellsEntry.set_sensitive(0);pamergeEntry.set_sensitive(0);pacacheCB.set_sensitive(0)
            papreconCombo.set_sensitive(1);pasmootherCombo.set_sensitive(0)		
        elif psolver=='GAMG':
            pasmootherCombo.set_sensitive(1);papresweepEntry.set_sensitive(1)
            papostsweepEntry.set_sensitive(1);paaggloCombo.set_sensitive(1)
            pancellsEntry.set_sensitive(1);pamergeEntry.set_sensitive(1);pacacheCB.set_sensitive(1)
            papreconCombo.set_sensitive(0);pasmootherCombo.set_sensitive(0)
        elif psolver=='smoothSolver':
            pasmootherCombo.set_sensitive(0);papresweepEntry.set_sensitive(0)
            papostsweepEntry.set_sensitive(0);paaggloCombo.set_sensitive(0)
            pancellsEntry.set_sensitive(0);pamergeEntry.set_sensitive(0);pacacheCB.set_sensitive(0)
            papreconCombo.set_sensitive(0);pasmootherCombo.set_sensitive(1)

        setSavedValueAdv()

        win.show_all()
    #-------------------------------------------------------------------------------------------------      
    def usolverAdv(self,usolver):
    
        GEN=generalClass(self.caseDir)
        
        def applythis(widget):
            UAdvDict={}
            UAdvDict['minIter']=uaminIterEntry.get_text()
            if GEN.isNumber(UAdvDict['minIter'])==False:GEN.makeDialog('Error!!! minIter is not number')            
            UAdvDict['maxIter']=uamaxIterEntry.get_text()
            if GEN.isNumber(UAdvDict['maxIter'])==False:GEN.makeDialog('Error!!! maxIter is not number')            
            aa=uapreconCombo.child;UAdvDict['PCGPreconditioner']=aa.get_text()
            aa=uasmootherCombo.child;UAdvDict['smoothSmoother']=aa.get_text()
            aa=uagamgsmootherCombo.child;UAdvDict['GAMGSmoother']=aa.get_text()
            UAdvDict['GAMGnPreSweeps']=uapresweepEntry.get_text()
            if GEN.isNumber(UAdvDict['GAMGnPreSweeps'])==False:GEN.makeDialog('Error!!! GAMGnPreSweeps is not number')            
            UAdvDict['GAMGnPostSweeps']=uapostsweepEntry.get_text()
            if GEN.isNumber(UAdvDict['GAMGnPostSweeps'])==False:GEN.makeDialog('Error!!! GAMGnPostSweeps is not number')            
            if uacacheCB.get_active()==True:UAdvDict['GAMGcache']='true'
            else:UAdvDict['GAMGcache']='False'
            aa=uaaggloCombo.child;UAdvDict['GAMGagglomerator']=aa.get_text()
            UAdvDict['GAMGnCellsInCoarsestLevel']=uancellsEntry.get_text()
            if GEN.isNumber(UAdvDict['GAMGnCellsInCoarsestLevel'])==False:GEN.makeDialog('Error!!! GAMGnCellsInCoarsestLevel is not number')            
            UAdvDict['GAMGmergeLevels']=uamergeEntry.get_text()
            if GEN.isNumber(UAdvDict['GAMGmergeLevels'])==False:GEN.makeDialog('Error!!! GAMGmergeLevels is not number')            
            UAdvDict['finalTol']=uafinaltolEntry.get_text()
            if GEN.isNumber(UAdvDict['finalTol'])==False:GEN.makeDialog('Error!!! finalTol is not number')            
            UAdvDict['finalRelTol']=uafinalreltolEntry.get_text()
            if GEN.isNumber(UAdvDict['finalRelTol'])==False:GEN.makeDialog('Error!!! finalRelTol is not number')
            
            keys=UAdvDict.keys()
            f=open(self.caseDir+'/system/settings/fvSolution_UAdv','w')
            for ii in keys:f.write(ii+';'+UAdvDict[ii]+'\n')
            f.close()
            win.destroy();self.openSubWindow=False

        def closethis(widget):
            win.destroy();self.openSubWindow=False

        def setSavedValueAdv():
            sfile=glob.glob(self.caseDir+'/system/settings/fvSolution_UAdv')
            if len(sfile)!=0:
                dic=GEN.makeDictFromFile(sfile[0])
                uaminIterEntry.set_text(dic['minIter']);uamaxIterEntry.set_text(dic['maxIter'])
                aaa=uapreconList.index(dic['PCGPreconditioner']);uapreconCombo.set_active(aaa)
                aaa=uasmootherList.index(dic['smoothSmoother']);uasmootherCombo.set_active(aaa)
                aaa=uasmootherList.index(dic['GAMGSmoother']);uagamgsmootherCombo.set_active(aaa)
                uapresweepEntry.set_text(dic['GAMGnPreSweeps']);uapostsweepEntry.set_text(dic['GAMGnPostSweeps'])
                if dic['GAMGcache']=='true':uacacheCB.set_active(1)
                else:uacacheCB.set_active(0)
                aaa=uaaggloList.index(dic['GAMGagglomerator']);uaaggloCombo.set_active(aaa)
                uancellsEntry.set_text(dic['GAMGnCellsInCoarsestLevel']);uamergeEntry.set_text(dic['GAMGmergeLevels'])
                uafinaltolEntry.set_text(dic['finalTol']);uafinalreltolEntry.set_text(dic['finalRelTol'])

        def setDefaultU(widget):
            uaminIterEntry.set_text('1');uamaxIterEntry.set_text('100')
            uapreconCombo.set_active(0);uasmootherCombo.set_active(1)
            uagamgsmootherCombo.set_active(1);uapresweepEntry.set_text('0');uapostsweepEntry.set_text('2')
            uacacheCB.set_active(1);uaaggloCombo.set_active(0);uancellsEntry.set_text('10');uamergeEntry.set_text('1') 

        self.openSubWindow=True
        
        win=gtk.Window(gtk.WINDOW_TOPLEVEL);win.set_title('u solver advanced')
        win.set_border_width(5);win.set_position(gtk.WIN_POS_CENTER);win.set_transient_for(self.mainwindow)
        vbox=gtk.VBox(False,5);win.add(vbox)
        uaframe=gtk.Frame();uaframe.set_shadow_type(gtk.SHADOW_ETCHED_OUT);vbox.pack_start(uaframe,False,False,5)
        uahbox=gtk.HBox(True,5);uaframe.add(uahbox)
        uavbox=gtk.VBox(False,5);uahbox.pack_start(uavbox,False,False,5)

        label=gtk.Label('minIter')
        uaminIterEntry=gtk.Entry();uaminIterEntry.set_size_request(100,28);uaminIterEntry.set_text('0')	    
        uaminIterbox=gtk.HBox(False,5);uavbox.pack_start(uaminIterbox,False,False,5)
        uaminIterbox.pack_start(label,False,False,5);uaminIterbox.pack_end(uaminIterEntry,False,False,5)	    

        label=gtk.Label('maxIter')
        uamaxIterEntry=gtk.Entry();uamaxIterEntry.set_size_request(100,28);uamaxIterEntry.set_text('100')	    
        uamaxIterbox=gtk.HBox(False,5);uavbox.pack_start(uamaxIterbox,False,False,5)
        uamaxIterbox.pack_start(label,False,False,5);uamaxIterbox.pack_end(uamaxIterEntry,False,False,5)	
        # PBiCG
        pbicgframe=gtk.Frame();pbicgframe.set_label('  PBiCG  ');pbicgframe.set_label_align(0.1, 0.5)
        pbicgframe.set_shadow_type(gtk.SHADOW_ETCHED_OUT);uavbox.pack_start(pbicgframe,False,False,5)

        pbicghbox=gtk.HBox(True,5);pbicgframe.add(pbicghbox)
        pbicgvbox=gtk.VBox(False,5);pbicghbox.pack_end(pbicgvbox,True,True,5)

        label=gtk.Label('preconditioner')
        uapreconCombo=gtk.combo_box_entry_new_text();uapreconCombo.set_size_request(120,28)
        uapreconList=['DILU','GAMG','diagonal','none']
        for ii in uapreconList:uapreconCombo.append_text(ii) 
        uapreconCombo.set_active(0)
        uapreconbox=gtk.HBox(False,5);pbicgvbox.pack_start(uapreconbox,False,False,5)
        uapreconbox.pack_start(label,False,False,5);uapreconbox.pack_end(uapreconCombo,False,False,5)
        # smoothSolver
        smoothframe=gtk.Frame();smoothframe.set_label('  smoothSolver  ');smoothframe.set_label_align(0.1, 0.5)
        smoothframe.set_shadow_type(gtk.SHADOW_ETCHED_OUT);uavbox.pack_start(smoothframe,False,False,5)

        smoothhbox=gtk.HBox(True,5);smoothframe.add(smoothhbox)
        smoothvbox=gtk.VBox(False,5);smoothhbox.pack_end(smoothvbox,True,True,5)

        label=gtk.Label('smoother')
        uasmootherCombo=gtk.combo_box_entry_new_text();uasmootherCombo.set_size_request(120,28)
        uasmootherList=['GaussSeidel','symGaussSeidel','DILU','DILUGaussSeidel','nonBlockingGaussSeidel']
        for ii in uasmootherList:uasmootherCombo.append_text(ii) 
        uasmootherCombo.set_active(1)
        uasmootherbox=gtk.HBox(False,5);smoothvbox.pack_start(uasmootherbox,False,False,5)
        uasmootherbox.pack_start(label,False,False,5);uasmootherbox.pack_end(uasmootherCombo,False,False,5)	
        # GAMG
        gamgframe=gtk.Frame();gamgframe.set_label('  GAMG  ');gamgframe.set_label_align(0.1, 0.5)
        gamgframe.set_shadow_type(gtk.SHADOW_ETCHED_OUT);uavbox.pack_start(gamgframe,False,False,5)

        gamghbox=gtk.HBox(True,5);gamgframe.add(gamghbox)
        gamgvbox=gtk.VBox(False,5);gamghbox.pack_start(gamgvbox,False,False,5)

        label=gtk.Label('smoother')
        uagamgsmootherCombo=gtk.combo_box_entry_new_text();uagamgsmootherCombo.set_size_request(120,28)
        uasmootherList=['GaussSeidel','symGaussSeidel','DILU','DILUGaussSeidel','nonBlockingGaussSeidel']
        for ii in uasmootherList:uagamgsmootherCombo.append_text(ii) 
        uagamgsmootherCombo.set_active(1)
        uasmootherbox=gtk.HBox(False,5);gamgvbox.pack_start(uasmootherbox,False,False,5)
        uasmootherbox.pack_start(label,False,False,5);uasmootherbox.pack_end(uagamgsmootherCombo,False,False,5)	

        label=gtk.Label('nPreSweeps')
        uapresweepEntry=gtk.Entry();uapresweepEntry.set_size_request(100,28);uapresweepEntry.set_text('0')	    
        uapresweepbox=gtk.HBox(False,5);gamgvbox.pack_start(uapresweepbox,False,False,5)
        uapresweepbox.pack_start(label,False,False,5);uapresweepbox.pack_end(uapresweepEntry,False,False,5)	

        label=gtk.Label('nPostSweeps')
        uapostsweepEntry=gtk.Entry();uapostsweepEntry.set_size_request(100,28);uapostsweepEntry.set_text('2')	    
        uapostsweepbox=gtk.HBox(False,5);gamgvbox.pack_start(uapostsweepbox,False,False,5)
        uapostsweepbox.pack_start(label,False,False,5);uapostsweepbox.pack_end(uapostsweepEntry,False,False,5)

        uacacheCB=gtk.CheckButton('cacheAgglomeration');uacacheCB.set_active(1)    
        uacachebox=gtk.HBox(False,5);gamgvbox.pack_start(uacachebox,False,False,5)
        uacachebox.pack_start(uacacheCB,False,False,5)

        label=gtk.Label('agglomerator')
        uaaggloCombo=gtk.combo_box_entry_new_text();uaaggloCombo.set_size_request(120,28)
        uaaggloList=['faceAreaPair']
        for ii in uaaggloList:uaaggloCombo.append_text(ii) 
        uaaggloCombo.set_active(0)
        uaagglobox=gtk.HBox(False,5);gamgvbox.pack_start(uaagglobox,False,False,5)
        uaagglobox.pack_start(label,False,False,5);uaagglobox.pack_end(uaaggloCombo,False,False,5)

        label=gtk.Label('nCellsInCoarsestLevel')
        uancellsEntry=gtk.Entry();uancellsEntry.set_size_request(100,28);uancellsEntry.set_text('10')	    
        uancellsbox=gtk.HBox(False,5);gamgvbox.pack_start(uancellsbox,False,False,5)
        uancellsbox.pack_start(label,False,False,5);uancellsbox.pack_end(uancellsEntry,False,False,5)

        label=gtk.Label('mergeLevels')
        uamergeEntry=gtk.Entry();uamergeEntry.set_size_request(100,28);uamergeEntry.set_text('1')	    
        uamergebox=gtk.HBox(False,5);gamgvbox.pack_start(uamergebox,False,False,5)
        uamergebox.pack_start(label,False,False,5);uamergebox.pack_end(uamergeEntry,False,False,5)

        finalframe=gtk.Frame();finalframe.set_label('  UFinal  ');finalframe.set_label_align(0.1, 0.5)
        finalframe.set_shadow_type(gtk.SHADOW_ETCHED_OUT);uavbox.pack_start(finalframe,False,False,5)

        finalbox=gtk.HBox(True,5);finalframe.add(finalbox)
        finalvbox=gtk.VBox(False,5);finalbox.pack_start(finalvbox,True,True,5)

        label=gtk.Label('tolerance')
        uafinaltolEntry=gtk.Entry();uafinaltolEntry.set_size_request(100,28);uafinaltolEntry.set_text('1e-7')
        uafinaltolbox=gtk.HBox(False,5);finalvbox.pack_start(uafinaltolbox,False,False,2)
        uafinaltolbox.pack_start(label,False,False,5);uafinaltolbox.pack_end(uafinaltolEntry,False,False,5)

        label=gtk.Label('relTol')
        uafinalreltolEntry=gtk.Entry();uafinalreltolEntry.set_size_request(100,28);uafinalreltolEntry.set_text('0.1')
        uafinalreltolbox=gtk.HBox(False,5);finalvbox.pack_start(uafinalreltolbox,False,False,2)
        uafinalreltolbox.pack_start(label,False,False,5);uafinalreltolbox.pack_end(uafinalreltolEntry,False,False,5)

        buttonbox=gtk.HBox(False,5)
        uavbox.pack_start(buttonbox,False,False,5)
        app=gtk.Button(label='Apply');app.set_size_request(80,30)
        cll=gtk.Button(label='Close');cll.set_size_request(80,30)
        default=gtk.Button('Default');default.set_size_request(80,30)
        app.connect('clicked',applythis);cll.connect('clicked',closethis);default.connect('clicked',setDefaultU)
        buttonbox.pack_end(cll,True,True,5);buttonbox.pack_end(default,True,True,5);buttonbox.pack_end(app,True,True,5)  

        if usolver=='smoothSolver':  
            uasmootherCombo.set_sensitive(1)
            uagamgsmootherCombo.set_sensitive(0);uapresweepEntry.set_sensitive(0)
            uapostsweepEntry.set_sensitive(0);uaaggloCombo.set_sensitive(0)
            uancellsEntry.set_sensitive(0);uamergeEntry.set_sensitive(0);uacacheCB.set_sensitive(0)
            uapreconCombo.set_sensitive(0)
        elif usolver=='PBiCG':
            uasmootherCombo.set_sensitive(0)
            uagamgsmootherCombo.set_sensitive(0);uapresweepEntry.set_sensitive(0)
            uapostsweepEntry.set_sensitive(0);uaaggloCombo.set_sensitive(0)
            uancellsEntry.set_sensitive(0);uamergeEntry.set_sensitive(0);uacacheCB.set_sensitive(0)
            uapreconCombo.set_sensitive(1)  
        else:
            uasmootherCombo.set_sensitive(0)
            uagamgsmootherCombo.set_sensitive(1);uapresweepEntry.set_sensitive(1)
            uapostsweepEntry.set_sensitive(1);uaaggloCombo.set_sensitive(1)
            uancellsEntry.set_sensitive(1);uamergeEntry.set_sensitive(1);uacacheCB.set_sensitive(1)
            uapreconCombo.set_sensitive(0) 

        setSavedValueAdv()

        win.show_all()
    #-------------------------------------------------------------------------------------------------      
    def tursolverAdv(self,tursolver):        

        GEN=generalClass(self.caseDir)
        
        def applythis(widget):
            turAdvDict={}
            turAdvDict['minIter']=kaminIterEntry.get_text()
            if GEN.isNumber(turAdvDict['minIter'])==False:GEN.makeDialog('Error!!! minIter is not number')            
            turAdvDict['maxIter']=kamaxIterEntry.get_text()
            if GEN.isNumber(turAdvDict['maxIter'])==False:GEN.makeDialog('Error!!! maxIter is not number')            
            aa=kapreconCombo.child;turAdvDict['PCGPreconditioner']=aa.get_text();
            aa=kasmootherCombo.child;turAdvDict['smoothSmoother']=aa.get_text()
            aa=kagamgsmootherCombo.child;turAdvDict['GAMGSmoother']=aa.get_text()
            turAdvDict['GAMGnPreSweeps']=kapresweepEntry.get_text()
            if GEN.isNumber(turAdvDict['GAMGnPreSweeps'])==False:GEN.makeDialog('Error!!! GAMGnPreSweeps is not number')            
            turAdvDict['GAMGnPostSweeps']=kapostsweepEntry.get_text()
            if GEN.isNumber(turAdvDict['GAMGnPostSweeps'])==False:GEN.makeDialog('Error!!! GAMGnPostSweeps is not number')            
            if kacacheCB.get_active()==True:turAdvDict['GAMGcache']='true'
            else:turAdvDict['GAMGcache']='False'
            aa=kaaggloCombo.child;turAdvDict['GAMGagglomerator']=aa.get_text()
            turAdvDict['GAMGnCellsInCoarsestLevel']=kancellsEntry.get_text()
            if GEN.isNumber(turAdvDict['GAMGnCellsInCoarsestLevel'])==False:GEN.makeDialog('Error!!! GAMGnCellsInCoarsestLevel is not number')            
            turAdvDict['GAMGmergeLevels']=kamergeEntry.get_text()
            if GEN.isNumber(turAdvDict['GAMGmergeLevels'])==False:GEN.makeDialog('Error!!! GAMGmergeLevels is not number')            
            turAdvDict['finalTol']=kafinaltolEntry.get_text()
            if GEN.isNumber(turAdvDict['finalTol'])==False:GEN.makeDialog('Error!!! finalTol is not number')            
            turAdvDict['finalRelTol']=kafinalreltolEntry.get_text()
            if GEN.isNumber(turAdvDict['finalRelTol'])==False:GEN.makeDialog('Error!!! finalRelTol is not number')
            
            keys=turAdvDict.keys()
            f=open(self.caseDir+'/system/settings/fvSolution_turAdv','w')
            for ii in keys:f.write(ii+';'+turAdvDict[ii]+'\n')
            f.close()
            win.destroy();self.openSubWindow=False

        def closethis(widget):
            win.destroy();self.openSubWindow=False

        def setSavedValueAdv():
            sfile=glob.glob(self.caseDir+'/system/settings/fvSolution_turAdv')
            if len(sfile)!=0:
                dic=GEN.makeDictFromFile(sfile[0])
                kaminIterEntry.set_text(dic['minIter']);kamaxIterEntry.set_text(dic['maxIter'])
                aaa=kapreconList.index(dic['PCGPreconditioner']);kapreconCombo.set_active(aaa)
                aaa=kasmootherList.index(dic['smoothSmoother']);kasmootherCombo.set_active(aaa)
                aaa=kasmootherList.index(dic['GAMGSmoother']);kagamgsmootherCombo.set_active(aaa)
                kapresweepEntry.set_text(dic['GAMGnPreSweeps']);kapostsweepEntry.set_text(dic['GAMGnPostSweeps'])
                if dic['GAMGcache']=='true':kacacheCB.set_active(1)
                else:kacacheCB.set_active(0)
                aaa=kaaggloList.index(dic['GAMGagglomerator']);kaaggloCombo.set_active(aaa)
                kancellsEntry.set_text(dic['GAMGnCellsInCoarsestLevel']);kamergeEntry.set_text(dic['GAMGmergeLevels'])
                kafinaltolEntry.set_text(dic['finalTol']);kafinalreltolEntry.set_text(dic['finalRelTol'])

        def setDefaultTur(widget):
            kaminIterEntry.set_text('1');kamaxIterEntry.set_text('100')
            kapreconCombo.set_active(0);kasmootherCombo.set_active(1)
            kagamgsmootherCombo.set_active(1);kapresweepEntry.set_text('0');kapostsweepEntry.set_text('2')
            kacacheCB.set_active(1);kaaggloCombo.set_active(0);kancellsEntry.set_text('10');kamergeEntry.set_text('1')

        self.openSubWindow=True
        
        win=gtk.Window(gtk.WINDOW_TOPLEVEL);win.set_title('h and turb. solver advanced')
        win.set_border_width(5);win.set_position(gtk.WIN_POS_CENTER);win.set_transient_for(self.mainwindow)
        vbox=gtk.VBox(False,5);win.add(vbox)
        kaframe=gtk.Frame();kaframe.set_shadow_type(gtk.SHADOW_ETCHED_OUT);vbox.pack_start(kaframe,False,False,5)
        kahbox=gtk.HBox(True,5);kaframe.add(kahbox)
        kavbox=gtk.VBox(False,5);kahbox.pack_start(kavbox,False,False,5)

        label=gtk.Label('minIter')
        kaminIterEntry=gtk.Entry();kaminIterEntry.set_size_request(100,28);kaminIterEntry.set_text('1')	    
        kaminIterbox=gtk.HBox(False,5);kavbox.pack_start(kaminIterbox,False,False,5)
        kaminIterbox.pack_start(label,False,False,5);kaminIterbox.pack_end(kaminIterEntry,False,False,5)	    

        label=gtk.Label('maxIter')
        kamaxIterEntry=gtk.Entry();kamaxIterEntry.set_size_request(100,28);kamaxIterEntry.set_text('100')	    
        kamaxIterbox=gtk.HBox(False,5);kavbox.pack_start(kamaxIterbox,False,False,5)
        kamaxIterbox.pack_start(label,False,False,5);kamaxIterbox.pack_end(kamaxIterEntry,False,False,5)	
        # PBiCG
        pbicgframe=gtk.Frame();pbicgframe.set_label('  PBiCG  ');pbicgframe.set_label_align(0.1, 0.5)
        pbicgframe.set_shadow_type(gtk.SHADOW_ETCHED_OUT);kavbox.pack_start(pbicgframe,False,False,5)

        pbicghbox=gtk.HBox(True,5);pbicgframe.add(pbicghbox)
        pbicgvbox=gtk.VBox(False,5);pbicghbox.pack_end(pbicgvbox,True,True,5)

        label=gtk.Label('preconditioner')
        kapreconCombo=gtk.combo_box_entry_new_text();kapreconCombo.set_size_request(120,28)
        kapreconList=['DILU','GAMG','diagonal','none']
        for ii in kapreconList:kapreconCombo.append_text(ii) 
        kapreconCombo.set_active(0)
        kapreconbox=gtk.HBox(False,5);pbicgvbox.pack_start(kapreconbox,False,False,5)
        kapreconbox.pack_start(label,False,False,5);kapreconbox.pack_end(kapreconCombo,False,False,5)
        # smoothSolver
        smoothframe=gtk.Frame();smoothframe.set_label('  smoothSolver  ');smoothframe.set_label_align(0.1, 0.5)
        smoothframe.set_shadow_type(gtk.SHADOW_ETCHED_OUT);kavbox.pack_start(smoothframe,False,False,5)

        smoothhbox=gtk.HBox(True,5);smoothframe.add(smoothhbox)
        smoothvbox=gtk.VBox(False,5);smoothhbox.pack_end(smoothvbox,True,True,5)

        label=gtk.Label('smoother')
        kasmootherCombo=gtk.combo_box_entry_new_text();kasmootherCombo.set_size_request(120,28)
        kasmootherList=['GaussSeidel','symGaussSeidel','DILU','DILUGaussSeidel','nonBlockingGaussSeidel']
        for ii in kasmootherList:kasmootherCombo.append_text(ii) 
        kasmootherCombo.set_active(1)
        kasmootherbox=gtk.HBox(False,5);smoothvbox.pack_start(kasmootherbox,False,False,5)
        kasmootherbox.pack_start(label,False,False,5);kasmootherbox.pack_end(kasmootherCombo,False,False,5)	
        # GAMG
        gamgframe=gtk.Frame();gamgframe.set_label('  GAMG  ');gamgframe.set_label_align(0.1, 0.5)
        gamgframe.set_shadow_type(gtk.SHADOW_ETCHED_OUT);kavbox.pack_start(gamgframe,False,False,5)

        gamghbox=gtk.HBox(True,5);gamgframe.add(gamghbox)
        gamgvbox=gtk.VBox(False,5);gamghbox.pack_start(gamgvbox,False,False,5)

        label=gtk.Label('smoother')
        kagamgsmootherCombo=gtk.combo_box_entry_new_text();kagamgsmootherCombo.set_size_request(120,28)
        kasmootherList=['GaussSeidel','symGaussSeidel','DILU','DILUGaussSeidel','nonBlockingGaussSeidel']
        for ii in kasmootherList:kagamgsmootherCombo.append_text(ii) 
        kagamgsmootherCombo.set_active(1)
        kasmootherbox=gtk.HBox(False,5);gamgvbox.pack_start(kasmootherbox,False,False,5)
        kasmootherbox.pack_start(label,False,False,5);kasmootherbox.pack_end(kagamgsmootherCombo,False,False,5)	

        label=gtk.Label('nPreSweeps')
        kapresweepEntry=gtk.Entry();kapresweepEntry.set_size_request(100,28);kapresweepEntry.set_text('0')	    
        kapresweepbox=gtk.HBox(False,5);gamgvbox.pack_start(kapresweepbox,False,False,5)
        kapresweepbox.pack_start(label,False,False,5);kapresweepbox.pack_end(kapresweepEntry,False,False,5)	

        label=gtk.Label('nPostSweeps')
        kapostsweepEntry=gtk.Entry();kapostsweepEntry.set_size_request(100,28);kapostsweepEntry.set_text('2')	    
        kapostsweepbox=gtk.HBox(False,5);gamgvbox.pack_start(kapostsweepbox,False,False,5)
        kapostsweepbox.pack_start(label,False,False,5);kapostsweepbox.pack_end(kapostsweepEntry,False,False,5)

        kacacheCB=gtk.CheckButton('cacheAgglomeration');kacacheCB.set_active(1)	    
        kacachebox=gtk.HBox(False,5);gamgvbox.pack_start(kacachebox,False,False,5)
        kacachebox.pack_start(kacacheCB,False,False,5)

        label=gtk.Label('agglomerator')
        kaaggloCombo=gtk.combo_box_entry_new_text();kaaggloCombo.set_size_request(120,28)
        kaaggloList=['faceAreaPair']
        for ii in kaaggloList:kaaggloCombo.append_text(ii) 
        kaaggloCombo.set_active(0)
        kaagglobox=gtk.HBox(False,5);gamgvbox.pack_start(kaagglobox,False,False,5)
        kaagglobox.pack_start(label,False,False,5);kaagglobox.pack_end(kaaggloCombo,False,False,5)

        label=gtk.Label('nCellsInCoarsestLevel')
        kancellsEntry=gtk.Entry();kancellsEntry.set_size_request(100,28);kancellsEntry.set_text('10')	    
        kancellsbox=gtk.HBox(False,5);gamgvbox.pack_start(kancellsbox,False,False,5)
        kancellsbox.pack_start(label,False,False,5);kancellsbox.pack_end(kancellsEntry,False,False,5)

        label=gtk.Label('mergeLevels')
        kamergeEntry=gtk.Entry();kamergeEntry.set_size_request(100,28);kamergeEntry.set_text('1')	    
        kamergebox=gtk.HBox(False,5);gamgvbox.pack_start(kamergebox,False,False,5)
        kamergebox.pack_start(label,False,False,5);kamergebox.pack_end(kamergeEntry,False,False,5)

        finalframe=gtk.Frame();finalframe.set_label('  turFinal  ');finalframe.set_label_align(0.1, 0.5)
        finalframe.set_shadow_type(gtk.SHADOW_ETCHED_OUT);kavbox.pack_start(finalframe,False,False,5)

        finalbox=gtk.HBox(True,5);finalframe.add(finalbox)
        finalvbox=gtk.VBox(False,5);finalbox.pack_start(finalvbox,True,True,5)

        label=gtk.Label('tolerance')
        kafinaltolEntry=gtk.Entry();kafinaltolEntry.set_size_request(100,28);kafinaltolEntry.set_text('1e-7')
        kafinaltolbox=gtk.HBox(False,5);finalvbox.pack_start(kafinaltolbox,False,False,2)
        kafinaltolbox.pack_start(label,False,False,5);kafinaltolbox.pack_end(kafinaltolEntry,False,False,5)

        label=gtk.Label('relTol')
        kafinalreltolEntry=gtk.Entry();kafinalreltolEntry.set_size_request(100,28);kafinalreltolEntry.set_text('0.1')
        kafinalreltolbox=gtk.HBox(False,5);finalvbox.pack_start(kafinalreltolbox,False,False,2)
        kafinalreltolbox.pack_start(label,False,False,5);kafinalreltolbox.pack_end(kafinalreltolEntry,False,False,5)

        buttonbox=gtk.HBox(False,5)
        kavbox.pack_start(buttonbox,False,False,5)
        app=gtk.Button(label='Apply');app.set_size_request(80,30)
        cll=gtk.Button(label='Close');cll.set_size_request(80,30)
        default=gtk.Button('Default');default.set_size_request(80,30)
        app.connect('clicked',applythis);cll.connect('clicked',closethis);default.connect('clicked',setDefaultTur)
        buttonbox.pack_end(cll,True,True,5);buttonbox.pack_end(default,True,True,5);buttonbox.pack_end(app,True,True,5)  

        if tursolver=='smoothSolver':  
            kasmootherCombo.set_sensitive(1)
            kagamgsmootherCombo.set_sensitive(0);kapresweepEntry.set_sensitive(0)
            kapostsweepEntry.set_sensitive(0);kaaggloCombo.set_sensitive(0)
            kancellsEntry.set_sensitive(0);kamergeEntry.set_sensitive(0);kacacheCB.set_sensitive(0)
            kapreconCombo.set_sensitive(0)
        elif tursolver=='PBiCG':
            kasmootherCombo.set_sensitive(0)
            kagamgsmootherCombo.set_sensitive(0);kapresweepEntry.set_sensitive(0)
            kapostsweepEntry.set_sensitive(0);kaaggloCombo.set_sensitive(0)
            kancellsEntry.set_sensitive(0);kamergeEntry.set_sensitive(0);kacacheCB.set_sensitive(0)
            kapreconCombo.set_sensitive(1)  
        else:
            kasmootherCombo.set_sensitive(0)
            kagamgsmootherCombo.set_sensitive(1);kapresweepEntry.set_sensitive(1)
            kapostsweepEntry.set_sensitive(1);kaaggloCombo.set_sensitive(1)
            kancellsEntry.set_sensitive(1);kamergeEntry.set_sensitive(1);kacacheCB.set_sensitive(1)
            kapreconCombo.set_sensitive(0) 

        setSavedValueAdv()

        win.show_all()
    #-------------------------------------------------------------------------------------------------      
    def ysolverAdv(self,ysolver):        

        GEN=generalClass(self.caseDir)
        
        def applythis(widget):
            yAdvDict={}
            yAdvDict['minIter']=yaminIterEntry.get_text()
            if GEN.isNumber(yAdvDict['minIter'])==False:GEN.makeDialog('Error!!! minIter is not number')            
            yAdvDict['maxIter']=yamaxIterEntry.get_text()
            if GEN.isNumber(yAdvDict['maxIter'])==False:GEN.makeDialog('Error!!! maxIter is not number')            
            aa=yapreconCombo.child;yAdvDict['PCGPreconditioner']=aa.get_text();
            aa=yasmootherCombo.child;yAdvDict['smoothSmoother']=aa.get_text()
            aa=yagamgsmootherCombo.child;yAdvDict['GAMGSmoother']=aa.get_text()
            yAdvDict['GAMGnPreSweeps']=yapresweepEntry.get_text()
            if GEN.isNumber(yAdvDict['GAMGnPreSweeps'])==False:GEN.makeDialog('Error!!! GAMGnPreSweeps is not number')            
            yAdvDict['GAMGnPostSweeps']=yapostsweepEntry.get_text()
            if GEN.isNumber(yAdvDict['GAMGnPostSweeps'])==False:GEN.makeDialog('Error!!! GAMGnPostSweeps is not number')            
            if yacacheCB.get_active()==True:yAdvDict['GAMGcache']='true'
            else:yAdvDict['GAMGcache']='False'
            aa=yaaggloCombo.child;yAdvDict['GAMGagglomerator']=aa.get_text()
            yAdvDict['GAMGnCellsInCoarsestLevel']=yancellsEntry.get_text()
            if GEN.isNumber(yAdvDict['GAMGnCellsInCoarsestLevel'])==False:GEN.makeDialog('Error!!! GAMGnCellsInCoarsestLevel is not number')            
            yAdvDict['GAMGmergeLevels']=yamergeEntry.get_text()
            if GEN.isNumber(yAdvDict['GAMGmergeLevels'])==False:GEN.makeDialog('Error!!! GAMGmergeLevels is not number')            
            yAdvDict['finalTol']=yafinaltolEntry.get_text()
            if GEN.isNumber(yAdvDict['finalTol'])==False:GEN.makeDialog('Error!!! finalTol is not number')            
            yAdvDict['finalRelTol']=yafinalreltolEntry.get_text()
            if GEN.isNumber(yAdvDict['finalRelTol'])==False:GEN.makeDialog('Error!!! finalRelTol is not number')
            
            keys=yAdvDict.keys()
            f=open(self.caseDir+'/system/settings/fvSolution_yAdv','w')
            for ii in keys:f.write(ii+';'+yAdvDict[ii]+'\n')
            f.close()
            win.destroy();self.openSubWindow=False

        def closethis(widget):
            win.destroy();self.openSubWindow=False

        def setSavedValueAdv():
            sfile=glob.glob(self.caseDir+'/system/settings/fvSolution_yAdv')
            if len(sfile)!=0:
                dic=GEN.makeDictFromFile(sfile[0])
                yaminIterEntry.set_text(dic['minIter']);yamaxIterEntry.set_text(dic['maxIter'])
                aaa=yapreconList.index(dic['PCGPreconditioner']);yapreconCombo.set_active(aaa)
                aaa=yasmootherList.index(dic['smoothSmoother']);yasmootherCombo.set_active(aaa)
                aaa=yasmootherList.index(dic['GAMGSmoother']);yagamgsmootherCombo.set_active(aaa)
                yapresweepEntry.set_text(dic['GAMGnPreSweeps']);yapostsweepEntry.set_text(dic['GAMGnPostSweeps'])
                if dic['GAMGcache']=='true':yacacheCB.set_active(1)
                else:yacacheCB.set_active(0)
                aaa=yaaggloList.index(dic['GAMGagglomerator']);yaaggloCombo.set_active(aaa)
                yancellsEntry.set_text(dic['GAMGnCellsInCoarsestLevel']);yamergeEntry.set_text(dic['GAMGmergeLevels'])
                yafinaltolEntry.set_text(dic['finalTol']);yafinalreltolEntry.set_text(dic['finalRelTol'])

        def setDefaulty(widget):
            yaminIterEntry.set_text('2');yamaxIterEntry.set_text('100')
            yapreconCombo.set_active(0);yasmootherCombo.set_active(1)
            yagamgsmootherCombo.set_active(1);yapresweepEntry.set_text('0');yapostsweepEntry.set_text('2')
            yacacheCB.set_active(1);yaaggloCombo.set_active(0);yancellsEntry.set_text('10');yamergeEntry.set_text('1')

        self.openSubWindow=True
        
        win=gtk.Window(gtk.WINDOW_TOPLEVEL);win.set_title('alpha solver advanced')
        win.set_border_width(5);win.set_position(gtk.WIN_POS_CENTER);win.set_transient_for(self.mainwindow)
        vbox=gtk.VBox(False,5);win.add(vbox)
        yaframe=gtk.Frame();yaframe.set_shadow_type(gtk.SHADOW_ETCHED_OUT);vbox.pack_start(yaframe,False,False,5)
        yahbox=gtk.HBox(True,5);yaframe.add(yahbox)
        yavbox=gtk.VBox(False,5);yahbox.pack_start(yavbox,False,False,5)

        label=gtk.Label('minIter')
        yaminIterEntry=gtk.Entry();yaminIterEntry.set_size_request(100,28);yaminIterEntry.set_text('2')	    
        yaminIterbox=gtk.HBox(False,5);yavbox.pack_start(yaminIterbox,False,False,5)
        yaminIterbox.pack_start(label,False,False,5);yaminIterbox.pack_end(yaminIterEntry,False,False,5)	    

        label=gtk.Label('maxIter')
        yamaxIterEntry=gtk.Entry();yamaxIterEntry.set_size_request(100,28);yamaxIterEntry.set_text('100')	    
        yamaxIterbox=gtk.HBox(False,5);yavbox.pack_start(yamaxIterbox,False,False,5)
        yamaxIterbox.pack_start(label,False,False,5);yamaxIterbox.pack_end(yamaxIterEntry,False,False,5)	
        # PBiCG
        pbicgframe=gtk.Frame();pbicgframe.set_label('  PBiCG  ');pbicgframe.set_label_align(0.1, 0.5)
        pbicgframe.set_shadow_type(gtk.SHADOW_ETCHED_OUT);yavbox.pack_start(pbicgframe,False,False,5)

        pbicghbox=gtk.HBox(True,5);pbicgframe.add(pbicghbox)
        pbicgvbox=gtk.VBox(False,5);pbicghbox.pack_end(pbicgvbox,True,True,5)

        label=gtk.Label('preconditioner')
        yapreconCombo=gtk.combo_box_entry_new_text();yapreconCombo.set_size_request(120,28)
        yapreconList=['DILU','GAMG','diagonal','none']
        for ii in yapreconList:yapreconCombo.append_text(ii) 
        yapreconCombo.set_active(0)
        yapreconbox=gtk.HBox(False,5);pbicgvbox.pack_start(yapreconbox,False,False,5)
        yapreconbox.pack_start(label,False,False,5);yapreconbox.pack_end(yapreconCombo,False,False,5)
        # smoothSolver
        smoothframe=gtk.Frame();smoothframe.set_label('  smoothSolver  ');smoothframe.set_label_align(0.1, 0.5)
        smoothframe.set_shadow_type(gtk.SHADOW_ETCHED_OUT);yavbox.pack_start(smoothframe,False,False,5)

        smoothhbox=gtk.HBox(True,5);smoothframe.add(smoothhbox)
        smoothvbox=gtk.VBox(False,5);smoothhbox.pack_end(smoothvbox,True,True,5)

        label=gtk.Label('smoother')
        yasmootherCombo=gtk.combo_box_entry_new_text();yasmootherCombo.set_size_request(120,28)
        yasmootherList=['GaussSeidel','symGaussSeidel','DILU','DILUGaussSeidel','nonBlockingGaussSeidel']
        for ii in yasmootherList:yasmootherCombo.append_text(ii) 
        yasmootherCombo.set_active(1)
        yasmootherbox=gtk.HBox(False,5);smoothvbox.pack_start(yasmootherbox,False,False,5)
        yasmootherbox.pack_start(label,False,False,5);yasmootherbox.pack_end(yasmootherCombo,False,False,5)	
        # GAMG
        gamgframe=gtk.Frame();gamgframe.set_label('  GAMG  ');gamgframe.set_label_align(0.1, 0.5)
        gamgframe.set_shadow_type(gtk.SHADOW_ETCHED_OUT);yavbox.pack_start(gamgframe,False,False,5)

        gamghbox=gtk.HBox(True,5);gamgframe.add(gamghbox)
        gamgvbox=gtk.VBox(False,5);gamghbox.pack_start(gamgvbox,False,False,5)

        label=gtk.Label('smoother')
        yagamgsmootherCombo=gtk.combo_box_entry_new_text();yagamgsmootherCombo.set_size_request(120,28)
        yasmootherList=['GaussSeidel','symGaussSeidel','DILU','DILUGaussSeidel','nonBlockingGaussSeidel']
        for ii in yasmootherList:yagamgsmootherCombo.append_text(ii) 
        yagamgsmootherCombo.set_active(1)
        yasmootherbox=gtk.HBox(False,5);gamgvbox.pack_start(yasmootherbox,False,False,5)
        yasmootherbox.pack_start(label,False,False,5);yasmootherbox.pack_end(yagamgsmootherCombo,False,False,5)	

        label=gtk.Label('nPreSweeps')
        yapresweepEntry=gtk.Entry();yapresweepEntry.set_size_request(100,28);yapresweepEntry.set_text('0')	    
        yapresweepbox=gtk.HBox(False,5);gamgvbox.pack_start(yapresweepbox,False,False,5)
        yapresweepbox.pack_start(label,False,False,5);yapresweepbox.pack_end(yapresweepEntry,False,False,5)	

        label=gtk.Label('nPostSweeps')
        yapostsweepEntry=gtk.Entry();yapostsweepEntry.set_size_request(100,28);yapostsweepEntry.set_text('2')	    
        yapostsweepbox=gtk.HBox(False,5);gamgvbox.pack_start(yapostsweepbox,False,False,5)
        yapostsweepbox.pack_start(label,False,False,5);yapostsweepbox.pack_end(yapostsweepEntry,False,False,5)

        yacacheCB=gtk.CheckButton('cacheAgglomeration');yacacheCB.set_active(1)	    
        yacachebox=gtk.HBox(False,5);gamgvbox.pack_start(yacachebox,False,False,5)
        yacachebox.pack_start(yacacheCB,False,False,5)

        label=gtk.Label('agglomerator')
        yaaggloCombo=gtk.combo_box_entry_new_text();yaaggloCombo.set_size_request(120,28)
        yaaggloList=['faceAreaPair']
        for ii in yaaggloList:yaaggloCombo.append_text(ii) 
        yaaggloCombo.set_active(0)
        yaagglobox=gtk.HBox(False,5);gamgvbox.pack_start(yaagglobox,False,False,5)
        yaagglobox.pack_start(label,False,False,5);yaagglobox.pack_end(yaaggloCombo,False,False,5)

        label=gtk.Label('nCellsInCoarsestLevel')
        yancellsEntry=gtk.Entry();yancellsEntry.set_size_request(100,28);yancellsEntry.set_text('10')	    
        yancellsbox=gtk.HBox(False,5);gamgvbox.pack_start(yancellsbox,False,False,5)
        yancellsbox.pack_start(label,False,False,5);yancellsbox.pack_end(yancellsEntry,False,False,5)

        label=gtk.Label('mergeLevels')
        yamergeEntry=gtk.Entry();yamergeEntry.set_size_request(100,28);yamergeEntry.set_text('1')	    
        yamergebox=gtk.HBox(False,5);gamgvbox.pack_start(yamergebox,False,False,5)
        yamergebox.pack_start(label,False,False,5);yamergebox.pack_end(yamergeEntry,False,False,5)

        finalframe=gtk.Frame();finalframe.set_label('  alphaFinal  ');finalframe.set_label_align(0.1, 0.5)
        finalframe.set_shadow_type(gtk.SHADOW_ETCHED_OUT);yavbox.pack_start(finalframe,False,False,5)

        finalbox=gtk.HBox(True,5);finalframe.add(finalbox)
        finalvbox=gtk.VBox(False,5);finalbox.pack_start(finalvbox,True,True,5)

        label=gtk.Label('tolerance')
        yafinaltolEntry=gtk.Entry();yafinaltolEntry.set_size_request(100,28);yafinaltolEntry.set_text('1e-8')
        yafinaltolbox=gtk.HBox(False,5);finalvbox.pack_start(yafinaltolbox,False,False,2)
        yafinaltolbox.pack_start(label,False,False,5);yafinaltolbox.pack_end(yafinaltolEntry,False,False,5)
        yafinaltolEntry.set_sensitive(0)

        label=gtk.Label('relTol')
        yafinalreltolEntry=gtk.Entry();yafinalreltolEntry.set_size_request(100,28);yafinalreltolEntry.set_text('0')
        yafinalreltolbox=gtk.HBox(False,5);finalvbox.pack_start(yafinalreltolbox,False,False,2)
        yafinalreltolbox.pack_start(label,False,False,5);yafinalreltolbox.pack_end(yafinalreltolEntry,False,False,5)
        yafinalreltolEntry.set_sensitive(0)

        buttonbox=gtk.HBox(False,5)
        yavbox.pack_start(buttonbox,False,False,5)
        app=gtk.Button(label='Apply');app.set_size_request(80,30)
        cll=gtk.Button(label='Close');cll.set_size_request(80,30)
        default=gtk.Button('Default');default.set_size_request(80,30)
        app.connect('clicked',applythis);cll.connect('clicked',closethis);default.connect('clicked',setDefaulty)
        buttonbox.pack_end(cll,True,True,5);buttonbox.pack_end(default,True,True,5);buttonbox.pack_end(app,True,True,5)  

        if ysolver=='smoothSolver':  
            yasmootherCombo.set_sensitive(1)
            yagamgsmootherCombo.set_sensitive(0);yapresweepEntry.set_sensitive(0)
            yapostsweepEntry.set_sensitive(0);yaaggloCombo.set_sensitive(0)
            yancellsEntry.set_sensitive(0);yamergeEntry.set_sensitive(0);yacacheCB.set_sensitive(0)
            yapreconCombo.set_sensitive(0)
        elif ysolver=='PBiCG':
            yasmootherCombo.set_sensitive(0)
            yagamgsmootherCombo.set_sensitive(0);yapresweepEntry.set_sensitive(0)
            yapostsweepEntry.set_sensitive(0);yaaggloCombo.set_sensitive(0)
            yancellsEntry.set_sensitive(0);yamergeEntry.set_sensitive(0);yacacheCB.set_sensitive(0)
            yapreconCombo.set_sensitive(1)  
        else:
            yasmootherCombo.set_sensitive(0)
            yagamgsmootherCombo.set_sensitive(1);yapresweepEntry.set_sensitive(1)
            yapostsweepEntry.set_sensitive(1);yaaggloCombo.set_sensitive(1)
            yancellsEntry.set_sensitive(1);yamergeEntry.set_sensitive(1);yacacheCB.set_sensitive(1)
            yapreconCombo.set_sensitive(0) 

        setSavedValueAdv()

        win.show_all() 
    #--------------------------------------------------------------------------------------  
    def foamComment(self):
        fc=[]
        fc.append('/*--------------------------------*- C++ -*----------------------------------*\ \n')
        fc.append('| =========                 |                                                 |\n')
        fc.append('| \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox           |\n')
        fc.append('|  \\    /   O peration     | Version:  2.3.0                                 |\n')
        fc.append('|   \\  /    A nd           | Web:      www.OpenFOAM.org                      |\n')
        fc.append('|    \\/     M anipulation  |                                                 |\n')
        fc.append('\*---------------------------------------------------------------------------*/\n')	
        return fc
    #------------------------------------------------------------------------------
    def header(self,location,obj):
        he=[]
        he.append('FoamFile\n')
        he.append('{\n')
        he.append('    version     2.0;\n')
        he.append('    format      ascii;\n')
        he.append('    class       dictionary;\n')
        he.append('    location    "'+location+'";\n')
        he.append('    object      '+obj+';\n')
        he.append('}\n')
        he.append('// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //\n')
        return he                       
    #------------------------------------------------------------------------------
    def createFvSolutionFile(self,fvSolutionDict,pAdvDict,UAdvDict,turAdvDict,yAdvDict,refpoint,refx,refy,refz,refValue):

        fcom=self.foamComment();head=self.header('system','fvSolution');hhh=fcom+head
        f=open(self.caseDir+'/system/fvSolution','w')
        for aaa in hhh:f.write(aaa)

        savedvof=glob.glob(self.caseDir+'/system/fvSolutionAlpha')
        if len(savedvof)!=0:f.write('#include    "fvSolutionAlpha" \n')

        f.write('solvers\n')
        f.write('{\n')

        f.write('    "alpha.water.*" \n')
        f.write('    { \n')
        
        if len(savedvof)==0:
            f.write('        nAlphaCorr          1;\n')
            f.write('        nAlphaSubCycles     3;\n')
            f.write('        cAlpha              0.2;\n')
            f.write('        icAlpha             0.0;\n')
            f.write('        MULESCorr           yes;\n')
            f.write('        nLimiterIter        5;\n')
            f.write('        alphaApplyPrevCorr  yes;\n')
        else:
            f.write('        nAlphaCorr          $nAlphaCorr;\n')
            f.write('        nAlphaSubCycles     $nAlphaSubCycles;\n')
            f.write('        cAlpha              $cAlpha;\n')
            f.write('        icAlpha             $icAlpha;\n')
            f.write('        MULESCorr           $MULESCorr;\n')
            f.write('        nLimiterIter        $nLimiterIter;\n')
            f.write('        alphaApplyPrevCorr  $alphaApplyPrevCorr;\n')

        f.write('        solver        '+fvSolutionDict['ysolver']+';\n')
        f.write('        tolerance     '+fvSolutionDict['ytolerance']+';\n')
        f.write('        relTol        '+fvSolutionDict['yrelTol']+';\n')
        f.write('        minAlpha      0;\n')
        f.write('        maxAlpha      1;\n')
        f.write('        minIter       '+yAdvDict['minIter']+';\n')
        f.write('        maxIter       '+yAdvDict['maxIter']+';\n')
        if fvSolutionDict['ysolver']=='smoothSolver':
            f.write('        smoother      '+yAdvDict['smoothSmoother']+';\n')
        elif fvSolutionDict['ysolver']=='PBiCG':
            f.write('        preconditioner '+yAdvDict['PCGPreconditioner']+';\n')
        elif fvSolutionDict['ysolver']=='GAMG':
            f.write('        smoother              '+yAdvDict['GAMGSmoother']+';\n')
            f.write('        nPreSweeps            '+yAdvDict['GAMGnPreSweeps']+';\n')
            f.write('        nPostSweeps           '+yAdvDict['GAMGnPostSweeps']+';\n')
            f.write('        cacheAgglomeration    '+yAdvDict['GAMGcache']+';\n')
            f.write('        agglomerator          '+yAdvDict['GAMGagglomerator']+';\n')
            f.write('        nCellsInCoarsestLevel '+yAdvDict['GAMGnCellsInCoarsestLevel']+';\n')
            f.write('        mergeLevels           '+yAdvDict['GAMGmergeLevels']+';\n')
        f.write('    } \n')        

        f.write('    "pcorr.*" \n')
        f.write('    { \n')
        f.write('        solver          PCG; \n')
        f.write('        preconditioner \n')
        f.write('        { \n')
        f.write('            preconditioner  GAMG; \n')
        f.write('            smoother        GaussSeidel; \n')
        f.write('            agglomerator    faceAreaPair; \n')
        f.write('            mergeLevels     1; \n')
        f.write('            nCellsInCoarsestLevel 10; \n')
        f.write('            cacheAgglomeration true; \n')
        f.write('            tolerance       1e-5; \n')
        f.write('            relTol          0; \n')
        #f.write('            minIter         1; \n')
        f.write('        }; \n')
        f.write('        tolerance       1e-5; \n')
        f.write('        relTol          0; \n')
        f.write('        minIter         2; \n')
        f.write('        maxIter         200;\n')
        f.write('    }; \n')

        f.write('    "(p|p_rgh)" \n')
        f.write('    {\n')
        f.write('        solver                '+fvSolutionDict['psolver']+';\n')
        f.write('        tolerance             '+fvSolutionDict['ptolerance']+';\n')
        f.write('        relTol                '+fvSolutionDict['prelTol']+';\n')
        f.write('        minIter               '+pAdvDict['minIter']+';\n')
        f.write('        maxIter               '+pAdvDict['maxIter']+';\n')
        if fvSolutionDict['psolver']=='GAMG':
            f.write('        smoother              '+pAdvDict['GAMGSmoother']+';\n')
            f.write('        nPreSweeps            '+pAdvDict['GAMGnPreSweeps']+';\n')
            f.write('        nPostSweeps           '+pAdvDict['GAMGnPostSweeps']+';\n')
            f.write('        cacheAgglomeration    '+pAdvDict['GAMGcache']+';\n')
            f.write('        agglomerator          '+pAdvDict['GAMGagglomerator']+';\n')
            f.write('        nCellsInCoarsestLevel '+pAdvDict['GAMGnCellsInCoarsestLevel']+';\n')
            f.write('        mergeLevels           '+pAdvDict['GAMGmergeLevels']+';\n')
        elif fvSolutionDict['psolver']=='PCG':
            if pAdvDict['PCGPreconditioner']!='GAMG':
                f.write('        preconditioner        '+pAdvDict['PCGPreconditioner']+';\n')
            elif pAdvDict['PCGPreconditioner']=='GAMG':
                f.write('        preconditioner\n')
        	f.write('        {\n')
        	f.write('            preconditioner        '+pAdvDict['PCGPreconditioner']+';\n')
        	f.write('            tolerance             '+fvSolutionDict['ptolerance']+';\n')
        	f.write('            relTol                '+fvSolutionDict['prelTol']+';\n')
        	f.write('            smoother              '+pAdvDict['GAMGSmoother']+';\n')
        	f.write('            nPreSweeps            '+pAdvDict['nPreSweeps']+';\n')
        	f.write('            nPostSweeps           '+pAdvDict['nPostSweeps']+';\n')
        	f.write('            cacheAgglomeration    '+pAdvDict['cacheAgglomeration']+';\n')
        	f.write('            agglomerator          '+pAdvDict['agglomerator']+';\n')
        	f.write('            nCellsInCoarsestLevel '+pAdvDict['nCellsInCoarsestLevel']+';\n')
        	f.write('            mergeLevels           '+pAdvDict['mergeLevels']+';\n')
        	f.write('        }\n')
        elif fvSolutionDict['psolver']=='smoothSolver':
            f.write('        smoother              '+pAdvDict['smoothSolverSmoother']+';\n')
        f.write('    }\n')

        f.write('    p_rghFinal\n')
        f.write('    {\n')
        f.write('        $p_rgh;\n')
        #f.write('        relTol        '+pAdvDict['pFinalRelTol']+';\n')
        #f.write('        minIter       1;\n')
        f.write('    }\n')	

        f.write('    U \n')
        f.write('    { \n')
        f.write('        solver        '+fvSolutionDict['usolver']+';\n')
        f.write('        tolerance     '+fvSolutionDict['utolerance']+';\n')
        f.write('        relTol        '+fvSolutionDict['urelTol']+';\n')
        f.write('        minIter       '+UAdvDict['minIter']+';\n')
        f.write('        maxIter       '+UAdvDict['maxIter']+';\n')
        if fvSolutionDict['usolver']=='smoothSolver':
            f.write('        smoother      '+UAdvDict['smoothSmoother']+';\n')
        elif fvSolutionDict['usolver']=='PBiCG' or fvSolutionDict['usolver']=='NEXT::PBiCG':
            f.write('        preconditioner '+UAdvDict['PCGPreconditioner']+';\n')
        elif fvSolutionDict['usolver']=='GAMG':
            f.write('        smoother              '+UAdvDict['GAMGSmoother']+';\n')
            f.write('        nPreSweeps            '+UAdvDict['GAMGnPreSweeps']+';\n')
            f.write('        nPostSweeps           '+UAdvDict['GAMGnPostSweeps']+';\n')
            f.write('        cacheAgglomeration    '+UAdvDict['GAMGcache']+';\n')
            f.write('        agglomerator          '+UAdvDict['GAMGagglomerator']+';\n')
            f.write('        nCellsInCoarsestLevel '+UAdvDict['GAMGnCellsInCoarsestLevel']+';\n')
            f.write('        mergeLevels           '+UAdvDict['GAMGmergeLevels']+';\n')
        f.write('    } \n')

        f.write('    UFinal \n')
        f.write('    { \n')
        f.write('        $U; \n')
        #f.write('        tolerance             '+UAdvDict['finalTol']+';\n')
        #f.write('        relTol                '+UAdvDict['finalRelTol']+';\n')
        f.write('    } \n')

        f.write('    "(k|epsilon|omega|nuTilda)" \n')
        f.write('    { \n')
        f.write('        solver        '+fvSolutionDict['tursolver']+';\n')
        f.write('        tolerance     '+fvSolutionDict['turtolerance']+';\n')
        f.write('        relTol        '+fvSolutionDict['turrelTol']+';\n')
        f.write('        minIter       '+turAdvDict['minIter']+';\n')
        f.write('        maxIter       '+turAdvDict['maxIter']+';\n')
        if fvSolutionDict['tursolver']=='smoothSolver' or fvSolutionDict['tursolver']=='NEXT::smoothSolver':
            f.write('        smoother      '+turAdvDict['smoothSmoother']+';\n')
        elif fvSolutionDict['tursolver']=='PBiCG' or fvSolutionDict['tursolver']=='NEXT::PBiCG':
            f.write('        preconditioner '+turAdvDict['PCGPreconditioner']+';\n')
        elif fvSolutionDict['tursolver']=='GAMG':
            f.write('        smoother              '+turAdvDict['GAMGSmoother']+';\n')
            f.write('        nPreSweeps            '+turAdvDict['GAMGnPreSweeps']+';\n')
            f.write('        nPostSweeps           '+turAdvDict['GAMGnPostSweeps']+';\n')
            f.write('        cacheAgglomeration    '+turAdvDict['GAMGcache']+';\n')
            f.write('        agglomerator          '+turAdvDict['GAMGagglomerator']+';\n')
            f.write('        nCellsInCoarsestLevel '+turAdvDict['GAMGnCellsInCoarsestLevel']+';\n')
            f.write('        mergeLevels           '+turAdvDict['GAMGmergeLevels']+';\n')
        f.write('    } \n')

        f.write('    "(k|epsilon|omega|nuTilda)Final" \n')
        f.write('    { \n')
        f.write('        $k; \n')
        #f.write('        tolerance             '+turAdvDict['finalTol']+';\n')
        #f.write('        relTol                '+turAdvDict['finalRelTol']+';\n')
        f.write('    } \n')
                
        f.write('} \n')

        f.write('potentialFlow\n')
        f.write('{\n')
        f.write('    nNonOrthogonalCorrectors 20;\n')
        if refpoint==0:
            f.write('    pRefCell                  0;\n')
        else:
            f.write('    pRefPoint                 ('+refx+' '+refy+' '+refz+');\n')
        f.write('    pRefValue                 '+refValue+';\n')
        f.write('}\n')

        f.write('SIMPLE \n')
        f.write('{\n')
        f.write('    nNonOrthogonalCorrectors  '+fvSolutionDict['nNonOrtho']+';\n')
        if refpoint==0:
            f.write('    pRefCell                  0;\n')
        else:
            f.write('    pRefPoint                 ('+refx+' '+refy+' '+refz+');\n')
        f.write('    pRefValue                 '+refValue+';\n')
        #f.write('    residualControl\n')
        #f.write('    {\n')	
        #f.write('        "(p|p_rgh)"          '+fvSolutionDict['convergep']+';\n')
        #f.write('        U                    '+fvSolutionDict['convergeu']+';\n')
        #f.write('        "(h|k|epsilon|omega|nuTilda|T)"  '+fvSolutionDict['convergetur']+';\n')
        #f.write('    }\n')
        f.write('}\n')

        f.write('PIMPLE\n')
        f.write('{\n')
        #f.write('    momentumPredictor         no;\n')
        f.write('    turbOnFinalIterOnly       false;\n')
        f.write('    nOuterCorrectors          '+fvSolutionDict['nOuterCorrectors']+';\n')
        f.write('    nCorrectors               '+fvSolutionDict['nCorrectors']+';\n')
        f.write('    nNonOrthogonalCorrectors  '+fvSolutionDict['nNonOrtho']+';\n')
        #f.write('    maxCo                     '+fvSolutionDict['maxCo']+';\n')
        #f.write('    maxAlphaCo                '+fvSolutionDict['maxAlphaCo']+';\n')
        
        f.write('    residualControl\n')
        f.write('    {\n')
        f.write('        "(p_rgh|U|k|epsilon)"\n')
        f.write('        {\n')
        f.write('            relTol          0;\n')
        f.write('            tolerance       0.00001;\n')   
        f.write('        }\n')
        f.write('    }\n')
        
        if refpoint==0:
            f.write('    pRefCell                  0;\n')
        else:
            f.write('    pRefPoint                 ('+refx+' '+refy+' '+refz+');\n')
        f.write('    pRefValue                 '+refValue+';\n')
        #f.write('    correctPhi                yes;\n')
        
        #f.write('    rDeltaTSmoothingCoeff     0.05;\n')
        #f.write('    rDeltaTDampingCoeff       0.5;\n')
        #f.write('    nAlphaSpreadIter          0;\n')
        #f.write('    nAlphaSweepIter           0;\n')
        #f.write('    maxDeltaT                 1;\n')
        f.write('}\n')

        f.write('relaxationFactors\n')
        f.write('{\n')
        f.write('    fields\n')
        f.write('    {\n')
        f.write('        "(p|p_rgh)"  '+fvSolutionDict['relaxp']+';\n')
        f.write('        pUrf         0.5;\n')
        f.write('    }\n')
        f.write('    equations\n')
        f.write('    {\n')
        f.write('        "U.*"            '+fvSolutionDict['relaxu']+';\n')
        f.write('        "(k|epsilon|omega|nuTilda).*"  '+fvSolutionDict['relaxtur']+';\n')
        f.write('    }\n')
        f.write('}\n')

        f.close()
    #------------------------------------------------------------------------------                 
