#-*-coding:utf8-*-
#############################################################################
# License                                                                       
#    This file is part of RESOS(RESistance Open Source CFD package).                                            
#
#    RESOS is free software; you can redistribute it and/or modify it
#    under the terms of the GNU General Public License as published by the
#    Free Software Foundation; either version 3 of the License, or (at your
#    option) any later version.
#
#    RESOS is distributed in the hope that it will be useful, but WITHOUT
#    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
#    for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with RESOS.  If not, see <http://www.gnu.org/licenses/>.
#
# Description
#    - Class for run condition free-panel
#
# Author
#    NEXTFOAM Inc. All rights reserved.
##############################################################################

import os,math,sys;import pygtk;pygtk.require('2.0');import gtk;import glob

from generalSub import *
from boundaryConditionSub import *
from writeFileSub import *
from resistance import *

class freepanelRunConditionClass:

    def delete_event(self,widget,event,data=None):
        print 'delete event occurred'
        return False

    def destroy(self,widget,data=None):
        self.Win.destroy()

    def __init__(self,caseDir,mainwindow,installpath):
        self.caseDir=caseDir
        self.mainwindow=mainwindow
        self.installpath=installpath

    def runCondition(self,notebook,textbuffer,terminal):
    
        GEN=generalClass(self.caseDir);RUN=resistanceSolvingClass(self.caseDir,self.installpath,terminal) 
    
        def initialize(widget):
                
            def applythis(widget):
                startfrom=self.startCombo.child.get_text()
                runControlDict=getControl()
                inputDictList=self.collectDicts(runControlDict)
                solver='interNFoam'                    

                message='\n [  Initialize Data....  ]\n'
                enditer=textbuffer.get_end_iter()
                textbuffer.insert(enditer,message)
                                
                RUN.runSolver(inputDictList,solver,'initialize',notebook,textbuffer)

                message='\n    ***     Initialization is completed     ********** \n\n'
                enditer=textbuffer.get_end_iter()
                textbuffer.insert(enditer,message)
                notebook.set_current_page(0)                  
                       
                win.destroy()
                
            def closethis(widget):win.destroy()

            GEN=generalClass(self.caseDir)
            savedResult=GEN.getResult()
            if len(savedResult[0])!=0 or len(savedResult[1])!=0:
                imagefile=self.installpath+'/pic/question.png'                
                win=gtk.Window(gtk.WINDOW_TOPLEVEL);win.set_border_width(5);win.set_position(gtk.WIN_POS_CENTER)
                win.set_title('Warning');win.set_transient_for(self.mainwindow)
                mbox=gtk.VBox(False,0);win.add(mbox)
                frame=gtk.Frame();frame.set_shadow_type(gtk.SHADOW_IN);mbox.pack_start(frame,False,False,5)
                hbox=gtk.HBox(False,5);frame.add(hbox)
                ibox=gtk.VBox(False,5);hbox.pack_start(ibox,False,False,5)
                pic=gtk.Image();pic.set_from_file(imagefile);ibox.pack_start(pic,False,False,0)
                lbox=gtk.HBox(False,5);hbox.pack_start(lbox,False,False,5)            
                label=gtk.Label();label.set_markup(' <b> All the saved data will be deleted. OK? </b> ')            
                lbox.pack_start(label,False,False,5)
                bbox=gtk.HBox(False,5);mbox.pack_start(bbox,False,False,5)
                newB=gtk.Button('Yes');newB.set_size_request(120,28);newB.connect('clicked',applythis)
                clsB=gtk.Button('Cancel');clsB.set_size_request(120,28);clsB.connect('clicked',closethis)
                bbox.pack_end(clsB,False,False,5);bbox.pack_end(newB,False,False,5)		
                win.show_all()
            else:
                startfrom=self.startCombo.child.get_text()
                runControlDict=getControl()
                inputDictList=self.collectDicts(runControlDict)
                solver='interNFoam' 
                
                message='\n [  Initialize Data....  ]\n'
                enditer=textbuffer.get_end_iter()
                textbuffer.insert(enditer,message)
                                 
                RUN.runSolver(inputDictList,solver,'initialize',notebook,textbuffer)                        
                
                message='\n    ***     Initialization is completed     ********** \n\n'
                enditer=textbuffer.get_end_iter()
                textbuffer.insert(enditer,message)
                notebook.set_current_page(0)           
        
        def runPotentialFoam(widget):
            startfrom=self.startCombo.child.get_text()
            self.startCombo.set_active(0)#;GEN.makeDialog('"StartFrom" is temporarily set to "StartTime"') 
            runControlDict=getControl()
            inputDictList=self.collectDicts(runControlDict)
            solver='interNFoam'  
            RUN.runSolver(inputDictList,solver,'potentialFoam',notebook,textbuffer)                        
            textbuffer.insert_at_cursor('\n-- PotentialFoam is completed. \n\n')
            notebook.set_current_page(0)          
            self.startCombo.set_active(1) 
        
        def applyrun(widget):            
            runControlDict=getControl()                       
            inputDictList=self.collectDicts(runControlDict)
            solver='interNFoam'
            RUN.runSolver(inputDictList,solver,'runSolver',notebook,textbuffer)
        
        def getControl():
            runControlDict={}
            runControlDict['startFrom']=self.startCombo.child.get_text()
            runControlDict['startTime']=self.startTimeEntry.get_text()
            runControlDict['endTime']=self.endTimeEntry.get_text()
            runControlDict['timeStepSize']=self.dtEntry.get_text()
            runControlDict['writeInterval']=self.wintervalEntry.get_text()
            runControlDict['purgeWrite']=self.purgeEntry.get_text()
            runControlDict['writePrecision']=self.wprecisionEntry.get_text()
            aa=self.wcontrolCombo.child;runControlDict['writeControl']=aa.get_text()
            aa=self.wformatCombo.child;runControlDict['writeFormat']=aa.get_text()
            if self.compressCheck.get_active()==1:runControlDict['dataCompression']='compressed'
            else:runControlDict['dataCompression']='uncompressed'
            if self.adjustCheck.get_active()==1:runControlDict['adjustTimeStep']='yes'
            else:runControlDict['adjustTimeStep']='no'
            runControlDict['maxCo']=self.maxcoEntry.get_text()
            runControlDict['maxAlphaCo']=self.maxAlphaCoEntry.get_text()
            if self.plotresCheck.get_active()==1:runControlDict['plotResidual']='true'
            else:runControlDict['plotResidual']='false'
            runControlDict['nCores']=self.ncoreEntry.get_text()            
            aa=self.partypeCombo.child;runControlDict['parallelType']=aa.get_text()
            aa=glob.glob(self.caseDir+'/system/settings/hostfilename')
            if len(aa)!=0:
                hh=GEN.makeDictFromFile(aa[0]);runControlDict['hostfile']=hh['hostfile']
            else:runControlDict['hostfile']='None'
            
            #if self.jobCB.get_active()==1:runControlDict['jobScheduler']='true'
            #else:runControlDict['jobScheduler']='false'
            #runControlDict['jobName']=self.jobNameEntry.get_text()
            
            if self.dynamicCB.get_active()==1:runControlDict['dynamicSimulation']='true'
            else:runControlDict['dynamicSimulation']='false'
            
            if GEN.isNumber(runControlDict['startTime'])==False:GEN.makeDialog('Error!!! startTime is not number')            
            if GEN.isNumber(runControlDict['endTime'])==False:GEN.makeDialog('Error!!! endTime is not number')            
            if GEN.isNumber(runControlDict['timeStepSize'])==False:GEN.makeDialog('Error!!! timeStepSize is not number')            
            if GEN.isNumber(runControlDict['writeInterval'])==False:GEN.makeDialog('Error!!! writeInterval is not number')            
            if GEN.isNumber(runControlDict['purgeWrite'])==False:GEN.makeDialog('Error!!! purgeWrite is not number')            
            if GEN.isNumber(runControlDict['writePrecision'])==False:GEN.makeDialog('Error!!! writePrecision is not number')            
            if GEN.isNumber(runControlDict['maxCo'])==False:GEN.makeDialog('Error!!! maxCo is not number')            
            if GEN.isNumber(runControlDict['maxAlphaCo'])==False:GEN.makeDialog('Error!!! maxAlphaCo is not number')            
            if GEN.isNumber(runControlDict['nCores'])==False:GEN.makeDialog('Error!!! nCores is not number')            
            
            keys=runControlDict.keys()
            f=open(self.caseDir+'/system/settings/runConditions','w')
            for ii in keys:f.write(ii+';'+runControlDict[ii]+'\n')
            f.close()
            
            return runControlDict
            
        def setSavedValue():
            aa=glob.glob(self.caseDir+'/system/settings/runConditions')
            if len(aa)!=0:
                GEN=generalClass(self.caseDir);dic=GEN.makeDictFromFile(aa[0])
                if dic['dynamicSimulation']=='true':self.dynamicCB.set_active(1)
                else:self.dynamicCB.set_active(0)
                self.startTimeEntry.set_text(dic['startTime'])
                self.endTimeEntry.set_text(dic['endTime']);self.dtEntry.set_text(dic['timeStepSize'])
                self.wintervalEntry.set_text(dic['writeInterval']);self.purgeEntry.set_text(dic['purgeWrite'])
                self.wprecisionEntry.set_text(dic['writePrecision']);self.wcontrolCombo.set_active(self.wcontrol.index(dic['writeControl']))
                self.wformatCombo.set_active(self.wformat.index(dic['writeFormat']))
                if dic['dataCompression']=='true':self.compressCheck.set_active(1)
                else:self.compressCheck.set_active(0)
                if dic['adjustTimeStep']=='true':self.adjustCheck.set_active(1)
                else:self.adjustCheck.set_active(0)                
                self.maxcoEntry.set_text(dic['maxCo']);self.maxAlphaCoEntry.set_text(dic['maxAlphaCo'])
                if dic['plotResidual']=='true':self.plotresCheck.set_active(1)
                else:self.plotresCheck.set_active(0)  
                self.ncoreEntry.set_text(dic['nCores'])#;self.partypeCombo.set_active(self.partype.index(dic['parallelType']))
                
                #if dic['jobScheduler']=='true':self.jobCB.set_active(1)
                #else:self.jobCB.set_active(0)
                #self.jobNameEntry.set_text(dic['jobName'])
                
        def selhostfile(widget):
            aa=widget.child;partype=aa.get_text()
            if partype=='Cluster':hostfilename=self.selectHostFile() 
            else:hostfilename='None'
            f=open(self.caseDir+'/system/settings/hostfilename','w')
            f.write('hostfile;'+hostfilename+'\n')
            f.close()    
            
        def adjustCheck(widget):
            if widget.get_active==0:self.maxcoEntry.set_sensitive(0);self.maxAlphaCoEntry.set_sensitive(0)
            else:self.maxcoEntry.set_sensitive(1);self.maxAlphaCoEntry.set_sensitive(1)
                                  
        self.runbox=gtk.VBox(False,5)
        label=gtk.Label();label.set_markup('<b>  Run Conditions  </b>')
        ebox=gtk.EventBox();self.runbox.pack_start(ebox,True,True,0)
        label.set_alignment(0,0.5);label.set_size_request(50,45)
        ebox.modify_bg(gtk.STATE_NORMAL,gtk.gdk.color_parse('white'));ebox.add(label) 
                
        self.dynamicCB=gtk.CheckButton('Dynamic Simulation')
        hbox=gtk.HBox(False,5);self.runbox.pack_start(hbox,False,False,2)
        #hbox.pack_start(self.dynamicCB,False,False,2)

        self.startCombo=gtk.combo_box_entry_new_text();self.startCombo.set_size_request(120,28)
        self.startFrom=['startTime','latestTime']  
        for ii in self.startFrom:self.startCombo.append_text(ii)
        self.startCombo.set_active(1)        
        self.startCombo.set_sensitive(0)        

        self.startTimeEntry=gtk.Entry();self.startTimeEntry.set_text('0');self.startTimeEntry.set_size_request(80,28)

        label=gtk.Label('Start time')#;hbox.pack_start(label,False,False,5)
        self.endTimeEntry=gtk.Entry();self.endTimeEntry.set_text('100');self.endTimeEntry.set_size_request(80,28)
        hbox=gtk.HBox(False,5);self.runbox.pack_start(hbox,False,False,2)
        hbox.pack_end(self.endTimeEntry,False,False,2)
        label=gtk.Label('End time');hbox.pack_start(label,False,False,5)
        self.dtEntry=gtk.Entry();self.dtEntry.set_text('0.01');self.dtEntry.set_size_request(80,28)
        hbox=gtk.HBox(False,5);self.runbox.pack_start(hbox,False,False,2)
        hbox.pack_end(self.dtEntry,False,False,2)
        label=gtk.Label('Time step size');hbox.pack_start(label,False,False,5)
        self.wintervalEntry=gtk.Entry();self.wintervalEntry.set_text('1');self.wintervalEntry.set_size_request(80,28)
        hbox=gtk.HBox(False,5);self.runbox.pack_start(hbox,False,False,2)
        hbox.pack_end(self.wintervalEntry,False,False,2)
        label=gtk.Label('Write interval');hbox.pack_start(label,False,False,5)
        self.purgeEntry=gtk.Entry();self.purgeEntry.set_text('10');self.purgeEntry.set_size_request(80,28)
        hbox=gtk.HBox(False,5);self.runbox.pack_start(hbox,False,False,2)
        hbox.pack_end(self.purgeEntry,False,False,2)
        label=gtk.Label('Purge write');hbox.pack_start(label,False,False,5)
        self.wprecisionEntry=gtk.Entry();self.wprecisionEntry.set_text('6');self.wprecisionEntry.set_size_request(80,28)
        hbox=gtk.HBox(False,5);self.runbox.pack_start(hbox,False,False,2)
        hbox.pack_end(self.wprecisionEntry,False,False,2)
        label=gtk.Label('Write precision');hbox.pack_start(label,False,False,5)
        self.wcontrolCombo=gtk.combo_box_entry_new_text();self.wcontrolCombo.set_size_request(120,28)
        self.wcontrol=['timeStep','runTime','adjustableRunTime','clockTime','cpuTime']  
        for ii in self.wcontrol:self.wcontrolCombo.append_text(ii)
        self.wcontrolCombo.set_active(1)
        hbox=gtk.HBox(False,5);self.runbox.pack_start(hbox,False,False,5)
        hbox.pack_end(self.wcontrolCombo,False,False,2)
        label=gtk.Label('Write control');hbox.pack_start(label,False,False,5)
        self.wformatCombo=gtk.combo_box_entry_new_text();self.wformatCombo.set_size_request(120,28)
        self.wformat=['ascii','binary']  
        for ii in self.wformat:self.wformatCombo.append_text(ii)
        self.wformatCombo.set_active(0)
        hbox=gtk.HBox(False,5);self.runbox.pack_start(hbox,False,False,2)
        hbox.pack_end(self.wformatCombo,False,False,2)
        label=gtk.Label('Write format');hbox.pack_start(label,False,False,5)
        self.compressCheck=gtk.CheckButton('Data compression')
        hbox=gtk.HBox(False,5);self.runbox.pack_start(hbox,False,False,2)
        hbox.pack_start(self.compressCheck,False,False,2)
        
        self.adjustCheck=gtk.CheckButton('Adjust time step')
        
        self.adjustCheck.connect('toggled',adjustCheck)
        hbox=gtk.HBox(False,5);self.runbox.pack_start(hbox,False,False,0)
        hbox.pack_start(self.adjustCheck,False,False,2)
        self.maxcoEntry=gtk.Entry();self.maxcoEntry.set_text('50');self.maxcoEntry.set_size_request(80,28)
        hbox=gtk.HBox(False,5);self.runbox.pack_start(hbox,False,False,0)
        hbox.pack_end(self.maxcoEntry,False,False,2)
        label=gtk.Label('maxCo.');hbox.pack_end(label,False,False,5);label.set_size_request(100,28);label.set_alignment(0,0.5)
        self.maxAlphaCoEntry=gtk.Entry();self.maxAlphaCoEntry.set_text('20');self.maxAlphaCoEntry.set_size_request(80,28)
        hbox=gtk.HBox(False,5);self.runbox.pack_start(hbox,False,False,0)
        hbox.pack_end(self.maxAlphaCoEntry,False,False,2)
        
        self.maxcoEntry.set_sensitive(0);self.maxAlphaCoEntry.set_sensitive(0)
        
        label=gtk.Label('maxAlphaCo');hbox.pack_end(label,False,False,5);label.set_size_request(100,28);label.set_alignment(0,0.5)
        self.plotresCheck=gtk.CheckButton('Plot residual')
        hbox=gtk.HBox(False,5);self.runbox.pack_start(hbox,False,False,00)
        label=gtk.Label('');hbox.pack_end(label,False,False,5)
        hbox.pack_start(self.plotresCheck,False,False,2)
        self.plotresCheck.set_active(1)
        self.ncoreEntry=gtk.Entry();self.ncoreEntry.set_text('1');self.ncoreEntry.set_size_request(80,28)
        hbox=gtk.HBox(False,5);self.runbox.pack_start(hbox,False,False,2)
        hbox.pack_end(self.ncoreEntry,False,False,2)
        label=gtk.Label('No. of cores');hbox.pack_start(label,False,False,5)
        self.partypeCombo=gtk.combo_box_entry_new_text();self.partypeCombo.set_size_request(100,28)
        self.partype=['SMP','Cluster']  
        for ii in self.partype:self.partypeCombo.append_text(ii)
        self.partypeCombo.set_active(0)
        #self.partypeCombo.set_sensitive(0)
        self.partypeCombo.connect('changed',selhostfile)
        hbox=gtk.HBox(False,5);self.runbox.pack_start(hbox,False,False,2)
        hbox.pack_end(self.partypeCombo,False,False,2)
        label=gtk.Label('Parallel type');hbox.pack_start(label,False,False,5);label.set_size_request(100,28);label.set_alignment(0,0.5)
        
        #self.jobCB=gtk.CheckButton('Job scheduler');self.jobCB.set_active(1);self.jobCB.connect('toggled',chJobScheduler)
        #self.jobNameEntry=gtk.Entry();self.jobNameEntry.set_size_request(140,28)
        #aa=self.caseDir.split('/');defaultname=aa[-1]
        #self.jobNameEntry.set_text(defaultname)
        #hbox=gtk.HBox(False,5);self.runbox.pack_start(hbox,False,False,2)
        #hbox.pack_start(self.jobCB,False,False,2);hbox.pack_end(self.jobNameEntry,False,False,2)

        hbox=gtk.HBox(False,5);self.runbox.pack_start(hbox,False,False,2)
        self.initializeB=gtk.Button('Initialize');self.initializeB.connect('clicked',initialize);self.initializeB.set_size_request(100,28)
        #self.potentialB=gtk.Button('PotentialFoam');self.potentialB.connect('clicked',runPotentialFoam);self.potentialB.set_size_request(100,28)
        hbox.pack_start(self.initializeB,True,True,2)#;hbox.pack_end(self.potentialB,True,True,2)
        
        hbox=gtk.HBox(False,5);self.runbox.pack_start(hbox,False,False,2)
        self.runAppB=gtk.Button('Start Run');self.runAppB.connect('clicked',applyrun);self.runAppB.set_size_request(100,28)
        hbox.pack_start(self.runAppB,True,True,2)

        setSavedValue()
        
        return self.runbox
    #------------------------------------------------------------------------
    def collectDicts(self,runControlDict):
        
        GEN=generalClass(self.caseDir)
        
        turDict={};propertyDict={};gravityDict={}
        
        aa=glob.glob(self.caseDir+'/system/settings/generalConditions')
        if len(aa)!=0:
            genDict=GEN.makeDictFromFile(aa[0])           
            turDict['RANSModel']=genDict['RANSModel']            
            propertyDict['rhol']=genDict['rhol']
            propertyDict['mul']=genDict['mul']
            propertyDict['rhog']=genDict['rhog']
            propertyDict['mug']=genDict['mug']                    
            gravityDict['gravity']='('+genDict['gx']+' '+genDict['gy']+' '+genDict['gz']+')'
        else:
            turDict['RANSModel']='kEpsilon'
            propertyDict['mug']='1e-5';propertyDict['rhog']='1.225'
            propertyDict['mul']='0.001';propertyDict['rhol']='1000'
            gravityDict['gravity']='(0 0 -9.81)' 

        aa=glob.glob(self.caseDir+'/system/settings/initialConditions')
        if len(aa)!=0:
            initialDict=GEN.makeDictFromFile(aa[0])
        else:
            initialDict={};initialDict['uxini']='0';initialDict['uyini']='0';initialDict['uzini']='0'
            initialDict['pini']='0';initialDict['kini']='1';initialDict['eini']='1';initialDict['alphaini']='0'
            
        aa=glob.glob(self.caseDir+'/system/settings/cellZoneConditions:*')
        cellZoneDictList=[]
        for i in range(len(aa)):
            cellZoneDict=GEN.makeDictFromFile(aa[i])
            if cellZoneDict['cellZoneType']!='None':cellZoneDictList.append(cellZoneDict)

        aa=glob.glob(self.caseDir+'/system/settings/BCDict:*')
        bcDictList=[]
        for i in range(len(aa)):
            bcDict=GEN.makeDictFromFile(aa[i])
            bcDictList.append(bcDict)  
            
        inputDictList=[turDict,propertyDict,initialDict,runControlDict,cellZoneDictList,bcDictList,gravityDict]
       
        return inputDictList
    #------------------------------------------------------------------------
    def selectHostFile(self):
        dialog = gtk.FileChooserDialog("Open..",None,gtk.FILE_CHOOSER_ACTION_OPEN,(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN, gtk.RESPONSE_OK))
        dialog.set_default_response(gtk.RESPONSE_OK)
        response = dialog.run()
        if response == gtk.RESPONSE_OK:hostfilename=dialog.get_filename()
        elif response == gtk.RESPONSE_CANCEL:hostfilename='None'
        dialog.destroy()
        return hostfilename
  
    
    


