// velocity pressure damping
    volScalarField relaxWeight
    (
        IOobject
        (
            "relaxWeight",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::AUTO_WRITE
        ),
        mesh,
        scalar(1)
    );

    volScalarField xcoodi
    (
        IOobject
        (
            "xcoodi",
            runTime.timeName(),
            mesh,
            IOobject::NO_READ,
            IOobject::NO_WRITE
        ),
        mesh,
        scalar(0)
    );

    forAll(mesh.C(), cellI)
    {
        xcoodi.internalField()[cellI] = mesh.C()[cellI][0];
    }

    scalar max_X = gMax(xcoodi.internalField());
    scalar min_X = gMin(xcoodi.internalField());
    
    scalar domainLength = max_X - min_X;
    scalar inletRelax_end = min_X + domainLength * 0.1;
    scalar outletRelax_start = max_X - domainLength * 0.2;

    forAll(mesh.C(), cellI)
    {
        relaxWeight.internalField()[cellI] = 1.00;

        if(mesh.C()[cellI][0] < inletRelax_end  ||  mesh.C()[cellI][0] > outletRelax_start)
        {
            if(alpha1.internalField()[cellI] < SMALL  ||  alpha1.internalField()[cellI] > (1-SMALL))
            {
            relaxWeight.internalField()[cellI] = 0.90;
            }
        }
    }
    relaxWeight.correctBoundaryConditions();

    vector currentU(vector::zero);
    forAll(U.boundaryField(), patchI)
    {
        if(mesh.boundary()[patchI].type() ==  "patch"  &&  U.boundaryField()[patchI].type() == "fixedValue")
        {
            currentU = gAverage(U.boundaryField()[patchI]);
        }
    }
// velocity pressure damping
